#ifndef QPID_AMQP_0_10_COMMANDHOLDER_H
#define QPID_AMQP_0_10_COMMANDHOLDER_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/amqp_0_10/ApplyCommand.h"
#include "qpid/amqp_0_10/Holder.h"

namespace qpid {
namespace amqp_0_10 {


namespace command_max {

template <class M, class X> struct Max
{
    static const size_t max=(M::max > sizeof(X)) ? M::max : sizeof(X);
};
struct Max000 { static const size_t max=0; };
typedef Max<Max000, execution::Sync> Max001;
typedef Max<Max001, execution::Result> Max002;
typedef Max<Max002, execution::Exception> Max003;
typedef Max<Max003, message::Transfer> Max004;
typedef Max<Max004, message::Accept> Max005;
typedef Max<Max005, message::Reject> Max006;
typedef Max<Max006, message::Release> Max007;
typedef Max<Max007, message::Acquire> Max008;
typedef Max<Max008, message::Resume> Max009;
typedef Max<Max009, message::Subscribe> Max010;
typedef Max<Max010, message::Cancel> Max011;
typedef Max<Max011, message::SetFlowMode> Max012;
typedef Max<Max012, message::Flow> Max013;
typedef Max<Max013, message::Flush> Max014;
typedef Max<Max014, message::Stop> Max015;
typedef Max<Max015, tx::Select> Max016;
typedef Max<Max016, tx::Commit> Max017;
typedef Max<Max017, tx::Rollback> Max018;
typedef Max<Max018, dtx::Select> Max019;
typedef Max<Max019, dtx::Start> Max020;
typedef Max<Max020, dtx::End> Max021;
typedef Max<Max021, dtx::Commit> Max022;
typedef Max<Max022, dtx::Forget> Max023;
typedef Max<Max023, dtx::GetTimeout> Max024;
typedef Max<Max024, dtx::Prepare> Max025;
typedef Max<Max025, dtx::Recover> Max026;
typedef Max<Max026, dtx::Rollback> Max027;
typedef Max<Max027, dtx::SetTimeout> Max028;
typedef Max<Max028, exchange::Declare> Max029;
typedef Max<Max029, exchange::Delete> Max030;
typedef Max<Max030, exchange::Query> Max031;
typedef Max<Max031, exchange::Bind> Max032;
typedef Max<Max032, exchange::Unbind> Max033;
typedef Max<Max033, exchange::Bound> Max034;
typedef Max<Max034, queue::Declare> Max035;
typedef Max<Max035, queue::Delete> Max036;
typedef Max<Max036, queue::Purge> Max037;
typedef Max<Max037, queue::Query> Max038;
typedef Max<Max038, file::Qos> Max039;
typedef Max<Max039, file::QosOk> Max040;
typedef Max<Max040, file::Consume> Max041;
typedef Max<Max041, file::ConsumeOk> Max042;
typedef Max<Max042, file::Cancel> Max043;
typedef Max<Max043, file::Open> Max044;
typedef Max<Max044, file::OpenOk> Max045;
typedef Max<Max045, file::Stage> Max046;
typedef Max<Max046, file::Publish> Max047;
typedef Max<Max047, file::Return> Max048;
typedef Max<Max048, file::Deliver> Max049;
typedef Max<Max049, file::Ack> Max050;
typedef Max<Max050, file::Reject> Max051;
typedef Max<Max051, stream::Qos> Max052;
typedef Max<Max052, stream::QosOk> Max053;
typedef Max<Max053, stream::Consume> Max054;
typedef Max<Max054, stream::ConsumeOk> Max055;
typedef Max<Max055, stream::Cancel> Max056;
typedef Max<Max056, stream::Publish> Max057;
typedef Max<Max057, stream::Return> Max058;
typedef Max<Max058, stream::Deliver> Max059;
static const int MAX=Max059::max;

} // namespace command_max

struct CommandHolder:
    public amqp_0_10::Holder<CommandHolder, Command, command_max::MAX>
{
    CommandHolder() {}
    template <class T> explicit CommandHolder(const T& t) : amqp_0_10::Holder<CommandHolder, Command, command_max::MAX>(t) {}
    using amqp_0_10::Holder<CommandHolder, Command, command_max::MAX>::operator=;
    void set(uint8_t classCode, uint8_t code);
};

std::ostream& operator<<(std::ostream& o, const CommandHolder& h);

}} // namespace qpid::amqp_0_10

#endif  /*!QPID_AMQP_0_10_COMMANDHOLDER_H*/
