#ifndef QPID_AMQP_0_10_CONTROLHOLDER_H
#define QPID_AMQP_0_10_CONTROLHOLDER_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/amqp_0_10/ApplyControl.h"
#include "qpid/amqp_0_10/Holder.h"

namespace qpid {
namespace amqp_0_10 {


namespace control_max {

template <class M, class X> struct Max
{
    static const size_t max=(M::max > sizeof(X)) ? M::max : sizeof(X);
};
struct Max000 { static const size_t max=0; };
typedef Max<Max000, connection::Start> Max001;
typedef Max<Max001, connection::StartOk> Max002;
typedef Max<Max002, connection::Secure> Max003;
typedef Max<Max003, connection::SecureOk> Max004;
typedef Max<Max004, connection::Tune> Max005;
typedef Max<Max005, connection::TuneOk> Max006;
typedef Max<Max006, connection::Open> Max007;
typedef Max<Max007, connection::OpenOk> Max008;
typedef Max<Max008, connection::Redirect> Max009;
typedef Max<Max009, connection::Heartbeat> Max010;
typedef Max<Max010, connection::Close> Max011;
typedef Max<Max011, connection::CloseOk> Max012;
typedef Max<Max012, session::Attach> Max013;
typedef Max<Max013, session::Attached> Max014;
typedef Max<Max014, session::Detach> Max015;
typedef Max<Max015, session::Detached> Max016;
typedef Max<Max016, session::RequestTimeout> Max017;
typedef Max<Max017, session::Timeout> Max018;
typedef Max<Max018, session::CommandPoint> Max019;
typedef Max<Max019, session::Expected> Max020;
typedef Max<Max020, session::Confirmed> Max021;
typedef Max<Max021, session::Completed> Max022;
typedef Max<Max022, session::KnownCompleted> Max023;
typedef Max<Max023, session::Flush> Max024;
typedef Max<Max024, session::Gap> Max025;
static const int MAX=Max025::max;

} // namespace control_max

struct ControlHolder:
    public amqp_0_10::Holder<ControlHolder, Control, control_max::MAX>
{
    ControlHolder() {}
    template <class T> explicit ControlHolder(const T& t) : amqp_0_10::Holder<ControlHolder, Control, control_max::MAX>(t) {}
    using amqp_0_10::Holder<ControlHolder, Control, control_max::MAX>::operator=;
    void set(uint8_t classCode, uint8_t code);
};

std::ostream& operator<<(std::ostream& o, const ControlHolder& h);

}} // namespace qpid::amqp_0_10

#endif  /*!QPID_AMQP_0_10_CONTROLHOLDER_H*/
