#ifndef QPID_AMQP_0_10_PROXYTEMPLATE_H
#define QPID_AMQP_0_10_PROXYTEMPLATE_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/amqp_0_10/specification.h"

namespace qpid {
namespace amqp_0_10 {

template <class F, class R=typename F::result_type>
class ProxyTemplate
{
  public:
    ProxyTemplate(F f=F()) : functor(f) {}
    
    
    R connectionStart(
        call_traits<Map>::param_type serverProperties_,
        call_traits<Str16Array>::param_type mechanisms_,
        call_traits<Str16Array>::param_type locales_
    )
    {
        connection::Start start(serverProperties_, mechanisms_, locales_);
        return functor(start);
    }
    
    
    R connectionStartOk(
        call_traits<Map>::param_type clientProperties_,
        call_traits<Str8>::param_type mechanism_,
        call_traits<Vbin32>::param_type response_,
        call_traits<Str8>::param_type locale_
    )
    {
        connection::StartOk startOk(clientProperties_, mechanism_, response_, locale_);
        return functor(startOk);
    }
    
    
    R connectionSecure(call_traits<Vbin32>::param_type challenge_)
    {
        connection::Secure secure(challenge_);
        return functor(secure);
    }
    
    
    R connectionSecureOk(call_traits<Vbin32>::param_type response_)
    {
        connection::SecureOk secureOk(response_);
        return functor(secureOk);
    }
    
    
    R connectionTune(
        call_traits<Uint16>::param_type channelMax_,
        call_traits<Uint16>::param_type maxFrameSize_,
        call_traits<Uint16>::param_type heartbeatMin_,
        call_traits<Uint16>::param_type heartbeatMax_
    )
    {
        connection::Tune tune(channelMax_, maxFrameSize_, heartbeatMin_, heartbeatMax_);
        return functor(tune);
    }
    
    
    R connectionTuneOk(
        call_traits<Uint16>::param_type channelMax_,
        call_traits<Uint16>::param_type maxFrameSize_,
        call_traits<Uint16>::param_type heartbeat_
    )
    {
        connection::TuneOk tuneOk(channelMax_, maxFrameSize_, heartbeat_);
        return functor(tuneOk);
    }
    
    
    R connectionOpen(
        call_traits<Str8>::param_type virtualHost_,
        call_traits<Str16Array>::param_type capabilities_,
        call_traits<Bit>::param_type insist_
    )
    {
        connection::Open open(virtualHost_, capabilities_, insist_);
        return functor(open);
    }
    
    
    R connectionOpenOk(call_traits<connection::AmqpHostArray>::param_type knownHosts_)
    {
        connection::OpenOk openOk(knownHosts_);
        return functor(openOk);
    }
    
    
    R connectionRedirect(
        call_traits<connection::AmqpHostUrl>::param_type host_,
        call_traits<connection::AmqpHostArray>::param_type knownHosts_
    )
    {
        connection::Redirect redirect(host_, knownHosts_);
        return functor(redirect);
    }
    
    
    R connectionHeartbeat()
    {
        connection::Heartbeat heartbeat;
        return functor(heartbeat);
    }
    
    
    R connectionClose(
        call_traits<connection::CloseCode>::param_type replyCode_,
        call_traits<Str8>::param_type replyText_
    )
    {
        connection::Close close(replyCode_, replyText_);
        return functor(close);
    }
    
    
    R connectionCloseOk()
    {
        connection::CloseOk closeOk;
        return functor(closeOk);
    }
    
    
    R sessionAttach(
        call_traits<session::Name>::param_type name_,
        call_traits<Bit>::param_type force_
    )
    {
        session::Attach attach(name_, force_);
        return functor(attach);
    }
    
    
    R sessionAttached(call_traits<session::Name>::param_type name_)
    {
        session::Attached attached(name_);
        return functor(attached);
    }
    
    
    R sessionDetach(call_traits<session::Name>::param_type name_)
    {
        session::Detach detach(name_);
        return functor(detach);
    }
    
    
    R sessionDetached(
        call_traits<session::Name>::param_type name_,
        call_traits<session::DetachCode>::param_type code_
    )
    {
        session::Detached detached(name_, code_);
        return functor(detached);
    }
    
    
    R sessionRequestTimeout(call_traits<Uint32>::param_type timeout_)
    {
        session::RequestTimeout requestTimeout(timeout_);
        return functor(requestTimeout);
    }
    
    
    R sessionTimeout(call_traits<Uint32>::param_type timeout_)
    {
        session::Timeout timeout(timeout_);
        return functor(timeout);
    }
    
    
    R sessionCommandPoint(
        call_traits<SequenceNo>::param_type commandId_,
        call_traits<Uint64>::param_type commandOffset_
    )
    {
        session::CommandPoint commandPoint(commandId_, commandOffset_);
        return functor(commandPoint);
    }
    
    
    R sessionExpected(
        call_traits<session::Commands>::param_type commands_,
        call_traits<session::CommandFragments>::param_type fragments_
    )
    {
        session::Expected expected(commands_, fragments_);
        return functor(expected);
    }
    
    
    R sessionConfirmed(
        call_traits<session::Commands>::param_type commands_,
        call_traits<session::CommandFragments>::param_type fragments_
    )
    {
        session::Confirmed confirmed(commands_, fragments_);
        return functor(confirmed);
    }
    
    
    R sessionCompleted(
        call_traits<session::Commands>::param_type commands_,
        call_traits<Bit>::param_type timelyReply_
    )
    {
        session::Completed completed(commands_, timelyReply_);
        return functor(completed);
    }
    
    
    R sessionKnownCompleted(call_traits<session::Commands>::param_type commands_)
    {
        session::KnownCompleted knownCompleted(commands_);
        return functor(knownCompleted);
    }
    
    
    R sessionFlush(
        call_traits<Bit>::param_type expected_,
        call_traits<Bit>::param_type confirmed_,
        call_traits<Bit>::param_type completed_
    )
    {
        session::Flush flush(expected_, confirmed_, completed_);
        return functor(flush);
    }
    
    
    R sessionGap(call_traits<session::Commands>::param_type commands_)
    {
        session::Gap gap(commands_);
        return functor(gap);
    }
    
    
    R executionSync()
    {
        execution::Sync sync;
        return functor(sync);
    }
    
    
    R executionResult(
        call_traits<SequenceNo>::param_type commandId_,
        call_traits<Struct32>::param_type value_
    )
    {
        execution::Result result(commandId_, value_);
        return functor(result);
    }
    
    
    R executionException(
        call_traits<execution::ErrorCode>::param_type errorCode_,
        call_traits<SequenceNo>::param_type commandId_,
        call_traits<Uint8>::param_type classCode_,
        call_traits<Uint8>::param_type commandCode_,
        call_traits<Uint8>::param_type fieldIndex_,
        call_traits<Str16>::param_type description_,
        call_traits<Map>::param_type errorInfo_
    )
    {
        execution::Exception exception(errorCode_, commandId_, classCode_, commandCode_, fieldIndex_, description_, errorInfo_);
        return functor(exception);
    }
    
    
    R messageTransfer(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::AcceptMode>::param_type acceptMode_,
        call_traits<message::AcquireMode>::param_type acquireMode_
    )
    {
        message::Transfer transfer(destination_, acceptMode_, acquireMode_);
        return functor(transfer);
    }
    
    
    R messageAccept(call_traits<session::Commands>::param_type transfers_)
    {
        message::Accept accept(transfers_);
        return functor(accept);
    }
    
    
    R messageReject(
        call_traits<session::Commands>::param_type transfers_,
        call_traits<message::RejectCode>::param_type code_,
        call_traits<Str8>::param_type text_
    )
    {
        message::Reject reject(transfers_, code_, text_);
        return functor(reject);
    }
    
    
    R messageRelease(
        call_traits<session::Commands>::param_type transfers_,
        call_traits<Bit>::param_type setRedelivered_
    )
    {
        message::Release release(transfers_, setRedelivered_);
        return functor(release);
    }
    
    
    R messageAcquire(call_traits<session::Commands>::param_type transfers_)
    {
        message::Acquire acquire(transfers_);
        return functor(acquire);
    }
    
    
    R messageResume(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::ResumeId>::param_type resumeId_
    )
    {
        message::Resume resume(destination_, resumeId_);
        return functor(resume);
    }
    
    
    R messageSubscribe(
        call_traits<queue::Name>::param_type queue_,
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::AcceptMode>::param_type acceptMode_,
        call_traits<message::AcquireMode>::param_type acquireMode_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<message::ResumeId>::param_type resumeId_,
        call_traits<Uint64>::param_type resumeTtl_,
        call_traits<Map>::param_type arguments_
    )
    {
        message::Subscribe subscribe(queue_, destination_, acceptMode_, acquireMode_, exclusive_, resumeId_, resumeTtl_, arguments_);
        return functor(subscribe);
    }
    
    
    R messageCancel(call_traits<message::Destination>::param_type destination_)
    {
        message::Cancel cancel(destination_);
        return functor(cancel);
    }
    
    
    R messageSetFlowMode(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::FlowMode>::param_type flowMode_
    )
    {
        message::SetFlowMode setFlowMode(destination_, flowMode_);
        return functor(setFlowMode);
    }
    
    
    R messageFlow(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::CreditUnit>::param_type unit_,
        call_traits<Uint32>::param_type value_
    )
    {
        message::Flow flow(destination_, unit_, value_);
        return functor(flow);
    }
    
    
    R messageFlush(call_traits<message::Destination>::param_type destination_)
    {
        message::Flush flush(destination_);
        return functor(flush);
    }
    
    
    R messageStop(call_traits<message::Destination>::param_type destination_)
    {
        message::Stop stop(destination_);
        return functor(stop);
    }
    
    
    R txSelect()
    {
        tx::Select select;
        return functor(select);
    }
    
    
    R txCommit()
    {
        tx::Commit commit;
        return functor(commit);
    }
    
    
    R txRollback()
    {
        tx::Rollback rollback;
        return functor(rollback);
    }
    
    
    R dtxSelect()
    {
        dtx::Select select;
        return functor(select);
    }
    
    
    R dtxStart(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Bit>::param_type join_,
        call_traits<Bit>::param_type resume_
    )
    {
        dtx::Start start(xid_, join_, resume_);
        return functor(start);
    }
    
    
    R dtxEnd(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Bit>::param_type fail_,
        call_traits<Bit>::param_type suspend_
    )
    {
        dtx::End end(xid_, fail_, suspend_);
        return functor(end);
    }
    
    
    R dtxCommit(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Bit>::param_type onePhase_
    )
    {
        dtx::Commit commit(xid_, onePhase_);
        return functor(commit);
    }
    
    
    R dtxForget(call_traits<dtx::Xid>::param_type xid_)
    {
        dtx::Forget forget(xid_);
        return functor(forget);
    }
    
    
    R dtxGetTimeout(call_traits<dtx::Xid>::param_type xid_)
    {
        dtx::GetTimeout getTimeout(xid_);
        return functor(getTimeout);
    }
    
    
    R dtxPrepare(call_traits<dtx::Xid>::param_type xid_)
    {
        dtx::Prepare prepare(xid_);
        return functor(prepare);
    }
    
    
    R dtxRecover()
    {
        dtx::Recover recover;
        return functor(recover);
    }
    
    
    R dtxRollback(call_traits<dtx::Xid>::param_type xid_)
    {
        dtx::Rollback rollback(xid_);
        return functor(rollback);
    }
    
    
    R dtxSetTimeout(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Uint32>::param_type timeout_
    )
    {
        dtx::SetTimeout setTimeout(xid_, timeout_);
        return functor(setTimeout);
    }
    
    
    R exchangeDeclare(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type type_,
        call_traits<exchange::Name>::param_type alternateExchange_,
        call_traits<Bit>::param_type passive_,
        call_traits<Bit>::param_type durable_,
        call_traits<Bit>::param_type autoDelete_,
        call_traits<Map>::param_type arguments_
    )
    {
        exchange::Declare declare(exchange_, type_, alternateExchange_, passive_, durable_, autoDelete_, arguments_);
        return functor(declare);
    }
    
    
    R exchangeDelete(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Bit>::param_type ifUnused_
    )
    {
        exchange::Delete delete_(exchange_, ifUnused_);
        return functor(delete_);
    }
    
    
    R exchangeQuery(call_traits<Str8>::param_type name_)
    {
        exchange::Query query(name_);
        return functor(query);
    }
    
    
    R exchangeBind(
        call_traits<queue::Name>::param_type queue_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type bindingKey_,
        call_traits<Map>::param_type arguments_
    )
    {
        exchange::Bind bind(queue_, exchange_, bindingKey_, arguments_);
        return functor(bind);
    }
    
    
    R exchangeUnbind(
        call_traits<queue::Name>::param_type queue_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type bindingKey_
    )
    {
        exchange::Unbind unbind(queue_, exchange_, bindingKey_);
        return functor(unbind);
    }
    
    
    R exchangeBound(
        call_traits<Str8>::param_type exchange_,
        call_traits<Str8>::param_type queue_,
        call_traits<Str8>::param_type bindingKey_,
        call_traits<Map>::param_type arguments_
    )
    {
        exchange::Bound bound(exchange_, queue_, bindingKey_, arguments_);
        return functor(bound);
    }
    
    
    R queueDeclare(
        call_traits<queue::Name>::param_type queue_,
        call_traits<exchange::Name>::param_type alternateExchange_,
        call_traits<Bit>::param_type passive_,
        call_traits<Bit>::param_type durable_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<Bit>::param_type autoDelete_,
        call_traits<Map>::param_type arguments_
    )
    {
        queue::Declare declare(queue_, alternateExchange_, passive_, durable_, exclusive_, autoDelete_, arguments_);
        return functor(declare);
    }
    
    
    R queueDelete(
        call_traits<queue::Name>::param_type queue_,
        call_traits<Bit>::param_type ifUnused_,
        call_traits<Bit>::param_type ifEmpty_
    )
    {
        queue::Delete delete_(queue_, ifUnused_, ifEmpty_);
        return functor(delete_);
    }
    
    
    R queuePurge(call_traits<queue::Name>::param_type queue_)
    {
        queue::Purge purge(queue_);
        return functor(purge);
    }
    
    
    R queueQuery(call_traits<queue::Name>::param_type queue_)
    {
        queue::Query query(queue_);
        return functor(query);
    }
    
    
    R fileQos(
        call_traits<Uint32>::param_type prefetchSize_,
        call_traits<Uint16>::param_type prefetchCount_,
        call_traits<Bit>::param_type global_
    )
    {
        file::Qos qos(prefetchSize_, prefetchCount_, global_);
        return functor(qos);
    }
    
    
    R fileQosOk()
    {
        file::QosOk qosOk;
        return functor(qosOk);
    }
    
    
    R fileConsume(
        call_traits<queue::Name>::param_type queue_,
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Bit>::param_type noLocal_,
        call_traits<Bit>::param_type noAck_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<Bit>::param_type nowait_,
        call_traits<Map>::param_type arguments_
    )
    {
        file::Consume consume(queue_, consumerTag_, noLocal_, noAck_, exclusive_, nowait_, arguments_);
        return functor(consume);
    }
    
    
    R fileConsumeOk(call_traits<Str8>::param_type consumerTag_)
    {
        file::ConsumeOk consumeOk(consumerTag_);
        return functor(consumeOk);
    }
    
    
    R fileCancel(call_traits<Str8>::param_type consumerTag_)
    {
        file::Cancel cancel(consumerTag_);
        return functor(cancel);
    }
    
    
    R fileOpen(
        call_traits<Str8>::param_type identifier_,
        call_traits<Uint64>::param_type contentSize_
    )
    {
        file::Open open(identifier_, contentSize_);
        return functor(open);
    }
    
    
    R fileOpenOk(call_traits<Uint64>::param_type stagedSize_)
    {
        file::OpenOk openOk(stagedSize_);
        return functor(openOk);
    }
    
    
    R fileStage()
    {
        file::Stage stage;
        return functor(stage);
    }
    
    
    R filePublish(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_,
        call_traits<Bit>::param_type mandatory_,
        call_traits<Bit>::param_type immediate_,
        call_traits<Str8>::param_type identifier_
    )
    {
        file::Publish publish(exchange_, routingKey_, mandatory_, immediate_, identifier_);
        return functor(publish);
    }
    
    
    R fileReturn(
        call_traits<file::ReturnCode>::param_type replyCode_,
        call_traits<Str8>::param_type replyText_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_
    )
    {
        file::Return return_(replyCode_, replyText_, exchange_, routingKey_);
        return functor(return_);
    }
    
    
    R fileDeliver(
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<Bit>::param_type redelivered_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_,
        call_traits<Str8>::param_type identifier_
    )
    {
        file::Deliver deliver(consumerTag_, deliveryTag_, redelivered_, exchange_, routingKey_, identifier_);
        return functor(deliver);
    }
    
    
    R fileAck(
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<Bit>::param_type multiple_
    )
    {
        file::Ack ack(deliveryTag_, multiple_);
        return functor(ack);
    }
    
    
    R fileReject(
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<Bit>::param_type requeue_
    )
    {
        file::Reject reject(deliveryTag_, requeue_);
        return functor(reject);
    }
    
    
    R streamQos(
        call_traits<Uint32>::param_type prefetchSize_,
        call_traits<Uint16>::param_type prefetchCount_,
        call_traits<Uint32>::param_type consumeRate_,
        call_traits<Bit>::param_type global_
    )
    {
        stream::Qos qos(prefetchSize_, prefetchCount_, consumeRate_, global_);
        return functor(qos);
    }
    
    
    R streamQosOk()
    {
        stream::QosOk qosOk;
        return functor(qosOk);
    }
    
    
    R streamConsume(
        call_traits<queue::Name>::param_type queue_,
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Bit>::param_type noLocal_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<Bit>::param_type nowait_,
        call_traits<Map>::param_type arguments_
    )
    {
        stream::Consume consume(queue_, consumerTag_, noLocal_, exclusive_, nowait_, arguments_);
        return functor(consume);
    }
    
    
    R streamConsumeOk(call_traits<Str8>::param_type consumerTag_)
    {
        stream::ConsumeOk consumeOk(consumerTag_);
        return functor(consumeOk);
    }
    
    
    R streamCancel(call_traits<Str8>::param_type consumerTag_)
    {
        stream::Cancel cancel(consumerTag_);
        return functor(cancel);
    }
    
    
    R streamPublish(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_,
        call_traits<Bit>::param_type mandatory_,
        call_traits<Bit>::param_type immediate_
    )
    {
        stream::Publish publish(exchange_, routingKey_, mandatory_, immediate_);
        return functor(publish);
    }
    
    
    R streamReturn(
        call_traits<stream::ReturnCode>::param_type replyCode_,
        call_traits<Str8>::param_type replyText_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_
    )
    {
        stream::Return return_(replyCode_, replyText_, exchange_, routingKey_);
        return functor(return_);
    }
    
    
    R streamDeliver(
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<queue::Name>::param_type queue_
    )
    {
        stream::Deliver deliver(consumerTag_, deliveryTag_, exchange_, queue_);
        return functor(deliver);
    }
  private:
    F functor;
};

}} // namespace qpid::amqp_0_10

#endif  /*!QPID_AMQP_0_10_PROXYTEMPLATE_H*/
