#ifndef QPID_AMQP_0_10_SPECIFICATION_H
#define QPID_AMQP_0_10_SPECIFICATION_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/amqp_0_10/specification_fwd.h"
#include "qpid/amqp_0_10/all_built_in_types.h"
#include "qpid/amqp_0_10/Packer.h"
#include <boost/call_traits.hpp>
#include <iosfwd>
using boost::call_traits;

namespace qpid {
namespace amqp_0_10 {


namespace connection {


} // namespace connection


namespace session {


struct CommandFragment:
    public Struct
{
    SequenceNo commandId;
    ByteRanges byteRanges;
    
    static const char* NAME;
    static const uint8_t SIZE=0;
    static const uint8_t PACK=0;
    static const uint8_t CODE=0;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    CommandFragment();
    CommandFragment(
        call_traits<SequenceNo>::param_type commandId_,
        call_traits<ByteRanges>::param_type byteRanges_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commandId)(byteRanges);
    }
    
};
std::ostream& operator << (std::ostream&, const CommandFragment&);
bool operator==(const CommandFragment&, const CommandFragment&);

} // namespace session


namespace execution {


} // namespace execution


namespace message {


} // namespace message


namespace tx {


} // namespace tx


namespace dtx {


} // namespace dtx


namespace exchange {


} // namespace exchange


namespace queue {


} // namespace queue


namespace file {


} // namespace file


namespace stream {


} // namespace stream


namespace connection {


struct Start:
    public Control
{
    Map serverProperties;
    Str16Array mechanisms;
    Str16Array locales;
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    Start();
    Start(
        call_traits<Map>::param_type serverProperties_,
        call_traits<Str16Array>::param_type mechanisms_,
        call_traits<Str16Array>::param_type locales_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(serverProperties)(mechanisms)(locales);
    }
    
    struct Handler
    {
        void connectionStart(
            call_traits<Map>::param_type serverProperties_,
            call_traits<Str16Array>::param_type mechanisms_,
            call_traits<Str16Array>::param_type locales_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionStart(serverProperties, mechanisms, locales );
    }
};
inline Packer<Start> serializable(Start& x) { return Packer<Start>(x); }
std::ostream& operator << (std::ostream&, const Start&);
bool operator==(const Start&, const Start&);

struct StartOk:
    public Control
{
    Map clientProperties;
    Str8 mechanism;
    Vbin32 response;
    Str8 locale;
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    StartOk();
    StartOk(
        call_traits<Map>::param_type clientProperties_,
        call_traits<Str8>::param_type mechanism_,
        call_traits<Vbin32>::param_type response_,
        call_traits<Str8>::param_type locale_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(clientProperties)(mechanism)(response)(locale);
    }
    
    struct Handler
    {
        void connectionStartOk(
            call_traits<Map>::param_type clientProperties_,
            call_traits<Str8>::param_type mechanism_,
            call_traits<Vbin32>::param_type response_,
            call_traits<Str8>::param_type locale_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionStartOk(clientProperties, mechanism, response, locale );
    }
};
inline Packer<StartOk> serializable(StartOk& x) { return Packer<StartOk>(x); }
std::ostream& operator << (std::ostream&, const StartOk&);
bool operator==(const StartOk&, const StartOk&);

struct Secure:
    public Control
{
    Vbin32 challenge;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    Secure();
    Secure(call_traits<Vbin32>::param_type challenge_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(challenge);
    }
    
    struct Handler
    {
        void connectionSecure(
            call_traits<Vbin32>::param_type challenge_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionSecure(challenge );
    }
};
inline Packer<Secure> serializable(Secure& x) { return Packer<Secure>(x); }
std::ostream& operator << (std::ostream&, const Secure&);
bool operator==(const Secure&, const Secure&);

struct SecureOk:
    public Control
{
    Vbin32 response;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    SecureOk();
    SecureOk(call_traits<Vbin32>::param_type response_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(response);
    }
    
    struct Handler
    {
        void connectionSecureOk(
            call_traits<Vbin32>::param_type response_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionSecureOk(response );
    }
};
inline Packer<SecureOk> serializable(SecureOk& x) { return Packer<SecureOk>(x); }
std::ostream& operator << (std::ostream&, const SecureOk&);
bool operator==(const SecureOk&, const SecureOk&);

struct Tune:
    public Control
{
    Uint16 channelMax;
    Uint16 maxFrameSize;
    Uint16 heartbeatMin;
    Uint16 heartbeatMax;
    
    static const char* NAME;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    Tune();
    Tune(
        call_traits<Uint16>::param_type channelMax_,
        call_traits<Uint16>::param_type maxFrameSize_,
        call_traits<Uint16>::param_type heartbeatMin_,
        call_traits<Uint16>::param_type heartbeatMax_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(channelMax)(maxFrameSize)(heartbeatMin)(heartbeatMax);
    }
    
    struct Handler
    {
        void connectionTune(
            call_traits<Uint16>::param_type channelMax_,
            call_traits<Uint16>::param_type maxFrameSize_,
            call_traits<Uint16>::param_type heartbeatMin_,
            call_traits<Uint16>::param_type heartbeatMax_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionTune(channelMax, maxFrameSize, heartbeatMin, heartbeatMax );
    }
};
inline Packer<Tune> serializable(Tune& x) { return Packer<Tune>(x); }
std::ostream& operator << (std::ostream&, const Tune&);
bool operator==(const Tune&, const Tune&);

struct TuneOk:
    public Control
{
    Uint16 channelMax;
    Uint16 maxFrameSize;
    Uint16 heartbeat;
    
    static const char* NAME;
    static const uint8_t CODE=0x6;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    TuneOk();
    TuneOk(
        call_traits<Uint16>::param_type channelMax_,
        call_traits<Uint16>::param_type maxFrameSize_,
        call_traits<Uint16>::param_type heartbeat_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(channelMax)(maxFrameSize)(heartbeat);
    }
    
    struct Handler
    {
        void connectionTuneOk(
            call_traits<Uint16>::param_type channelMax_,
            call_traits<Uint16>::param_type maxFrameSize_,
            call_traits<Uint16>::param_type heartbeat_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionTuneOk(channelMax, maxFrameSize, heartbeat );
    }
};
inline Packer<TuneOk> serializable(TuneOk& x) { return Packer<TuneOk>(x); }
std::ostream& operator << (std::ostream&, const TuneOk&);
bool operator==(const TuneOk&, const TuneOk&);

struct Open:
    public Control
{
    Str8 virtualHost;
    Str16Array capabilities;
    Bit insist;
    
    static const char* NAME;
    static const uint8_t CODE=0x7;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    Open();
    Open(
        call_traits<Str8>::param_type virtualHost_,
        call_traits<Str16Array>::param_type capabilities_,
        call_traits<Bit>::param_type insist_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(virtualHost)(capabilities)(insist);
    }
    
    struct Handler
    {
        void connectionOpen(
            call_traits<Str8>::param_type virtualHost_,
            call_traits<Str16Array>::param_type capabilities_,
            call_traits<Bit>::param_type insist_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionOpen(virtualHost, capabilities, insist );
    }
};
inline Packer<Open> serializable(Open& x) { return Packer<Open>(x); }
std::ostream& operator << (std::ostream&, const Open&);
bool operator==(const Open&, const Open&);

struct OpenOk:
    public Control
{
    AmqpHostArray knownHosts;
    
    static const char* NAME;
    static const uint8_t CODE=0x8;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    OpenOk();
    OpenOk(call_traits<connection::AmqpHostArray>::param_type knownHosts_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(knownHosts);
    }
    
    struct Handler
    {
        void connectionOpenOk(
            call_traits<connection::AmqpHostArray>::param_type knownHosts_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionOpenOk(knownHosts );
    }
};
inline Packer<OpenOk> serializable(OpenOk& x) { return Packer<OpenOk>(x); }
std::ostream& operator << (std::ostream&, const OpenOk&);
bool operator==(const OpenOk&, const OpenOk&);

struct Redirect:
    public Control
{
    AmqpHostUrl host;
    AmqpHostArray knownHosts;
    
    static const char* NAME;
    static const uint8_t CODE=0x9;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    Redirect();
    Redirect(
        call_traits<connection::AmqpHostUrl>::param_type host_,
        call_traits<connection::AmqpHostArray>::param_type knownHosts_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(host)(knownHosts);
    }
    
    struct Handler
    {
        void connectionRedirect(
            call_traits<connection::AmqpHostUrl>::param_type host_,
            call_traits<connection::AmqpHostArray>::param_type knownHosts_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionRedirect(host, knownHosts );
    }
};
inline Packer<Redirect> serializable(Redirect& x) { return Packer<Redirect>(x); }
std::ostream& operator << (std::ostream&, const Redirect&);
bool operator==(const Redirect&, const Redirect&);

struct Heartbeat:
    public Control
{
    
    static const char* NAME;
    static const uint8_t CODE=0xa;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    Heartbeat();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void connectionHeartbeat(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionHeartbeat( );
    }
};
inline Packer<Heartbeat> serializable(Heartbeat& x) { return Packer<Heartbeat>(x); }
std::ostream& operator << (std::ostream&, const Heartbeat&);
bool operator==(const Heartbeat&, const Heartbeat&);

struct Close:
    public Control
{
    CloseCode replyCode;
    Str8 replyText;
    
    static const char* NAME;
    static const uint8_t CODE=0xb;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    Close();
    Close(
        call_traits<connection::CloseCode>::param_type replyCode_,
        call_traits<Str8>::param_type replyText_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(replyCode)(replyText);
    }
    
    struct Handler
    {
        void connectionClose(
            call_traits<connection::CloseCode>::param_type replyCode_,
            call_traits<Str8>::param_type replyText_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionClose(replyCode, replyText );
    }
};
inline Packer<Close> serializable(Close& x) { return Packer<Close>(x); }
std::ostream& operator << (std::ostream&, const Close&);
bool operator==(const Close&, const Close&);

struct CloseOk:
    public Control
{
    
    static const char* NAME;
    static const uint8_t CODE=0xc;
    static const uint8_t CLASS_CODE=connection::CODE;
    static const char* CLASS_NAME;
    CloseOk();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void connectionCloseOk(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.connectionCloseOk( );
    }
};
inline Packer<CloseOk> serializable(CloseOk& x) { return Packer<CloseOk>(x); }
std::ostream& operator << (std::ostream&, const CloseOk&);
bool operator==(const CloseOk&, const CloseOk&);

} // namespace connection


namespace session {


struct Header:
    public Struct
{
    Bit sync;
    
    static const char* NAME;
    static const uint8_t SIZE=1;
    static const uint8_t PACK=1;
    static const uint8_t CODE=0;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Header();
    Header(call_traits<Bit>::param_type sync_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(sync);
    }
    
};
inline Packer<Header> serializable(Header& x) { return Packer<Header>(x); }
std::ostream& operator << (std::ostream&, const Header&);
bool operator==(const Header&, const Header&);

struct Attach:
    public Control
{
    Name name;
    Bit force;
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Attach();
    Attach(
        call_traits<session::Name>::param_type name_,
        call_traits<Bit>::param_type force_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(name)(force);
    }
    
    struct Handler
    {
        void sessionAttach(
            call_traits<session::Name>::param_type name_,
            call_traits<Bit>::param_type force_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionAttach(name, force );
    }
};
inline Packer<Attach> serializable(Attach& x) { return Packer<Attach>(x); }
std::ostream& operator << (std::ostream&, const Attach&);
bool operator==(const Attach&, const Attach&);

struct Attached:
    public Control
{
    Name name;
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Attached();
    Attached(call_traits<session::Name>::param_type name_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(name);
    }
    
    struct Handler
    {
        void sessionAttached(
            call_traits<session::Name>::param_type name_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionAttached(name );
    }
};
inline Packer<Attached> serializable(Attached& x) { return Packer<Attached>(x); }
std::ostream& operator << (std::ostream&, const Attached&);
bool operator==(const Attached&, const Attached&);

struct Detach:
    public Control
{
    Name name;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Detach();
    Detach(call_traits<session::Name>::param_type name_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(name);
    }
    
    struct Handler
    {
        void sessionDetach(
            call_traits<session::Name>::param_type name_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionDetach(name );
    }
};
inline Packer<Detach> serializable(Detach& x) { return Packer<Detach>(x); }
std::ostream& operator << (std::ostream&, const Detach&);
bool operator==(const Detach&, const Detach&);

struct Detached:
    public Control
{
    Name name;
    DetachCode code;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Detached();
    Detached(
        call_traits<session::Name>::param_type name_,
        call_traits<session::DetachCode>::param_type code_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(name)(code);
    }
    
    struct Handler
    {
        void sessionDetached(
            call_traits<session::Name>::param_type name_,
            call_traits<session::DetachCode>::param_type code_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionDetached(name, code );
    }
};
inline Packer<Detached> serializable(Detached& x) { return Packer<Detached>(x); }
std::ostream& operator << (std::ostream&, const Detached&);
bool operator==(const Detached&, const Detached&);

struct RequestTimeout:
    public Control
{
    Uint32 timeout;
    
    static const char* NAME;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    RequestTimeout();
    RequestTimeout(call_traits<Uint32>::param_type timeout_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(timeout);
    }
    
    struct Handler
    {
        void sessionRequestTimeout(
            call_traits<Uint32>::param_type timeout_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionRequestTimeout(timeout );
    }
};
inline Packer<RequestTimeout> serializable(RequestTimeout& x) { return Packer<RequestTimeout>(x); }
std::ostream& operator << (std::ostream&, const RequestTimeout&);
bool operator==(const RequestTimeout&, const RequestTimeout&);

struct Timeout:
    public Control
{
    Uint32 timeout;
    
    static const char* NAME;
    static const uint8_t CODE=0x6;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Timeout();
    Timeout(call_traits<Uint32>::param_type timeout_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(timeout);
    }
    
    struct Handler
    {
        void sessionTimeout(
            call_traits<Uint32>::param_type timeout_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionTimeout(timeout );
    }
};
inline Packer<Timeout> serializable(Timeout& x) { return Packer<Timeout>(x); }
std::ostream& operator << (std::ostream&, const Timeout&);
bool operator==(const Timeout&, const Timeout&);

struct CommandPoint:
    public Control
{
    SequenceNo commandId;
    Uint64 commandOffset;
    
    static const char* NAME;
    static const uint8_t CODE=0x7;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    CommandPoint();
    CommandPoint(
        call_traits<SequenceNo>::param_type commandId_,
        call_traits<Uint64>::param_type commandOffset_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commandId)(commandOffset);
    }
    
    struct Handler
    {
        void sessionCommandPoint(
            call_traits<SequenceNo>::param_type commandId_,
            call_traits<Uint64>::param_type commandOffset_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionCommandPoint(commandId, commandOffset );
    }
};
inline Packer<CommandPoint> serializable(CommandPoint& x) { return Packer<CommandPoint>(x); }
std::ostream& operator << (std::ostream&, const CommandPoint&);
bool operator==(const CommandPoint&, const CommandPoint&);

struct Expected:
    public Control
{
    Commands commands;
    CommandFragments fragments;
    
    static const char* NAME;
    static const uint8_t CODE=0x8;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Expected();
    Expected(
        call_traits<session::Commands>::param_type commands_,
        call_traits<session::CommandFragments>::param_type fragments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commands)(fragments);
    }
    
    struct Handler
    {
        void sessionExpected(
            call_traits<session::Commands>::param_type commands_,
            call_traits<session::CommandFragments>::param_type fragments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionExpected(commands, fragments );
    }
};
inline Packer<Expected> serializable(Expected& x) { return Packer<Expected>(x); }
std::ostream& operator << (std::ostream&, const Expected&);
bool operator==(const Expected&, const Expected&);

struct Confirmed:
    public Control
{
    Commands commands;
    CommandFragments fragments;
    
    static const char* NAME;
    static const uint8_t CODE=0x9;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Confirmed();
    Confirmed(
        call_traits<session::Commands>::param_type commands_,
        call_traits<session::CommandFragments>::param_type fragments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commands)(fragments);
    }
    
    struct Handler
    {
        void sessionConfirmed(
            call_traits<session::Commands>::param_type commands_,
            call_traits<session::CommandFragments>::param_type fragments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionConfirmed(commands, fragments );
    }
};
inline Packer<Confirmed> serializable(Confirmed& x) { return Packer<Confirmed>(x); }
std::ostream& operator << (std::ostream&, const Confirmed&);
bool operator==(const Confirmed&, const Confirmed&);

struct Completed:
    public Control
{
    Commands commands;
    Bit timelyReply;
    
    static const char* NAME;
    static const uint8_t CODE=0xa;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Completed();
    Completed(
        call_traits<session::Commands>::param_type commands_,
        call_traits<Bit>::param_type timelyReply_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commands)(timelyReply);
    }
    
    struct Handler
    {
        void sessionCompleted(
            call_traits<session::Commands>::param_type commands_,
            call_traits<Bit>::param_type timelyReply_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionCompleted(commands, timelyReply );
    }
};
inline Packer<Completed> serializable(Completed& x) { return Packer<Completed>(x); }
std::ostream& operator << (std::ostream&, const Completed&);
bool operator==(const Completed&, const Completed&);

struct KnownCompleted:
    public Control
{
    Commands commands;
    
    static const char* NAME;
    static const uint8_t CODE=0xb;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    KnownCompleted();
    KnownCompleted(call_traits<session::Commands>::param_type commands_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commands);
    }
    
    struct Handler
    {
        void sessionKnownCompleted(
            call_traits<session::Commands>::param_type commands_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionKnownCompleted(commands );
    }
};
inline Packer<KnownCompleted> serializable(KnownCompleted& x) { return Packer<KnownCompleted>(x); }
std::ostream& operator << (std::ostream&, const KnownCompleted&);
bool operator==(const KnownCompleted&, const KnownCompleted&);

struct Flush:
    public Control
{
    Bit expected;
    Bit confirmed;
    Bit completed;
    
    static const char* NAME;
    static const uint8_t CODE=0xc;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Flush();
    Flush(
        call_traits<Bit>::param_type expected_,
        call_traits<Bit>::param_type confirmed_,
        call_traits<Bit>::param_type completed_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(expected)(confirmed)(completed);
    }
    
    struct Handler
    {
        void sessionFlush(
            call_traits<Bit>::param_type expected_,
            call_traits<Bit>::param_type confirmed_,
            call_traits<Bit>::param_type completed_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionFlush(expected, confirmed, completed );
    }
};
inline Packer<Flush> serializable(Flush& x) { return Packer<Flush>(x); }
std::ostream& operator << (std::ostream&, const Flush&);
bool operator==(const Flush&, const Flush&);

struct Gap:
    public Control
{
    Commands commands;
    
    static const char* NAME;
    static const uint8_t CODE=0xd;
    static const uint8_t CLASS_CODE=session::CODE;
    static const char* CLASS_NAME;
    Gap();
    Gap(call_traits<session::Commands>::param_type commands_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commands);
    }
    
    struct Handler
    {
        void sessionGap(
            call_traits<session::Commands>::param_type commands_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.sessionGap(commands );
    }
};
inline Packer<Gap> serializable(Gap& x) { return Packer<Gap>(x); }
std::ostream& operator << (std::ostream&, const Gap&);
bool operator==(const Gap&, const Gap&);

} // namespace session


namespace execution {


struct Sync:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=execution::CODE;
    static const char* CLASS_NAME;
    Sync();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void executionSync(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.executionSync( );
    }
};
inline Packer<Sync> serializable(Sync& x) { return Packer<Sync>(x); }
std::ostream& operator << (std::ostream&, const Sync&);
bool operator==(const Sync&, const Sync&);

struct Result:
    public Command
{
    SequenceNo commandId;
    Struct32 value;
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=execution::CODE;
    static const char* CLASS_NAME;
    Result();
    Result(
        call_traits<SequenceNo>::param_type commandId_,
        call_traits<Struct32>::param_type value_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(commandId)(value);
    }
    
    struct Handler
    {
        void executionResult(
            call_traits<SequenceNo>::param_type commandId_,
            call_traits<Struct32>::param_type value_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.executionResult(commandId, value );
    }
};
inline Packer<Result> serializable(Result& x) { return Packer<Result>(x); }
std::ostream& operator << (std::ostream&, const Result&);
bool operator==(const Result&, const Result&);

struct Exception:
    public Command
{
    ErrorCode errorCode;
    SequenceNo commandId;
    Uint8 classCode;
    Uint8 commandCode;
    Uint8 fieldIndex;
    Str16 description;
    Map errorInfo;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=execution::CODE;
    static const char* CLASS_NAME;
    Exception();
    Exception(
        call_traits<execution::ErrorCode>::param_type errorCode_,
        call_traits<SequenceNo>::param_type commandId_,
        call_traits<Uint8>::param_type classCode_,
        call_traits<Uint8>::param_type commandCode_,
        call_traits<Uint8>::param_type fieldIndex_,
        call_traits<Str16>::param_type description_,
        call_traits<Map>::param_type errorInfo_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(errorCode)(commandId)(classCode)(commandCode)(fieldIndex)(description)(errorInfo);
    }
    
    struct Handler
    {
        void executionException(
            call_traits<execution::ErrorCode>::param_type errorCode_,
            call_traits<SequenceNo>::param_type commandId_,
            call_traits<Uint8>::param_type classCode_,
            call_traits<Uint8>::param_type commandCode_,
            call_traits<Uint8>::param_type fieldIndex_,
            call_traits<Str16>::param_type description_,
            call_traits<Map>::param_type errorInfo_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.executionException(errorCode, commandId, classCode, commandCode, fieldIndex, description, errorInfo );
    }
};
inline Packer<Exception> serializable(Exception& x) { return Packer<Exception>(x); }
std::ostream& operator << (std::ostream&, const Exception&);
bool operator==(const Exception&, const Exception&);

} // namespace execution


namespace message {


struct DeliveryProperties:
    public Struct
{
    Bit discardUnroutable;
    Bit immediate;
    Bit redelivered;
    DeliveryPriority priority;
    DeliveryMode deliveryMode;
    Uint64 ttl;
    Datetime timestamp;
    Datetime expiration;
    exchange::Name exchange;
    Str8 routingKey;
    ResumeId resumeId;
    Uint64 resumeTtl;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    DeliveryProperties();
    DeliveryProperties(
        call_traits<Bit>::param_type discardUnroutable_,
        call_traits<Bit>::param_type immediate_,
        call_traits<Bit>::param_type redelivered_,
        call_traits<message::DeliveryPriority>::param_type priority_,
        call_traits<message::DeliveryMode>::param_type deliveryMode_,
        call_traits<Uint64>::param_type ttl_,
        call_traits<Datetime>::param_type timestamp_,
        call_traits<Datetime>::param_type expiration_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_,
        call_traits<message::ResumeId>::param_type resumeId_,
        call_traits<Uint64>::param_type resumeTtl_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(discardUnroutable)(immediate)(redelivered)(priority)(deliveryMode)(ttl)(timestamp)(expiration)(exchange)(routingKey)(resumeId)(resumeTtl);
    }
    
};
inline Packer<DeliveryProperties> serializable(DeliveryProperties& x) { return Packer<DeliveryProperties>(x); }
std::ostream& operator << (std::ostream&, const DeliveryProperties&);
bool operator==(const DeliveryProperties&, const DeliveryProperties&);

struct FragmentProperties:
    public Struct
{
    Bit first;
    Bit last;
    Uint64 fragmentSize;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    FragmentProperties();
    FragmentProperties(
        call_traits<Bit>::param_type first_,
        call_traits<Bit>::param_type last_,
        call_traits<Uint64>::param_type fragmentSize_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(first)(last)(fragmentSize);
    }
    
};
inline Packer<FragmentProperties> serializable(FragmentProperties& x) { return Packer<FragmentProperties>(x); }
std::ostream& operator << (std::ostream&, const FragmentProperties&);
bool operator==(const FragmentProperties&, const FragmentProperties&);

struct ReplyTo:
    public Struct
{
    exchange::Name exchange;
    Str8 routingKey;
    
    static const char* NAME;
    static const uint8_t SIZE=2;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    ReplyTo();
    ReplyTo(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(exchange)(routingKey);
    }
    
};
inline Packer<ReplyTo> serializable(ReplyTo& x) { return Packer<ReplyTo>(x); }
std::ostream& operator << (std::ostream&, const ReplyTo&);
bool operator==(const ReplyTo&, const ReplyTo&);

struct MessageProperties:
    public Struct
{
    Uint64 contentLength;
    Uuid messageId;
    Vbin16 correlationId;
    ReplyTo replyTo;
    Str8 contentType;
    Str8 contentEncoding;
    Vbin16 userId;
    Vbin16 appId;
    Map applicationHeaders;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    MessageProperties();
    MessageProperties(
        call_traits<Uint64>::param_type contentLength_,
        call_traits<Uuid>::param_type messageId_,
        call_traits<Vbin16>::param_type correlationId_,
        call_traits<message::ReplyTo>::param_type replyTo_,
        call_traits<Str8>::param_type contentType_,
        call_traits<Str8>::param_type contentEncoding_,
        call_traits<Vbin16>::param_type userId_,
        call_traits<Vbin16>::param_type appId_,
        call_traits<Map>::param_type applicationHeaders_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(contentLength)(messageId)(correlationId)(replyTo)(contentType)(contentEncoding)(userId)(appId)(applicationHeaders);
    }
    
};
inline Packer<MessageProperties> serializable(MessageProperties& x) { return Packer<MessageProperties>(x); }
std::ostream& operator << (std::ostream&, const MessageProperties&);
bool operator==(const MessageProperties&, const MessageProperties&);

struct Acquired:
    public Struct
{
    session::Commands transfers;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Acquired();
    Acquired(call_traits<session::Commands>::param_type transfers_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(transfers);
    }
    
};
inline Packer<Acquired> serializable(Acquired& x) { return Packer<Acquired>(x); }
std::ostream& operator << (std::ostream&, const Acquired&);
bool operator==(const Acquired&, const Acquired&);

struct MessageResumeResult:
    public Struct
{
    Uint64 offset;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    MessageResumeResult();
    MessageResumeResult(call_traits<Uint64>::param_type offset_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(offset);
    }
    
};
inline Packer<MessageResumeResult> serializable(MessageResumeResult& x) { return Packer<MessageResumeResult>(x); }
std::ostream& operator << (std::ostream&, const MessageResumeResult&);
bool operator==(const MessageResumeResult&, const MessageResumeResult&);

struct Transfer:
    public Command
{
    Destination destination;
    AcceptMode acceptMode;
    AcquireMode acquireMode;
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Transfer();
    Transfer(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::AcceptMode>::param_type acceptMode_,
        call_traits<message::AcquireMode>::param_type acquireMode_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(destination)(acceptMode)(acquireMode);
    }
    
    struct Handler
    {
        void messageTransfer(
            call_traits<message::Destination>::param_type destination_,
            call_traits<message::AcceptMode>::param_type acceptMode_,
            call_traits<message::AcquireMode>::param_type acquireMode_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageTransfer(destination, acceptMode, acquireMode );
    }
};
inline Packer<Transfer> serializable(Transfer& x) { return Packer<Transfer>(x); }
std::ostream& operator << (std::ostream&, const Transfer&);
bool operator==(const Transfer&, const Transfer&);

struct Accept:
    public Command
{
    session::Commands transfers;
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Accept();
    Accept(call_traits<session::Commands>::param_type transfers_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(transfers);
    }
    
    struct Handler
    {
        void messageAccept(
            call_traits<session::Commands>::param_type transfers_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageAccept(transfers );
    }
};
inline Packer<Accept> serializable(Accept& x) { return Packer<Accept>(x); }
std::ostream& operator << (std::ostream&, const Accept&);
bool operator==(const Accept&, const Accept&);

struct Reject:
    public Command
{
    session::Commands transfers;
    RejectCode code;
    Str8 text;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Reject();
    Reject(
        call_traits<session::Commands>::param_type transfers_,
        call_traits<message::RejectCode>::param_type code_,
        call_traits<Str8>::param_type text_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(transfers)(code)(text);
    }
    
    struct Handler
    {
        void messageReject(
            call_traits<session::Commands>::param_type transfers_,
            call_traits<message::RejectCode>::param_type code_,
            call_traits<Str8>::param_type text_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageReject(transfers, code, text );
    }
};
inline Packer<Reject> serializable(Reject& x) { return Packer<Reject>(x); }
std::ostream& operator << (std::ostream&, const Reject&);
bool operator==(const Reject&, const Reject&);

struct Release:
    public Command
{
    session::Commands transfers;
    Bit setRedelivered;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Release();
    Release(
        call_traits<session::Commands>::param_type transfers_,
        call_traits<Bit>::param_type setRedelivered_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(transfers)(setRedelivered);
    }
    
    struct Handler
    {
        void messageRelease(
            call_traits<session::Commands>::param_type transfers_,
            call_traits<Bit>::param_type setRedelivered_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageRelease(transfers, setRedelivered );
    }
};
inline Packer<Release> serializable(Release& x) { return Packer<Release>(x); }
std::ostream& operator << (std::ostream&, const Release&);
bool operator==(const Release&, const Release&);

struct Acquire:
    public Command
{
    session::Commands transfers;
    
    static const char* NAME;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Acquire();
    Acquire(call_traits<session::Commands>::param_type transfers_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(transfers);
    }
    
    struct Handler
    {
        void messageAcquire(
            call_traits<session::Commands>::param_type transfers_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageAcquire(transfers );
    }
};
inline Packer<Acquire> serializable(Acquire& x) { return Packer<Acquire>(x); }
std::ostream& operator << (std::ostream&, const Acquire&);
bool operator==(const Acquire&, const Acquire&);

struct Resume:
    public Command
{
    Destination destination;
    ResumeId resumeId;
    
    static const char* NAME;
    static const uint8_t CODE=0x6;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Resume();
    Resume(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::ResumeId>::param_type resumeId_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(destination)(resumeId);
    }
    
    struct Handler
    {
        void messageResume(
            call_traits<message::Destination>::param_type destination_,
            call_traits<message::ResumeId>::param_type resumeId_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageResume(destination, resumeId );
    }
};
inline Packer<Resume> serializable(Resume& x) { return Packer<Resume>(x); }
std::ostream& operator << (std::ostream&, const Resume&);
bool operator==(const Resume&, const Resume&);

struct Subscribe:
    public Command
{
    queue::Name queue;
    Destination destination;
    AcceptMode acceptMode;
    AcquireMode acquireMode;
    Bit exclusive;
    ResumeId resumeId;
    Uint64 resumeTtl;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t CODE=0x7;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Subscribe();
    Subscribe(
        call_traits<queue::Name>::param_type queue_,
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::AcceptMode>::param_type acceptMode_,
        call_traits<message::AcquireMode>::param_type acquireMode_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<message::ResumeId>::param_type resumeId_,
        call_traits<Uint64>::param_type resumeTtl_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(destination)(acceptMode)(acquireMode)(exclusive)(resumeId)(resumeTtl)(arguments);
    }
    
    struct Handler
    {
        void messageSubscribe(
            call_traits<queue::Name>::param_type queue_,
            call_traits<message::Destination>::param_type destination_,
            call_traits<message::AcceptMode>::param_type acceptMode_,
            call_traits<message::AcquireMode>::param_type acquireMode_,
            call_traits<Bit>::param_type exclusive_,
            call_traits<message::ResumeId>::param_type resumeId_,
            call_traits<Uint64>::param_type resumeTtl_,
            call_traits<Map>::param_type arguments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageSubscribe(queue, destination, acceptMode, acquireMode, exclusive, resumeId, resumeTtl, arguments );
    }
};
inline Packer<Subscribe> serializable(Subscribe& x) { return Packer<Subscribe>(x); }
std::ostream& operator << (std::ostream&, const Subscribe&);
bool operator==(const Subscribe&, const Subscribe&);

struct Cancel:
    public Command
{
    Destination destination;
    
    static const char* NAME;
    static const uint8_t CODE=0x8;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Cancel();
    Cancel(call_traits<message::Destination>::param_type destination_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(destination);
    }
    
    struct Handler
    {
        void messageCancel(
            call_traits<message::Destination>::param_type destination_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageCancel(destination );
    }
};
inline Packer<Cancel> serializable(Cancel& x) { return Packer<Cancel>(x); }
std::ostream& operator << (std::ostream&, const Cancel&);
bool operator==(const Cancel&, const Cancel&);

struct SetFlowMode:
    public Command
{
    Destination destination;
    FlowMode flowMode;
    
    static const char* NAME;
    static const uint8_t CODE=0x9;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    SetFlowMode();
    SetFlowMode(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::FlowMode>::param_type flowMode_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(destination)(flowMode);
    }
    
    struct Handler
    {
        void messageSetFlowMode(
            call_traits<message::Destination>::param_type destination_,
            call_traits<message::FlowMode>::param_type flowMode_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageSetFlowMode(destination, flowMode );
    }
};
inline Packer<SetFlowMode> serializable(SetFlowMode& x) { return Packer<SetFlowMode>(x); }
std::ostream& operator << (std::ostream&, const SetFlowMode&);
bool operator==(const SetFlowMode&, const SetFlowMode&);

struct Flow:
    public Command
{
    Destination destination;
    CreditUnit unit;
    Uint32 value;
    
    static const char* NAME;
    static const uint8_t CODE=0xa;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Flow();
    Flow(
        call_traits<message::Destination>::param_type destination_,
        call_traits<message::CreditUnit>::param_type unit_,
        call_traits<Uint32>::param_type value_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(destination)(unit)(value);
    }
    
    struct Handler
    {
        void messageFlow(
            call_traits<message::Destination>::param_type destination_,
            call_traits<message::CreditUnit>::param_type unit_,
            call_traits<Uint32>::param_type value_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageFlow(destination, unit, value );
    }
};
inline Packer<Flow> serializable(Flow& x) { return Packer<Flow>(x); }
std::ostream& operator << (std::ostream&, const Flow&);
bool operator==(const Flow&, const Flow&);

struct Flush:
    public Command
{
    Destination destination;
    
    static const char* NAME;
    static const uint8_t CODE=0xb;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Flush();
    Flush(call_traits<message::Destination>::param_type destination_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(destination);
    }
    
    struct Handler
    {
        void messageFlush(
            call_traits<message::Destination>::param_type destination_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageFlush(destination );
    }
};
inline Packer<Flush> serializable(Flush& x) { return Packer<Flush>(x); }
std::ostream& operator << (std::ostream&, const Flush&);
bool operator==(const Flush&, const Flush&);

struct Stop:
    public Command
{
    Destination destination;
    
    static const char* NAME;
    static const uint8_t CODE=0xc;
    static const uint8_t CLASS_CODE=message::CODE;
    static const char* CLASS_NAME;
    Stop();
    Stop(call_traits<message::Destination>::param_type destination_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(destination);
    }
    
    struct Handler
    {
        void messageStop(
            call_traits<message::Destination>::param_type destination_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.messageStop(destination );
    }
};
inline Packer<Stop> serializable(Stop& x) { return Packer<Stop>(x); }
std::ostream& operator << (std::ostream&, const Stop&);
bool operator==(const Stop&, const Stop&);

} // namespace message


namespace tx {


struct Select:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=tx::CODE;
    static const char* CLASS_NAME;
    Select();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void txSelect(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.txSelect( );
    }
};
inline Packer<Select> serializable(Select& x) { return Packer<Select>(x); }
std::ostream& operator << (std::ostream&, const Select&);
bool operator==(const Select&, const Select&);

struct Commit:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=tx::CODE;
    static const char* CLASS_NAME;
    Commit();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void txCommit(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.txCommit( );
    }
};
inline Packer<Commit> serializable(Commit& x) { return Packer<Commit>(x); }
std::ostream& operator << (std::ostream&, const Commit&);
bool operator==(const Commit&, const Commit&);

struct Rollback:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=tx::CODE;
    static const char* CLASS_NAME;
    Rollback();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void txRollback(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.txRollback( );
    }
};
inline Packer<Rollback> serializable(Rollback& x) { return Packer<Rollback>(x); }
std::ostream& operator << (std::ostream&, const Rollback&);
bool operator==(const Rollback&, const Rollback&);

} // namespace tx


namespace dtx {


struct XaResult:
    public Struct
{
    XaStatus status;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    XaResult();
    XaResult(call_traits<dtx::XaStatus>::param_type status_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(status);
    }
    
};
inline Packer<XaResult> serializable(XaResult& x) { return Packer<XaResult>(x); }
std::ostream& operator << (std::ostream&, const XaResult&);
bool operator==(const XaResult&, const XaResult&);

struct Xid:
    public Struct
{
    Uint32 format;
    Vbin8 globalId;
    Vbin8 branchId;
    
    static const char* NAME;
    static const uint8_t SIZE=2;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Xid();
    Xid(
        call_traits<Uint32>::param_type format_,
        call_traits<Vbin8>::param_type globalId_,
        call_traits<Vbin8>::param_type branchId_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(format)(globalId)(branchId);
    }
    
};
inline Packer<Xid> serializable(Xid& x) { return Packer<Xid>(x); }
std::ostream& operator << (std::ostream&, const Xid&);
bool operator==(const Xid&, const Xid&);

struct GetTimeoutResult:
    public Struct
{
    Uint32 timeout;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    GetTimeoutResult();
    GetTimeoutResult(call_traits<Uint32>::param_type timeout_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(timeout);
    }
    
};
inline Packer<GetTimeoutResult> serializable(GetTimeoutResult& x) { return Packer<GetTimeoutResult>(x); }
std::ostream& operator << (std::ostream&, const GetTimeoutResult&);
bool operator==(const GetTimeoutResult&, const GetTimeoutResult&);

struct RecoverResult:
    public Struct
{
    ArrayDomain<dtx::Xid>  inDoubt;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    RecoverResult();
    RecoverResult(call_traits<ArrayDomain<dtx::Xid> >::param_type inDoubt_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(inDoubt);
    }
    
};
inline Packer<RecoverResult> serializable(RecoverResult& x) { return Packer<RecoverResult>(x); }
std::ostream& operator << (std::ostream&, const RecoverResult&);
bool operator==(const RecoverResult&, const RecoverResult&);

struct Select:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Select();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void dtxSelect(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxSelect( );
    }
};
inline Packer<Select> serializable(Select& x) { return Packer<Select>(x); }
std::ostream& operator << (std::ostream&, const Select&);
bool operator==(const Select&, const Select&);

struct Start:
    public Command
{
    Xid xid;
    Bit join;
    Bit resume;
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Start();
    Start(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Bit>::param_type join_,
        call_traits<Bit>::param_type resume_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid)(join)(resume);
    }
    
    struct Handler
    {
        void dtxStart(
            call_traits<dtx::Xid>::param_type xid_,
            call_traits<Bit>::param_type join_,
            call_traits<Bit>::param_type resume_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxStart(xid, join, resume );
    }
};
inline Packer<Start> serializable(Start& x) { return Packer<Start>(x); }
std::ostream& operator << (std::ostream&, const Start&);
bool operator==(const Start&, const Start&);

struct End:
    public Command
{
    Xid xid;
    Bit fail;
    Bit suspend;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    End();
    End(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Bit>::param_type fail_,
        call_traits<Bit>::param_type suspend_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid)(fail)(suspend);
    }
    
    struct Handler
    {
        void dtxEnd(
            call_traits<dtx::Xid>::param_type xid_,
            call_traits<Bit>::param_type fail_,
            call_traits<Bit>::param_type suspend_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxEnd(xid, fail, suspend );
    }
};
inline Packer<End> serializable(End& x) { return Packer<End>(x); }
std::ostream& operator << (std::ostream&, const End&);
bool operator==(const End&, const End&);

struct Commit:
    public Command
{
    Xid xid;
    Bit onePhase;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Commit();
    Commit(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Bit>::param_type onePhase_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid)(onePhase);
    }
    
    struct Handler
    {
        void dtxCommit(
            call_traits<dtx::Xid>::param_type xid_,
            call_traits<Bit>::param_type onePhase_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxCommit(xid, onePhase );
    }
};
inline Packer<Commit> serializable(Commit& x) { return Packer<Commit>(x); }
std::ostream& operator << (std::ostream&, const Commit&);
bool operator==(const Commit&, const Commit&);

struct Forget:
    public Command
{
    Xid xid;
    
    static const char* NAME;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Forget();
    Forget(call_traits<dtx::Xid>::param_type xid_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid);
    }
    
    struct Handler
    {
        void dtxForget(
            call_traits<dtx::Xid>::param_type xid_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxForget(xid );
    }
};
inline Packer<Forget> serializable(Forget& x) { return Packer<Forget>(x); }
std::ostream& operator << (std::ostream&, const Forget&);
bool operator==(const Forget&, const Forget&);

struct GetTimeout:
    public Command
{
    Xid xid;
    
    static const char* NAME;
    static const uint8_t CODE=0x6;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    GetTimeout();
    GetTimeout(call_traits<dtx::Xid>::param_type xid_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid);
    }
    
    struct Handler
    {
        void dtxGetTimeout(
            call_traits<dtx::Xid>::param_type xid_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxGetTimeout(xid );
    }
};
inline Packer<GetTimeout> serializable(GetTimeout& x) { return Packer<GetTimeout>(x); }
std::ostream& operator << (std::ostream&, const GetTimeout&);
bool operator==(const GetTimeout&, const GetTimeout&);

struct Prepare:
    public Command
{
    Xid xid;
    
    static const char* NAME;
    static const uint8_t CODE=0x7;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Prepare();
    Prepare(call_traits<dtx::Xid>::param_type xid_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid);
    }
    
    struct Handler
    {
        void dtxPrepare(
            call_traits<dtx::Xid>::param_type xid_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxPrepare(xid );
    }
};
inline Packer<Prepare> serializable(Prepare& x) { return Packer<Prepare>(x); }
std::ostream& operator << (std::ostream&, const Prepare&);
bool operator==(const Prepare&, const Prepare&);

struct Recover:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x8;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Recover();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void dtxRecover(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxRecover( );
    }
};
inline Packer<Recover> serializable(Recover& x) { return Packer<Recover>(x); }
std::ostream& operator << (std::ostream&, const Recover&);
bool operator==(const Recover&, const Recover&);

struct Rollback:
    public Command
{
    Xid xid;
    
    static const char* NAME;
    static const uint8_t CODE=0x9;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    Rollback();
    Rollback(call_traits<dtx::Xid>::param_type xid_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid);
    }
    
    struct Handler
    {
        void dtxRollback(
            call_traits<dtx::Xid>::param_type xid_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxRollback(xid );
    }
};
inline Packer<Rollback> serializable(Rollback& x) { return Packer<Rollback>(x); }
std::ostream& operator << (std::ostream&, const Rollback&);
bool operator==(const Rollback&, const Rollback&);

struct SetTimeout:
    public Command
{
    Xid xid;
    Uint32 timeout;
    
    static const char* NAME;
    static const uint8_t CODE=0xa;
    static const uint8_t CLASS_CODE=dtx::CODE;
    static const char* CLASS_NAME;
    SetTimeout();
    SetTimeout(
        call_traits<dtx::Xid>::param_type xid_,
        call_traits<Uint32>::param_type timeout_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(xid)(timeout);
    }
    
    struct Handler
    {
        void dtxSetTimeout(
            call_traits<dtx::Xid>::param_type xid_,
            call_traits<Uint32>::param_type timeout_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.dtxSetTimeout(xid, timeout );
    }
};
inline Packer<SetTimeout> serializable(SetTimeout& x) { return Packer<SetTimeout>(x); }
std::ostream& operator << (std::ostream&, const SetTimeout&);
bool operator==(const SetTimeout&, const SetTimeout&);

} // namespace dtx


namespace exchange {


struct ExchangeQueryResult:
    public Struct
{
    Str8 type;
    Bit durable;
    Bit notFound;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    ExchangeQueryResult();
    ExchangeQueryResult(
        call_traits<Str8>::param_type type_,
        call_traits<Bit>::param_type durable_,
        call_traits<Bit>::param_type notFound_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(type)(durable)(notFound)(arguments);
    }
    
};
inline Packer<ExchangeQueryResult> serializable(ExchangeQueryResult& x) { return Packer<ExchangeQueryResult>(x); }
std::ostream& operator << (std::ostream&, const ExchangeQueryResult&);
bool operator==(const ExchangeQueryResult&, const ExchangeQueryResult&);

struct ExchangeBoundResult:
    public Struct
{
    Bit exchangeNotFound;
    Bit queueNotFound;
    Bit queueNotMatched;
    Bit keyNotMatched;
    Bit argsNotMatched;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    ExchangeBoundResult();
    ExchangeBoundResult(
        call_traits<Bit>::param_type exchangeNotFound_,
        call_traits<Bit>::param_type queueNotFound_,
        call_traits<Bit>::param_type queueNotMatched_,
        call_traits<Bit>::param_type keyNotMatched_,
        call_traits<Bit>::param_type argsNotMatched_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(exchangeNotFound)(queueNotFound)(queueNotMatched)(keyNotMatched)(argsNotMatched);
    }
    
};
inline Packer<ExchangeBoundResult> serializable(ExchangeBoundResult& x) { return Packer<ExchangeBoundResult>(x); }
std::ostream& operator << (std::ostream&, const ExchangeBoundResult&);
bool operator==(const ExchangeBoundResult&, const ExchangeBoundResult&);

struct Declare:
    public Command
{
    Name exchange;
    Str8 type;
    Name alternateExchange;
    Bit passive;
    Bit durable;
    Bit autoDelete;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    Declare();
    Declare(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type type_,
        call_traits<exchange::Name>::param_type alternateExchange_,
        call_traits<Bit>::param_type passive_,
        call_traits<Bit>::param_type durable_,
        call_traits<Bit>::param_type autoDelete_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(exchange)(type)(alternateExchange)(passive)(durable)(autoDelete)(arguments);
    }
    
    struct Handler
    {
        void exchangeDeclare(
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type type_,
            call_traits<exchange::Name>::param_type alternateExchange_,
            call_traits<Bit>::param_type passive_,
            call_traits<Bit>::param_type durable_,
            call_traits<Bit>::param_type autoDelete_,
            call_traits<Map>::param_type arguments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.exchangeDeclare(exchange, type, alternateExchange, passive, durable, autoDelete, arguments );
    }
};
inline Packer<Declare> serializable(Declare& x) { return Packer<Declare>(x); }
std::ostream& operator << (std::ostream&, const Declare&);
bool operator==(const Declare&, const Declare&);

struct Delete:
    public Command
{
    Name exchange;
    Bit ifUnused;
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    Delete();
    Delete(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Bit>::param_type ifUnused_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(exchange)(ifUnused);
    }
    
    struct Handler
    {
        void exchangeDelete(
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Bit>::param_type ifUnused_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.exchangeDelete(exchange, ifUnused );
    }
};
inline Packer<Delete> serializable(Delete& x) { return Packer<Delete>(x); }
std::ostream& operator << (std::ostream&, const Delete&);
bool operator==(const Delete&, const Delete&);

struct Query:
    public Command
{
    Str8 name;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    Query();
    Query(call_traits<Str8>::param_type name_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(name);
    }
    
    struct Handler
    {
        void exchangeQuery(
            call_traits<Str8>::param_type name_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.exchangeQuery(name );
    }
};
inline Packer<Query> serializable(Query& x) { return Packer<Query>(x); }
std::ostream& operator << (std::ostream&, const Query&);
bool operator==(const Query&, const Query&);

struct Bind:
    public Command
{
    queue::Name queue;
    Name exchange;
    Str8 bindingKey;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    Bind();
    Bind(
        call_traits<queue::Name>::param_type queue_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type bindingKey_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(exchange)(bindingKey)(arguments);
    }
    
    struct Handler
    {
        void exchangeBind(
            call_traits<queue::Name>::param_type queue_,
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type bindingKey_,
            call_traits<Map>::param_type arguments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.exchangeBind(queue, exchange, bindingKey, arguments );
    }
};
inline Packer<Bind> serializable(Bind& x) { return Packer<Bind>(x); }
std::ostream& operator << (std::ostream&, const Bind&);
bool operator==(const Bind&, const Bind&);

struct Unbind:
    public Command
{
    queue::Name queue;
    Name exchange;
    Str8 bindingKey;
    
    static const char* NAME;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    Unbind();
    Unbind(
        call_traits<queue::Name>::param_type queue_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type bindingKey_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(exchange)(bindingKey);
    }
    
    struct Handler
    {
        void exchangeUnbind(
            call_traits<queue::Name>::param_type queue_,
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type bindingKey_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.exchangeUnbind(queue, exchange, bindingKey );
    }
};
inline Packer<Unbind> serializable(Unbind& x) { return Packer<Unbind>(x); }
std::ostream& operator << (std::ostream&, const Unbind&);
bool operator==(const Unbind&, const Unbind&);

struct Bound:
    public Command
{
    Str8 exchange;
    Str8 queue;
    Str8 bindingKey;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t CODE=0x6;
    static const uint8_t CLASS_CODE=exchange::CODE;
    static const char* CLASS_NAME;
    Bound();
    Bound(
        call_traits<Str8>::param_type exchange_,
        call_traits<Str8>::param_type queue_,
        call_traits<Str8>::param_type bindingKey_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(exchange)(queue)(bindingKey)(arguments);
    }
    
    struct Handler
    {
        void exchangeBound(
            call_traits<Str8>::param_type exchange_,
            call_traits<Str8>::param_type queue_,
            call_traits<Str8>::param_type bindingKey_,
            call_traits<Map>::param_type arguments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.exchangeBound(exchange, queue, bindingKey, arguments );
    }
};
inline Packer<Bound> serializable(Bound& x) { return Packer<Bound>(x); }
std::ostream& operator << (std::ostream&, const Bound&);
bool operator==(const Bound&, const Bound&);

} // namespace exchange


namespace queue {


struct QueueQueryResult:
    public Struct
{
    Name queue;
    exchange::Name alternateExchange;
    Bit durable;
    Bit exclusive;
    Bit autoDelete;
    Map arguments;
    Uint32 messageCount;
    Uint32 subscriberCount;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=queue::CODE;
    static const char* CLASS_NAME;
    QueueQueryResult();
    QueueQueryResult(
        call_traits<queue::Name>::param_type queue_,
        call_traits<exchange::Name>::param_type alternateExchange_,
        call_traits<Bit>::param_type durable_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<Bit>::param_type autoDelete_,
        call_traits<Map>::param_type arguments_,
        call_traits<Uint32>::param_type messageCount_,
        call_traits<Uint32>::param_type subscriberCount_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(alternateExchange)(durable)(exclusive)(autoDelete)(arguments)(messageCount)(subscriberCount);
    }
    
};
inline Packer<QueueQueryResult> serializable(QueueQueryResult& x) { return Packer<QueueQueryResult>(x); }
std::ostream& operator << (std::ostream&, const QueueQueryResult&);
bool operator==(const QueueQueryResult&, const QueueQueryResult&);

struct Declare:
    public Command
{
    Name queue;
    exchange::Name alternateExchange;
    Bit passive;
    Bit durable;
    Bit exclusive;
    Bit autoDelete;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=queue::CODE;
    static const char* CLASS_NAME;
    Declare();
    Declare(
        call_traits<queue::Name>::param_type queue_,
        call_traits<exchange::Name>::param_type alternateExchange_,
        call_traits<Bit>::param_type passive_,
        call_traits<Bit>::param_type durable_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<Bit>::param_type autoDelete_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(alternateExchange)(passive)(durable)(exclusive)(autoDelete)(arguments);
    }
    
    struct Handler
    {
        void queueDeclare(
            call_traits<queue::Name>::param_type queue_,
            call_traits<exchange::Name>::param_type alternateExchange_,
            call_traits<Bit>::param_type passive_,
            call_traits<Bit>::param_type durable_,
            call_traits<Bit>::param_type exclusive_,
            call_traits<Bit>::param_type autoDelete_,
            call_traits<Map>::param_type arguments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.queueDeclare(queue, alternateExchange, passive, durable, exclusive, autoDelete, arguments );
    }
};
inline Packer<Declare> serializable(Declare& x) { return Packer<Declare>(x); }
std::ostream& operator << (std::ostream&, const Declare&);
bool operator==(const Declare&, const Declare&);

struct Delete:
    public Command
{
    Name queue;
    Bit ifUnused;
    Bit ifEmpty;
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=queue::CODE;
    static const char* CLASS_NAME;
    Delete();
    Delete(
        call_traits<queue::Name>::param_type queue_,
        call_traits<Bit>::param_type ifUnused_,
        call_traits<Bit>::param_type ifEmpty_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(ifUnused)(ifEmpty);
    }
    
    struct Handler
    {
        void queueDelete(
            call_traits<queue::Name>::param_type queue_,
            call_traits<Bit>::param_type ifUnused_,
            call_traits<Bit>::param_type ifEmpty_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.queueDelete(queue, ifUnused, ifEmpty );
    }
};
inline Packer<Delete> serializable(Delete& x) { return Packer<Delete>(x); }
std::ostream& operator << (std::ostream&, const Delete&);
bool operator==(const Delete&, const Delete&);

struct Purge:
    public Command
{
    Name queue;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=queue::CODE;
    static const char* CLASS_NAME;
    Purge();
    Purge(call_traits<queue::Name>::param_type queue_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue);
    }
    
    struct Handler
    {
        void queuePurge(
            call_traits<queue::Name>::param_type queue_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.queuePurge(queue );
    }
};
inline Packer<Purge> serializable(Purge& x) { return Packer<Purge>(x); }
std::ostream& operator << (std::ostream&, const Purge&);
bool operator==(const Purge&, const Purge&);

struct Query:
    public Command
{
    Name queue;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=queue::CODE;
    static const char* CLASS_NAME;
    Query();
    Query(call_traits<queue::Name>::param_type queue_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue);
    }
    
    struct Handler
    {
        void queueQuery(
            call_traits<queue::Name>::param_type queue_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.queueQuery(queue );
    }
};
inline Packer<Query> serializable(Query& x) { return Packer<Query>(x); }
std::ostream& operator << (std::ostream&, const Query&);
bool operator==(const Query&, const Query&);

} // namespace queue


namespace file {


struct FileProperties:
    public Struct
{
    Str8 contentType;
    Str8 contentEncoding;
    Map headers;
    Uint8 priority;
    Str8 replyTo;
    Str8 messageId;
    Str8 filename;
    Datetime timestamp;
    Str8 clusterId;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    FileProperties();
    FileProperties(
        call_traits<Str8>::param_type contentType_,
        call_traits<Str8>::param_type contentEncoding_,
        call_traits<Map>::param_type headers_,
        call_traits<Uint8>::param_type priority_,
        call_traits<Str8>::param_type replyTo_,
        call_traits<Str8>::param_type messageId_,
        call_traits<Str8>::param_type filename_,
        call_traits<Datetime>::param_type timestamp_,
        call_traits<Str8>::param_type clusterId_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(contentType)(contentEncoding)(headers)(priority)(replyTo)(messageId)(filename)(timestamp)(clusterId);
    }
    
};
inline Packer<FileProperties> serializable(FileProperties& x) { return Packer<FileProperties>(x); }
std::ostream& operator << (std::ostream&, const FileProperties&);
bool operator==(const FileProperties&, const FileProperties&);

struct Qos:
    public Command
{
    Uint32 prefetchSize;
    Uint16 prefetchCount;
    Bit global;
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Qos();
    Qos(
        call_traits<Uint32>::param_type prefetchSize_,
        call_traits<Uint16>::param_type prefetchCount_,
        call_traits<Bit>::param_type global_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(prefetchSize)(prefetchCount)(global);
    }
    
    struct Handler
    {
        void fileQos(
            call_traits<Uint32>::param_type prefetchSize_,
            call_traits<Uint16>::param_type prefetchCount_,
            call_traits<Bit>::param_type global_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileQos(prefetchSize, prefetchCount, global );
    }
};
inline Packer<Qos> serializable(Qos& x) { return Packer<Qos>(x); }
std::ostream& operator << (std::ostream&, const Qos&);
bool operator==(const Qos&, const Qos&);

struct QosOk:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    QosOk();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void fileQosOk(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileQosOk( );
    }
};
inline Packer<QosOk> serializable(QosOk& x) { return Packer<QosOk>(x); }
std::ostream& operator << (std::ostream&, const QosOk&);
bool operator==(const QosOk&, const QosOk&);

struct Consume:
    public Command
{
    queue::Name queue;
    Str8 consumerTag;
    Bit noLocal;
    Bit noAck;
    Bit exclusive;
    Bit nowait;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Consume();
    Consume(
        call_traits<queue::Name>::param_type queue_,
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Bit>::param_type noLocal_,
        call_traits<Bit>::param_type noAck_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<Bit>::param_type nowait_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(consumerTag)(noLocal)(noAck)(exclusive)(nowait)(arguments);
    }
    
    struct Handler
    {
        void fileConsume(
            call_traits<queue::Name>::param_type queue_,
            call_traits<Str8>::param_type consumerTag_,
            call_traits<Bit>::param_type noLocal_,
            call_traits<Bit>::param_type noAck_,
            call_traits<Bit>::param_type exclusive_,
            call_traits<Bit>::param_type nowait_,
            call_traits<Map>::param_type arguments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileConsume(queue, consumerTag, noLocal, noAck, exclusive, nowait, arguments );
    }
};
inline Packer<Consume> serializable(Consume& x) { return Packer<Consume>(x); }
std::ostream& operator << (std::ostream&, const Consume&);
bool operator==(const Consume&, const Consume&);

struct ConsumeOk:
    public Command
{
    Str8 consumerTag;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    ConsumeOk();
    ConsumeOk(call_traits<Str8>::param_type consumerTag_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(consumerTag);
    }
    
    struct Handler
    {
        void fileConsumeOk(
            call_traits<Str8>::param_type consumerTag_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileConsumeOk(consumerTag );
    }
};
inline Packer<ConsumeOk> serializable(ConsumeOk& x) { return Packer<ConsumeOk>(x); }
std::ostream& operator << (std::ostream&, const ConsumeOk&);
bool operator==(const ConsumeOk&, const ConsumeOk&);

struct Cancel:
    public Command
{
    Str8 consumerTag;
    
    static const char* NAME;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Cancel();
    Cancel(call_traits<Str8>::param_type consumerTag_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(consumerTag);
    }
    
    struct Handler
    {
        void fileCancel(
            call_traits<Str8>::param_type consumerTag_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileCancel(consumerTag );
    }
};
inline Packer<Cancel> serializable(Cancel& x) { return Packer<Cancel>(x); }
std::ostream& operator << (std::ostream&, const Cancel&);
bool operator==(const Cancel&, const Cancel&);

struct Open:
    public Command
{
    Str8 identifier;
    Uint64 contentSize;
    
    static const char* NAME;
    static const uint8_t CODE=0x6;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Open();
    Open(
        call_traits<Str8>::param_type identifier_,
        call_traits<Uint64>::param_type contentSize_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(identifier)(contentSize);
    }
    
    struct Handler
    {
        void fileOpen(
            call_traits<Str8>::param_type identifier_,
            call_traits<Uint64>::param_type contentSize_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileOpen(identifier, contentSize );
    }
};
inline Packer<Open> serializable(Open& x) { return Packer<Open>(x); }
std::ostream& operator << (std::ostream&, const Open&);
bool operator==(const Open&, const Open&);

struct OpenOk:
    public Command
{
    Uint64 stagedSize;
    
    static const char* NAME;
    static const uint8_t CODE=0x7;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    OpenOk();
    OpenOk(call_traits<Uint64>::param_type stagedSize_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(stagedSize);
    }
    
    struct Handler
    {
        void fileOpenOk(
            call_traits<Uint64>::param_type stagedSize_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileOpenOk(stagedSize );
    }
};
inline Packer<OpenOk> serializable(OpenOk& x) { return Packer<OpenOk>(x); }
std::ostream& operator << (std::ostream&, const OpenOk&);
bool operator==(const OpenOk&, const OpenOk&);

struct Stage:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x8;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Stage();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void fileStage(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileStage( );
    }
};
inline Packer<Stage> serializable(Stage& x) { return Packer<Stage>(x); }
std::ostream& operator << (std::ostream&, const Stage&);
bool operator==(const Stage&, const Stage&);

struct Publish:
    public Command
{
    exchange::Name exchange;
    Str8 routingKey;
    Bit mandatory;
    Bit immediate;
    Str8 identifier;
    
    static const char* NAME;
    static const uint8_t CODE=0x9;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Publish();
    Publish(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_,
        call_traits<Bit>::param_type mandatory_,
        call_traits<Bit>::param_type immediate_,
        call_traits<Str8>::param_type identifier_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(exchange)(routingKey)(mandatory)(immediate)(identifier);
    }
    
    struct Handler
    {
        void filePublish(
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type routingKey_,
            call_traits<Bit>::param_type mandatory_,
            call_traits<Bit>::param_type immediate_,
            call_traits<Str8>::param_type identifier_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.filePublish(exchange, routingKey, mandatory, immediate, identifier );
    }
};
inline Packer<Publish> serializable(Publish& x) { return Packer<Publish>(x); }
std::ostream& operator << (std::ostream&, const Publish&);
bool operator==(const Publish&, const Publish&);

struct Return:
    public Command
{
    ReturnCode replyCode;
    Str8 replyText;
    exchange::Name exchange;
    Str8 routingKey;
    
    static const char* NAME;
    static const uint8_t CODE=0xa;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Return();
    Return(
        call_traits<file::ReturnCode>::param_type replyCode_,
        call_traits<Str8>::param_type replyText_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(replyCode)(replyText)(exchange)(routingKey);
    }
    
    struct Handler
    {
        void fileReturn(
            call_traits<file::ReturnCode>::param_type replyCode_,
            call_traits<Str8>::param_type replyText_,
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type routingKey_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileReturn(replyCode, replyText, exchange, routingKey );
    }
};
inline Packer<Return> serializable(Return& x) { return Packer<Return>(x); }
std::ostream& operator << (std::ostream&, const Return&);
bool operator==(const Return&, const Return&);

struct Deliver:
    public Command
{
    Str8 consumerTag;
    Uint64 deliveryTag;
    Bit redelivered;
    exchange::Name exchange;
    Str8 routingKey;
    Str8 identifier;
    
    static const char* NAME;
    static const uint8_t CODE=0xb;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Deliver();
    Deliver(
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<Bit>::param_type redelivered_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_,
        call_traits<Str8>::param_type identifier_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(consumerTag)(deliveryTag)(redelivered)(exchange)(routingKey)(identifier);
    }
    
    struct Handler
    {
        void fileDeliver(
            call_traits<Str8>::param_type consumerTag_,
            call_traits<Uint64>::param_type deliveryTag_,
            call_traits<Bit>::param_type redelivered_,
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type routingKey_,
            call_traits<Str8>::param_type identifier_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileDeliver(consumerTag, deliveryTag, redelivered, exchange, routingKey, identifier );
    }
};
inline Packer<Deliver> serializable(Deliver& x) { return Packer<Deliver>(x); }
std::ostream& operator << (std::ostream&, const Deliver&);
bool operator==(const Deliver&, const Deliver&);

struct Ack:
    public Command
{
    Uint64 deliveryTag;
    Bit multiple;
    
    static const char* NAME;
    static const uint8_t CODE=0xc;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Ack();
    Ack(
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<Bit>::param_type multiple_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(deliveryTag)(multiple);
    }
    
    struct Handler
    {
        void fileAck(
            call_traits<Uint64>::param_type deliveryTag_,
            call_traits<Bit>::param_type multiple_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileAck(deliveryTag, multiple );
    }
};
inline Packer<Ack> serializable(Ack& x) { return Packer<Ack>(x); }
std::ostream& operator << (std::ostream&, const Ack&);
bool operator==(const Ack&, const Ack&);

struct Reject:
    public Command
{
    Uint64 deliveryTag;
    Bit requeue;
    
    static const char* NAME;
    static const uint8_t CODE=0xd;
    static const uint8_t CLASS_CODE=file::CODE;
    static const char* CLASS_NAME;
    Reject();
    Reject(
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<Bit>::param_type requeue_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(deliveryTag)(requeue);
    }
    
    struct Handler
    {
        void fileReject(
            call_traits<Uint64>::param_type deliveryTag_,
            call_traits<Bit>::param_type requeue_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.fileReject(deliveryTag, requeue );
    }
};
inline Packer<Reject> serializable(Reject& x) { return Packer<Reject>(x); }
std::ostream& operator << (std::ostream&, const Reject&);
bool operator==(const Reject&, const Reject&);

} // namespace file


namespace stream {


struct StreamProperties:
    public Struct
{
    Str8 contentType;
    Str8 contentEncoding;
    Map headers;
    Uint8 priority;
    Datetime timestamp;
    
    static const char* NAME;
    static const uint8_t SIZE=4;
    static const uint8_t PACK=2;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    StreamProperties();
    StreamProperties(
        call_traits<Str8>::param_type contentType_,
        call_traits<Str8>::param_type contentEncoding_,
        call_traits<Map>::param_type headers_,
        call_traits<Uint8>::param_type priority_,
        call_traits<Datetime>::param_type timestamp_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(contentType)(contentEncoding)(headers)(priority)(timestamp);
    }
    
};
inline Packer<StreamProperties> serializable(StreamProperties& x) { return Packer<StreamProperties>(x); }
std::ostream& operator << (std::ostream&, const StreamProperties&);
bool operator==(const StreamProperties&, const StreamProperties&);

struct Qos:
    public Command
{
    Uint32 prefetchSize;
    Uint16 prefetchCount;
    Uint32 consumeRate;
    Bit global;
    
    static const char* NAME;
    static const uint8_t CODE=0x1;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    Qos();
    Qos(
        call_traits<Uint32>::param_type prefetchSize_,
        call_traits<Uint16>::param_type prefetchCount_,
        call_traits<Uint32>::param_type consumeRate_,
        call_traits<Bit>::param_type global_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(prefetchSize)(prefetchCount)(consumeRate)(global);
    }
    
    struct Handler
    {
        void streamQos(
            call_traits<Uint32>::param_type prefetchSize_,
            call_traits<Uint16>::param_type prefetchCount_,
            call_traits<Uint32>::param_type consumeRate_,
            call_traits<Bit>::param_type global_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamQos(prefetchSize, prefetchCount, consumeRate, global );
    }
};
inline Packer<Qos> serializable(Qos& x) { return Packer<Qos>(x); }
std::ostream& operator << (std::ostream&, const Qos&);
bool operator==(const Qos&, const Qos&);

struct QosOk:
    public Command
{
    
    static const char* NAME;
    static const uint8_t CODE=0x2;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    QosOk();
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S&) {}
    
    struct Handler
    {
        void streamQosOk(
            
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamQosOk( );
    }
};
inline Packer<QosOk> serializable(QosOk& x) { return Packer<QosOk>(x); }
std::ostream& operator << (std::ostream&, const QosOk&);
bool operator==(const QosOk&, const QosOk&);

struct Consume:
    public Command
{
    queue::Name queue;
    Str8 consumerTag;
    Bit noLocal;
    Bit exclusive;
    Bit nowait;
    Map arguments;
    
    static const char* NAME;
    static const uint8_t CODE=0x3;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    Consume();
    Consume(
        call_traits<queue::Name>::param_type queue_,
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Bit>::param_type noLocal_,
        call_traits<Bit>::param_type exclusive_,
        call_traits<Bit>::param_type nowait_,
        call_traits<Map>::param_type arguments_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(queue)(consumerTag)(noLocal)(exclusive)(nowait)(arguments);
    }
    
    struct Handler
    {
        void streamConsume(
            call_traits<queue::Name>::param_type queue_,
            call_traits<Str8>::param_type consumerTag_,
            call_traits<Bit>::param_type noLocal_,
            call_traits<Bit>::param_type exclusive_,
            call_traits<Bit>::param_type nowait_,
            call_traits<Map>::param_type arguments_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamConsume(queue, consumerTag, noLocal, exclusive, nowait, arguments );
    }
};
inline Packer<Consume> serializable(Consume& x) { return Packer<Consume>(x); }
std::ostream& operator << (std::ostream&, const Consume&);
bool operator==(const Consume&, const Consume&);

struct ConsumeOk:
    public Command
{
    Str8 consumerTag;
    
    static const char* NAME;
    static const uint8_t CODE=0x4;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    ConsumeOk();
    ConsumeOk(call_traits<Str8>::param_type consumerTag_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(consumerTag);
    }
    
    struct Handler
    {
        void streamConsumeOk(
            call_traits<Str8>::param_type consumerTag_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamConsumeOk(consumerTag );
    }
};
inline Packer<ConsumeOk> serializable(ConsumeOk& x) { return Packer<ConsumeOk>(x); }
std::ostream& operator << (std::ostream&, const ConsumeOk&);
bool operator==(const ConsumeOk&, const ConsumeOk&);

struct Cancel:
    public Command
{
    Str8 consumerTag;
    
    static const char* NAME;
    static const uint8_t CODE=0x5;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    Cancel();
    Cancel(call_traits<Str8>::param_type consumerTag_);
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(consumerTag);
    }
    
    struct Handler
    {
        void streamCancel(
            call_traits<Str8>::param_type consumerTag_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamCancel(consumerTag );
    }
};
inline Packer<Cancel> serializable(Cancel& x) { return Packer<Cancel>(x); }
std::ostream& operator << (std::ostream&, const Cancel&);
bool operator==(const Cancel&, const Cancel&);

struct Publish:
    public Command
{
    exchange::Name exchange;
    Str8 routingKey;
    Bit mandatory;
    Bit immediate;
    
    static const char* NAME;
    static const uint8_t CODE=0x6;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    Publish();
    Publish(
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_,
        call_traits<Bit>::param_type mandatory_,
        call_traits<Bit>::param_type immediate_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(exchange)(routingKey)(mandatory)(immediate);
    }
    
    struct Handler
    {
        void streamPublish(
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type routingKey_,
            call_traits<Bit>::param_type mandatory_,
            call_traits<Bit>::param_type immediate_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamPublish(exchange, routingKey, mandatory, immediate );
    }
};
inline Packer<Publish> serializable(Publish& x) { return Packer<Publish>(x); }
std::ostream& operator << (std::ostream&, const Publish&);
bool operator==(const Publish&, const Publish&);

struct Return:
    public Command
{
    ReturnCode replyCode;
    Str8 replyText;
    exchange::Name exchange;
    Str8 routingKey;
    
    static const char* NAME;
    static const uint8_t CODE=0x7;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    Return();
    Return(
        call_traits<stream::ReturnCode>::param_type replyCode_,
        call_traits<Str8>::param_type replyText_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<Str8>::param_type routingKey_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(replyCode)(replyText)(exchange)(routingKey);
    }
    
    struct Handler
    {
        void streamReturn(
            call_traits<stream::ReturnCode>::param_type replyCode_,
            call_traits<Str8>::param_type replyText_,
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<Str8>::param_type routingKey_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamReturn(replyCode, replyText, exchange, routingKey );
    }
};
inline Packer<Return> serializable(Return& x) { return Packer<Return>(x); }
std::ostream& operator << (std::ostream&, const Return&);
bool operator==(const Return&, const Return&);

struct Deliver:
    public Command
{
    Str8 consumerTag;
    Uint64 deliveryTag;
    exchange::Name exchange;
    queue::Name queue;
    
    static const char* NAME;
    static const uint8_t CODE=0x8;
    static const uint8_t CLASS_CODE=stream::CODE;
    static const char* CLASS_NAME;
    Deliver();
    Deliver(
        call_traits<Str8>::param_type consumerTag_,
        call_traits<Uint64>::param_type deliveryTag_,
        call_traits<exchange::Name>::param_type exchange_,
        call_traits<queue::Name>::param_type queue_
    );
    void accept(Visitor&);
    void accept(ConstVisitor&) const;
    template <class S> void serialize(S& s) {
        s(consumerTag)(deliveryTag)(exchange)(queue);
    }
    
    struct Handler
    {
        void streamDeliver(
            call_traits<Str8>::param_type consumerTag_,
            call_traits<Uint64>::param_type deliveryTag_,
            call_traits<exchange::Name>::param_type exchange_,
            call_traits<queue::Name>::param_type queue_
        );
    };
    
    template <class T> void invoke(T& target)const
    {
        target.streamDeliver(consumerTag, deliveryTag, exchange, queue );
    }
};
inline Packer<Deliver> serializable(Deliver& x) { return Packer<Deliver>(x); }
std::ostream& operator << (std::ostream&, const Deliver&);
bool operator==(const Deliver&, const Deliver&);

} // namespace stream


}} // namespace qpid::amqp_0_10

#endif  /*!QPID_AMQP_0_10_SPECIFICATION_H*/
