#ifndef QPID_CLIENT_SESSION_99_0_H
#define QPID_CLIENT_SESSION_99_0_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/client/no_keyword/Session_99_0.h"

#define BOOST_PARAMETER_MAX_ARITY 8
#include <boost/parameter.hpp>


namespace qpid {
namespace client {


namespace arg {

BOOST_PARAMETER_KEYWORD(keyword_tags, realm)
BOOST_PARAMETER_KEYWORD(keyword_tags, exclusive)
BOOST_PARAMETER_KEYWORD(keyword_tags, passive)
BOOST_PARAMETER_KEYWORD(keyword_tags, active)
BOOST_PARAMETER_KEYWORD(keyword_tags, write)
BOOST_PARAMETER_KEYWORD(keyword_tags, read)
BOOST_PARAMETER_KEYWORD(keyword_tags, ticket)
BOOST_PARAMETER_KEYWORD(keyword_tags, exchange)
BOOST_PARAMETER_KEYWORD(keyword_tags, type)
BOOST_PARAMETER_KEYWORD(keyword_tags, alternateExchange)
BOOST_PARAMETER_KEYWORD(keyword_tags, durable)
BOOST_PARAMETER_KEYWORD(keyword_tags, autoDelete)
BOOST_PARAMETER_KEYWORD(keyword_tags, arguments)
BOOST_PARAMETER_KEYWORD(keyword_tags, ifUnused)
BOOST_PARAMETER_KEYWORD(keyword_tags, name)
BOOST_PARAMETER_KEYWORD(keyword_tags, queue)
BOOST_PARAMETER_KEYWORD(keyword_tags, routingKey)
BOOST_PARAMETER_KEYWORD(keyword_tags, ifEmpty)
BOOST_PARAMETER_KEYWORD(keyword_tags, prefetchSize)
BOOST_PARAMETER_KEYWORD(keyword_tags, prefetchCount)
BOOST_PARAMETER_KEYWORD(keyword_tags, global)
BOOST_PARAMETER_KEYWORD(keyword_tags, consumerTag)
BOOST_PARAMETER_KEYWORD(keyword_tags, noLocal)
BOOST_PARAMETER_KEYWORD(keyword_tags, noAck)
BOOST_PARAMETER_KEYWORD(keyword_tags, nowait)
BOOST_PARAMETER_KEYWORD(keyword_tags, rejectUnroutable)
BOOST_PARAMETER_KEYWORD(keyword_tags, immediate)
BOOST_PARAMETER_KEYWORD(keyword_tags, content)
BOOST_PARAMETER_KEYWORD(keyword_tags, deliveryTag)
BOOST_PARAMETER_KEYWORD(keyword_tags, multiple)
BOOST_PARAMETER_KEYWORD(keyword_tags, requeue)
BOOST_PARAMETER_KEYWORD(keyword_tags, filter)
BOOST_PARAMETER_KEYWORD(keyword_tags, identifier)
BOOST_PARAMETER_KEYWORD(keyword_tags, contentSize)
BOOST_PARAMETER_KEYWORD(keyword_tags, stagedSize)
BOOST_PARAMETER_KEYWORD(keyword_tags, mandatory)
BOOST_PARAMETER_KEYWORD(keyword_tags, consumeRate)
BOOST_PARAMETER_KEYWORD(keyword_tags, xid)
BOOST_PARAMETER_KEYWORD(keyword_tags, join)
BOOST_PARAMETER_KEYWORD(keyword_tags, resume)
BOOST_PARAMETER_KEYWORD(keyword_tags, fail)
BOOST_PARAMETER_KEYWORD(keyword_tags, suspend)
BOOST_PARAMETER_KEYWORD(keyword_tags, onePhase)
BOOST_PARAMETER_KEYWORD(keyword_tags, startscan)
BOOST_PARAMETER_KEYWORD(keyword_tags, endscan)
BOOST_PARAMETER_KEYWORD(keyword_tags, timeout)
BOOST_PARAMETER_KEYWORD(keyword_tags, metaData)
BOOST_PARAMETER_KEYWORD(keyword_tags, destination)
BOOST_PARAMETER_KEYWORD(keyword_tags, confirmMode)
BOOST_PARAMETER_KEYWORD(keyword_tags, acquireMode)
BOOST_PARAMETER_KEYWORD(keyword_tags, transfers)
BOOST_PARAMETER_KEYWORD(keyword_tags, code)
BOOST_PARAMETER_KEYWORD(keyword_tags, text)
BOOST_PARAMETER_KEYWORD(keyword_tags, mode)
BOOST_PARAMETER_KEYWORD(keyword_tags, reference)
BOOST_PARAMETER_KEYWORD(keyword_tags, bytes)
BOOST_PARAMETER_KEYWORD(keyword_tags, unit)
BOOST_PARAMETER_KEYWORD(keyword_tags, value)

} // namespace arg


/**
 * AMQP 99-0 session API with keyword arguments.
 * This class provides the same set of functions as no_keyword::Session_99_0, but also
 * allows parameters be passed using keywords. The keyword is the
 * parameter name in the namespace "arg".
 * 
 * For example given the normal function "foo(int x=0, int y=0, int z=0)"
 * you could call it in either of the following ways:
 * 
 * @code
 * session.foo(1,2,3);             // Normal no keywords
 * session.foo(arg::z=3, arg::x=1); // Keywords and a default
 * @endcode
 * 
 * The keyword functions are easy to use but their declarations are hard
 * to read. You may find it easier to read the documentation for no_keyword::Session_99_0
 * which provides the same set of functions using normal non-keyword
 * declarations.
 * 
 * \ingroup clientapi
 * 
 */
class Session_99_0:
    public no_keyword::Session_99_0
{
  private:
    Session_99_0(shared_ptr<SessionCore> core) : no_keyword::Session_99_0(core) {}
    typedef boost::parameter::parameters<arg::keyword_tags::realm,arg::keyword_tags::exclusive,arg::keyword_tags::passive,arg::keyword_tags::active,arg::keyword_tags::write,arg::keyword_tags::read> AccessRequestParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::exchange,arg::keyword_tags::type,arg::keyword_tags::alternateExchange,arg::keyword_tags::passive,arg::keyword_tags::durable,arg::keyword_tags::autoDelete,arg::keyword_tags::arguments> ExchangeDeclareParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::exchange,arg::keyword_tags::ifUnused> ExchangeDeleteParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::name> ExchangeQueryParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::alternateExchange,arg::keyword_tags::passive,arg::keyword_tags::durable,arg::keyword_tags::exclusive,arg::keyword_tags::autoDelete,arg::keyword_tags::arguments> QueueDeclareParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::exchange,arg::keyword_tags::routingKey,arg::keyword_tags::arguments> QueueBindParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::exchange,arg::keyword_tags::routingKey,arg::keyword_tags::arguments> QueueUnbindParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue> QueuePurgeParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::ifUnused,arg::keyword_tags::ifEmpty> QueueDeleteParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::queue> QueueQueryParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::prefetchSize,arg::keyword_tags::prefetchCount,arg::keyword_tags::global> BasicQosParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::consumerTag,arg::keyword_tags::noLocal,arg::keyword_tags::noAck,arg::keyword_tags::exclusive,arg::keyword_tags::nowait,arg::keyword_tags::arguments> BasicConsumeParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::consumerTag> BasicCancelParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::exchange,arg::keyword_tags::routingKey,arg::keyword_tags::rejectUnroutable,arg::keyword_tags::immediate,arg::keyword_tags::content> BasicPublishParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::noAck> BasicGetParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::deliveryTag,arg::keyword_tags::multiple> BasicAckParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::deliveryTag,arg::keyword_tags::requeue> BasicRejectParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::requeue> BasicRecoverParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::prefetchSize,arg::keyword_tags::prefetchCount,arg::keyword_tags::global> FileQosParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::consumerTag,arg::keyword_tags::noLocal,arg::keyword_tags::noAck,arg::keyword_tags::exclusive,arg::keyword_tags::nowait,arg::keyword_tags::filter> FileConsumeParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::consumerTag> FileCancelParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::identifier,arg::keyword_tags::contentSize> FileOpenParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::stagedSize> FileOpenOkParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::content> FileStageParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::exchange,arg::keyword_tags::routingKey,arg::keyword_tags::mandatory,arg::keyword_tags::immediate,arg::keyword_tags::identifier> FilePublishParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::deliveryTag,arg::keyword_tags::multiple> FileAckParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::deliveryTag,arg::keyword_tags::requeue> FileRejectParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::prefetchSize,arg::keyword_tags::prefetchCount,arg::keyword_tags::consumeRate,arg::keyword_tags::global> StreamQosParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::consumerTag,arg::keyword_tags::noLocal,arg::keyword_tags::exclusive,arg::keyword_tags::nowait,arg::keyword_tags::filter> StreamConsumeParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::consumerTag> StreamCancelParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::exchange,arg::keyword_tags::routingKey,arg::keyword_tags::mandatory,arg::keyword_tags::immediate,arg::keyword_tags::content> StreamPublishParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::xid,arg::keyword_tags::join,arg::keyword_tags::resume> DtxDemarcationStartParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::xid,arg::keyword_tags::fail,arg::keyword_tags::suspend> DtxDemarcationEndParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::xid,arg::keyword_tags::onePhase> DtxCoordinationCommitParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::xid> DtxCoordinationForgetParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::xid> DtxCoordinationGetTimeoutParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::xid> DtxCoordinationPrepareParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::startscan,arg::keyword_tags::endscan> DtxCoordinationRecoverParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::xid> DtxCoordinationRollbackParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::xid,arg::keyword_tags::timeout> DtxCoordinationSetTimeoutParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::metaData,arg::keyword_tags::content> TunnelRequestParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::destination,arg::keyword_tags::confirmMode,arg::keyword_tags::acquireMode,arg::keyword_tags::content> MessageTransferParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::transfers,arg::keyword_tags::code,arg::keyword_tags::text> MessageRejectParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::transfers,arg::keyword_tags::mode> MessageAcquireParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::transfers> MessageReleaseParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::destination,arg::keyword_tags::noLocal,arg::keyword_tags::confirmMode,arg::keyword_tags::acquireMode,arg::keyword_tags::exclusive,arg::keyword_tags::filter> MessageSubscribeParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::destination> MessageCancelParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::queue,arg::keyword_tags::destination,arg::keyword_tags::noAck> MessageGetParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::requeue> MessageRecoverParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::reference> MessageOpenParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::reference> MessageCloseParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::reference,arg::keyword_tags::bytes> MessageAppendParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::reference,arg::keyword_tags::identifier> MessageCheckpointParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::reference,arg::keyword_tags::identifier> MessageResumeParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::prefetchSize,arg::keyword_tags::prefetchCount,arg::keyword_tags::global> MessageQosParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::destination,arg::keyword_tags::mode> MessageFlowModeParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::destination,arg::keyword_tags::unit,arg::keyword_tags::value> MessageFlowParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::destination> MessageFlushParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::destination> MessageStopParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::value> MessageOffsetParameters;
    
    typedef boost::parameter::parameters<arg::keyword_tags::ticket,arg::keyword_tags::exchange,arg::keyword_tags::queue,arg::keyword_tags::routingKey,arg::keyword_tags::arguments> BindingQueryParameters;
    
    friend class Connection;
  public:
    Session_99_0() {}
    BOOST_PARAMETER_MEMFUN(Response, accessRequest, 0, 6, AccessRequestParameters) {
        return no_keyword::Session_99_0::accessRequest(
            p[arg::realm|string()],
            p[arg::exclusive|false],
            p[arg::passive|false],
            p[arg::active|false],
            p[arg::write|false],
            p[arg::read|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, exchangeDeclare, 0, 8, ExchangeDeclareParameters) {
        return no_keyword::Session_99_0::exchangeDeclare(
            p[arg::ticket|0],
            p[arg::exchange|string()],
            p[arg::type|string()],
            p[arg::alternateExchange|string()],
            p[arg::passive|false],
            p[arg::durable|false],
            p[arg::autoDelete|false],
            p[arg::arguments|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, exchangeDelete, 0, 3, ExchangeDeleteParameters) {
        return no_keyword::Session_99_0::exchangeDelete(
            p[arg::ticket|0],
            p[arg::exchange|string()],
            p[arg::ifUnused|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::ExchangeQueryResult>, exchangeQuery, 0, 2, ExchangeQueryParameters) {
        return no_keyword::Session_99_0::exchangeQuery(
            p[arg::ticket|0],
            p[arg::name|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, queueDeclare, 0, 8, QueueDeclareParameters) {
        return no_keyword::Session_99_0::queueDeclare(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::alternateExchange|string()],
            p[arg::passive|false],
            p[arg::durable|false],
            p[arg::exclusive|false],
            p[arg::autoDelete|false],
            p[arg::arguments|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, queueBind, 0, 5, QueueBindParameters) {
        return no_keyword::Session_99_0::queueBind(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::exchange|string()],
            p[arg::routingKey|string()],
            p[arg::arguments|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, queueUnbind, 0, 5, QueueUnbindParameters) {
        return no_keyword::Session_99_0::queueUnbind(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::exchange|string()],
            p[arg::routingKey|string()],
            p[arg::arguments|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, queuePurge, 0, 2, QueuePurgeParameters) {
        return no_keyword::Session_99_0::queuePurge(
            p[arg::ticket|0],
            p[arg::queue|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, queueDelete, 0, 4, QueueDeleteParameters) {
        return no_keyword::Session_99_0::queueDelete(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::ifUnused|false],
            p[arg::ifEmpty|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::QueueQueryResult>, queueQuery, 0, 1, QueueQueryParameters) {
        return no_keyword::Session_99_0::queueQuery(
            p[arg::queue|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, basicQos, 0, 3, BasicQosParameters) {
        return no_keyword::Session_99_0::basicQos(
            p[arg::prefetchSize|0],
            p[arg::prefetchCount|0],
            p[arg::global|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, basicConsume, 0, 8, BasicConsumeParameters) {
        return no_keyword::Session_99_0::basicConsume(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::consumerTag|string()],
            p[arg::noLocal|false],
            p[arg::noAck|false],
            p[arg::exclusive|false],
            p[arg::nowait|false],
            p[arg::arguments|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, basicCancel, 0, 1, BasicCancelParameters) {
        return no_keyword::Session_99_0::basicCancel(
            p[arg::consumerTag|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, basicPublish, 0, 6, BasicPublishParameters) {
        return no_keyword::Session_99_0::basicPublish(
            p[arg::ticket|0],
            p[arg::exchange|string()],
            p[arg::routingKey|string()],
            p[arg::rejectUnroutable|false],
            p[arg::immediate|false],
            p[arg::content|DefaultContent(std::string())]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, basicGet, 0, 3, BasicGetParameters) {
        return no_keyword::Session_99_0::basicGet(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::noAck|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, basicAck, 0, 2, BasicAckParameters) {
        return no_keyword::Session_99_0::basicAck(
            p[arg::deliveryTag|0],
            p[arg::multiple|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, basicReject, 0, 2, BasicRejectParameters) {
        return no_keyword::Session_99_0::basicReject(
            p[arg::deliveryTag|0],
            p[arg::requeue|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, basicRecover, 0, 1, BasicRecoverParameters) {
        return no_keyword::Session_99_0::basicRecover(
            p[arg::requeue|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, fileQos, 0, 3, FileQosParameters) {
        return no_keyword::Session_99_0::fileQos(
            p[arg::prefetchSize|0],
            p[arg::prefetchCount|0],
            p[arg::global|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, fileConsume, 0, 8, FileConsumeParameters) {
        return no_keyword::Session_99_0::fileConsume(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::consumerTag|string()],
            p[arg::noLocal|false],
            p[arg::noAck|false],
            p[arg::exclusive|false],
            p[arg::nowait|false],
            p[arg::filter|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, fileCancel, 0, 1, FileCancelParameters) {
        return no_keyword::Session_99_0::fileCancel(
            p[arg::consumerTag|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, fileOpen, 0, 2, FileOpenParameters) {
        return no_keyword::Session_99_0::fileOpen(
            p[arg::identifier|string()],
            p[arg::contentSize|0]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, fileOpenOk, 0, 1, FileOpenOkParameters) {
        return no_keyword::Session_99_0::fileOpenOk(
            p[arg::stagedSize|0]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, fileStage, 0, 1, FileStageParameters) {
        return no_keyword::Session_99_0::fileStage(
            p[arg::content|DefaultContent(std::string())]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, filePublish, 0, 6, FilePublishParameters) {
        return no_keyword::Session_99_0::filePublish(
            p[arg::ticket|0],
            p[arg::exchange|string()],
            p[arg::routingKey|string()],
            p[arg::mandatory|false],
            p[arg::immediate|false],
            p[arg::identifier|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, fileAck, 0, 2, FileAckParameters) {
        return no_keyword::Session_99_0::fileAck(
            p[arg::deliveryTag|0],
            p[arg::multiple|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, fileReject, 0, 2, FileRejectParameters) {
        return no_keyword::Session_99_0::fileReject(
            p[arg::deliveryTag|0],
            p[arg::requeue|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, streamQos, 0, 4, StreamQosParameters) {
        return no_keyword::Session_99_0::streamQos(
            p[arg::prefetchSize|0],
            p[arg::prefetchCount|0],
            p[arg::consumeRate|0],
            p[arg::global|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, streamConsume, 0, 7, StreamConsumeParameters) {
        return no_keyword::Session_99_0::streamConsume(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::consumerTag|string()],
            p[arg::noLocal|false],
            p[arg::exclusive|false],
            p[arg::nowait|false],
            p[arg::filter|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, streamCancel, 0, 1, StreamCancelParameters) {
        return no_keyword::Session_99_0::streamCancel(
            p[arg::consumerTag|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, streamPublish, 0, 6, StreamPublishParameters) {
        return no_keyword::Session_99_0::streamPublish(
            p[arg::ticket|0],
            p[arg::exchange|string()],
            p[arg::routingKey|string()],
            p[arg::mandatory|false],
            p[arg::immediate|false],
            p[arg::content|DefaultContent(std::string())]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::DtxDemarcationStartResult>, dtxDemarcationStart, 0, 4, DtxDemarcationStartParameters) {
        return no_keyword::Session_99_0::dtxDemarcationStart(
            p[arg::ticket|0],
            p[arg::xid|string()],
            p[arg::join|false],
            p[arg::resume|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::DtxDemarcationEndResult>, dtxDemarcationEnd, 0, 4, DtxDemarcationEndParameters) {
        return no_keyword::Session_99_0::dtxDemarcationEnd(
            p[arg::ticket|0],
            p[arg::xid|string()],
            p[arg::fail|false],
            p[arg::suspend|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::DtxCoordinationCommitResult>, dtxCoordinationCommit, 0, 3, DtxCoordinationCommitParameters) {
        return no_keyword::Session_99_0::dtxCoordinationCommit(
            p[arg::ticket|0],
            p[arg::xid|string()],
            p[arg::onePhase|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, dtxCoordinationForget, 0, 2, DtxCoordinationForgetParameters) {
        return no_keyword::Session_99_0::dtxCoordinationForget(
            p[arg::ticket|0],
            p[arg::xid|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::DtxCoordinationGetTimeoutResult>, dtxCoordinationGetTimeout, 0, 1, DtxCoordinationGetTimeoutParameters) {
        return no_keyword::Session_99_0::dtxCoordinationGetTimeout(
            p[arg::xid|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::DtxCoordinationPrepareResult>, dtxCoordinationPrepare, 0, 2, DtxCoordinationPrepareParameters) {
        return no_keyword::Session_99_0::dtxCoordinationPrepare(
            p[arg::ticket|0],
            p[arg::xid|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::DtxCoordinationRecoverResult>, dtxCoordinationRecover, 0, 3, DtxCoordinationRecoverParameters) {
        return no_keyword::Session_99_0::dtxCoordinationRecover(
            p[arg::ticket|0],
            p[arg::startscan|false],
            p[arg::endscan|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::DtxCoordinationRollbackResult>, dtxCoordinationRollback, 0, 2, DtxCoordinationRollbackParameters) {
        return no_keyword::Session_99_0::dtxCoordinationRollback(
            p[arg::ticket|0],
            p[arg::xid|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, dtxCoordinationSetTimeout, 0, 3, DtxCoordinationSetTimeoutParameters) {
        return no_keyword::Session_99_0::dtxCoordinationSetTimeout(
            p[arg::ticket|0],
            p[arg::xid|string()],
            p[arg::timeout|0]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, tunnelRequest, 0, 2, TunnelRequestParameters) {
        return no_keyword::Session_99_0::tunnelRequest(
            p[arg::metaData|FieldTable()],
            p[arg::content|DefaultContent(std::string())]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageTransfer, 0, 5, MessageTransferParameters) {
        return no_keyword::Session_99_0::messageTransfer(
            p[arg::ticket|0],
            p[arg::destination|string()],
            p[arg::confirmMode|0],
            p[arg::acquireMode|0],
            p[arg::content|DefaultContent(std::string())]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageReject, 0, 3, MessageRejectParameters) {
        return no_keyword::Session_99_0::messageReject(
            p[arg::transfers|SequenceNumberSet()],
            p[arg::code|0],
            p[arg::text|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageAcquire, 0, 2, MessageAcquireParameters) {
        return no_keyword::Session_99_0::messageAcquire(
            p[arg::transfers|SequenceNumberSet()],
            p[arg::mode|0]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageRelease, 0, 1, MessageReleaseParameters) {
        return no_keyword::Session_99_0::messageRelease(
            p[arg::transfers|SequenceNumberSet()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageSubscribe, 0, 8, MessageSubscribeParameters) {
        return no_keyword::Session_99_0::messageSubscribe(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::destination|string()],
            p[arg::noLocal|false],
            p[arg::confirmMode|0],
            p[arg::acquireMode|0],
            p[arg::exclusive|false],
            p[arg::filter|FieldTable()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageCancel, 0, 1, MessageCancelParameters) {
        return no_keyword::Session_99_0::messageCancel(
            p[arg::destination|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, messageGet, 0, 4, MessageGetParameters) {
        return no_keyword::Session_99_0::messageGet(
            p[arg::ticket|0],
            p[arg::queue|string()],
            p[arg::destination|string()],
            p[arg::noAck|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageRecover, 0, 1, MessageRecoverParameters) {
        return no_keyword::Session_99_0::messageRecover(
            p[arg::requeue|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageOpen, 0, 1, MessageOpenParameters) {
        return no_keyword::Session_99_0::messageOpen(
            p[arg::reference|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageClose, 0, 1, MessageCloseParameters) {
        return no_keyword::Session_99_0::messageClose(
            p[arg::reference|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageAppend, 0, 2, MessageAppendParameters) {
        return no_keyword::Session_99_0::messageAppend(
            p[arg::reference|string()],
            p[arg::bytes|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageCheckpoint, 0, 2, MessageCheckpointParameters) {
        return no_keyword::Session_99_0::messageCheckpoint(
            p[arg::reference|string()],
            p[arg::identifier|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Response, messageResume, 0, 2, MessageResumeParameters) {
        return no_keyword::Session_99_0::messageResume(
            p[arg::reference|string()],
            p[arg::identifier|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageQos, 0, 3, MessageQosParameters) {
        return no_keyword::Session_99_0::messageQos(
            p[arg::prefetchSize|0],
            p[arg::prefetchCount|0],
            p[arg::global|false]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageFlowMode, 0, 2, MessageFlowModeParameters) {
        return no_keyword::Session_99_0::messageFlowMode(
            p[arg::destination|string()],
            p[arg::mode|0]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageFlow, 0, 3, MessageFlowParameters) {
        return no_keyword::Session_99_0::messageFlow(
            p[arg::destination|string()],
            p[arg::unit|0],
            p[arg::value|0]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageFlush, 0, 1, MessageFlushParameters) {
        return no_keyword::Session_99_0::messageFlush(
            p[arg::destination|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageStop, 0, 1, MessageStopParameters) {
        return no_keyword::Session_99_0::messageStop(
            p[arg::destination|string()]);
    }
    
    BOOST_PARAMETER_MEMFUN(Completion, messageOffset, 0, 1, MessageOffsetParameters) {
        return no_keyword::Session_99_0::messageOffset(
            p[arg::value|0]);
    }
    
    BOOST_PARAMETER_MEMFUN(TypedResult<qpid::framing::BindingQueryResult>, bindingQuery, 0, 5, BindingQueryParameters) {
        return no_keyword::Session_99_0::bindingQuery(
            p[arg::ticket|0],
            p[arg::exchange|string()],
            p[arg::queue|string()],
            p[arg::routingKey|string()],
            p[arg::arguments|FieldTable()]);
    }
    
};

}} // namespace qpid::client

#endif  /*!QPID_CLIENT_SESSION_99_0_H*/
