#ifndef QPID_FRAMING_ACCESSREQUESTBODY_H
#define QPID_FRAMING_ACCESSREQUESTBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class AccessRequestBody : public AMQMethodBody {
    string realm;
    bool exclusive;
    bool passive;
    bool active;
    bool write;
    bool read;
public:
    static const ClassId CLASS_ID = 30;
    static const MethodId METHOD_ID = 10;
    AccessRequestBody(
        ProtocolVersion, const string& _realm,
        bool _exclusive,
        bool _passive,
        bool _active,
        bool _write,
        bool _read) : 
         realm(_realm),
         exclusive(_exclusive),
         passive(_passive),
         active(_active),
         write(_write),
         read(_read){}
    AccessRequestBody(ProtocolVersion=ProtocolVersion())  : exclusive(0), passive(0), active(0), write(0), read(0) {}
    
    void setRealm(const string& _realm) { realm = _realm; }
    const string& getRealm() const { return realm; }
    void setExclusive(bool _exclusive) { exclusive = _exclusive; }
    bool getExclusive() const { return exclusive; }
    void setPassive(bool _passive) { passive = _passive; }
    bool getPassive() const { return passive; }
    void setActive(bool _active) { active = _active; }
    bool getActive() const { return active; }
    void setWrite(bool _write) { write = _write; }
    bool getWrite() const { return write; }
    void setRead(bool _read) { read = _read; }
    bool getRead() const { return read; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.request(getRealm(), getExclusive(), getPassive(), getActive(), getWrite(), getRead());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  true; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class AccessRequestBody */

}}
#endif  /*!QPID_FRAMING_ACCESSREQUESTBODY_H*/
