#ifndef QPID_FRAMING_BASICREJECTBODY_H
#define QPID_FRAMING_BASICREJECTBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class BasicRejectBody : public AMQMethodBody {
    uint64_t deliveryTag;
    bool requeue;
public:
    static const ClassId CLASS_ID = 60;
    static const MethodId METHOD_ID = 90;
    BasicRejectBody(
        ProtocolVersion, uint64_t _deliveryTag,
        bool _requeue) : 
         deliveryTag(_deliveryTag),
         requeue(_requeue){}
    BasicRejectBody(ProtocolVersion=ProtocolVersion())  : deliveryTag(0), requeue(0) {}
    
    void setDeliveryTag(uint64_t _deliveryTag) { deliveryTag = _deliveryTag; }
    uint64_t getDeliveryTag() const { return deliveryTag; }
    void setRequeue(bool _requeue) { requeue = _requeue; }
    bool getRequeue() const { return requeue; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.reject(getDeliveryTag(), getRequeue());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class BasicRejectBody */

}}
#endif  /*!QPID_FRAMING_BASICREJECTBODY_H*/
