#ifndef QPID_FRAMING_CLIENTINVOKER_H
#define QPID_FRAMING_CLIENTINVOKER_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQP_ClientOperations.h"
#include "qpid/framing/Invoker.h"

namespace qpid {
namespace framing {


class AMQP_ClientOperations::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations& target;
  public:
    Invoker(AMQP_ClientOperations& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const ConnectionStartBody& body);
    void visit(const ConnectionSecureBody& body);
    void visit(const ConnectionTuneBody& body);
    void visit(const ConnectionOpenOkBody& body);
    void visit(const ConnectionRedirectBody& body);
    void visit(const ConnectionCloseBody& body);
    void visit(const ConnectionCloseOkBody& body);
    void visit(const SessionAttachedBody& body);
    void visit(const SessionFlowBody& body);
    void visit(const SessionFlowOkBody& body);
    void visit(const SessionCloseBody& body);
    void visit(const SessionClosedBody& body);
    void visit(const SessionDetachedBody& body);
    void visit(const SessionAckBody& body);
    void visit(const SessionHighWaterMarkBody& body);
    void visit(const SessionSolicitAckBody& body);
    void visit(const AccessRequestOkBody& body);
    void visit(const BasicConsumeOkBody& body);
    void visit(const BasicGetEmptyBody& body);
    void visit(const FileQosOkBody& body);
    void visit(const FileConsumeOkBody& body);
    void visit(const FileOpenBody& body);
    void visit(const FileOpenOkBody& body);
    void visit(const FileDeliverBody& body);
    void visit(const StreamQosOkBody& body);
    void visit(const StreamConsumeOkBody& body);
    void visit(const MessageRejectBody& body);
    void visit(const MessageAcquiredBody& body);
    void visit(const MessageReleaseBody& body);
    void visit(const MessageOpenBody& body);
    void visit(const MessageCloseBody& body);
    void visit(const MessageAppendBody& body);
    void visit(const MessageCheckpointBody& body);
    void visit(const MessageResumeBody& body);
    void visit(const MessageFlowModeBody& body);
    void visit(const MessageFlowBody& body);
    void visit(const MessageStopBody& body);
    void visit(const MessageEmptyBody& body);
    void visit(const MessageOffsetBody& body);
    void visit(const ExecutionFlushBody& body);
    void visit(const ExecutionCompleteBody& body);
    void visit(const ExecutionNoopBody& body);
    void visit(const ExecutionResultBody& body);
    void visit(const ExecutionSyncBody& body);
    void visit(const Connection010StartBody& body);
    void visit(const Connection010SecureBody& body);
    void visit(const Connection010TuneBody& body);
    void visit(const Connection010OpenOkBody& body);
    void visit(const Connection010RedirectBody& body);
    void visit(const Connection010CloseBody& body);
    void visit(const Connection010CloseOkBody& body);
    void visit(const Session010AttachBody& body);
    void visit(const Session010AttachedBody& body);
    void visit(const Session010DetachBody& body);
    void visit(const Session010DetachedBody& body);
    void visit(const Session010RequestTimeoutBody& body);
    void visit(const Session010TimeoutBody& body);
    void visit(const Session010CommandPointBody& body);
    void visit(const Session010ExpectedBody& body);
    void visit(const Session010ConfirmedBody& body);
    void visit(const Session010CompletedBody& body);
    void visit(const Session010KnownCompletedBody& body);
    void visit(const Session010FlushBody& body);
    void visit(const Session010GapBody& body);
    void visit(const Execution010SyncBody& body);
    void visit(const Execution010ResultBody& body);
    void visit(const Execution010ExceptionBody& body);
    void visit(const Message010TransferBody& body);
    void visit(const Message010AcceptBody& body);
    void visit(const Message010RejectBody& body);
};

class AMQP_ClientOperations::ConnectionHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::ConnectionHandler& target;
  public:
    Invoker(AMQP_ClientOperations::ConnectionHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const ConnectionStartBody& body);
    void visit(const ConnectionSecureBody& body);
    void visit(const ConnectionTuneBody& body);
    void visit(const ConnectionOpenOkBody& body);
    void visit(const ConnectionRedirectBody& body);
    void visit(const ConnectionCloseBody& body);
    void visit(const ConnectionCloseOkBody& body);
};

class AMQP_ClientOperations::SessionHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::SessionHandler& target;
  public:
    Invoker(AMQP_ClientOperations::SessionHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const SessionAttachedBody& body);
    void visit(const SessionFlowBody& body);
    void visit(const SessionFlowOkBody& body);
    void visit(const SessionCloseBody& body);
    void visit(const SessionClosedBody& body);
    void visit(const SessionDetachedBody& body);
    void visit(const SessionAckBody& body);
    void visit(const SessionHighWaterMarkBody& body);
    void visit(const SessionSolicitAckBody& body);
};

class AMQP_ClientOperations::AccessHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::AccessHandler& target;
  public:
    Invoker(AMQP_ClientOperations::AccessHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const AccessRequestOkBody& body);
};

class AMQP_ClientOperations::BasicHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::BasicHandler& target;
  public:
    Invoker(AMQP_ClientOperations::BasicHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const BasicConsumeOkBody& body);
    void visit(const BasicGetEmptyBody& body);
};

class AMQP_ClientOperations::FileHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::FileHandler& target;
  public:
    Invoker(AMQP_ClientOperations::FileHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const FileQosOkBody& body);
    void visit(const FileConsumeOkBody& body);
    void visit(const FileOpenBody& body);
    void visit(const FileOpenOkBody& body);
    void visit(const FileDeliverBody& body);
};

class AMQP_ClientOperations::StreamHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::StreamHandler& target;
  public:
    Invoker(AMQP_ClientOperations::StreamHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const StreamQosOkBody& body);
    void visit(const StreamConsumeOkBody& body);
};

class AMQP_ClientOperations::MessageHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::MessageHandler& target;
  public:
    Invoker(AMQP_ClientOperations::MessageHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const MessageRejectBody& body);
    void visit(const MessageAcquiredBody& body);
    void visit(const MessageReleaseBody& body);
    void visit(const MessageOpenBody& body);
    void visit(const MessageCloseBody& body);
    void visit(const MessageAppendBody& body);
    void visit(const MessageCheckpointBody& body);
    void visit(const MessageResumeBody& body);
    void visit(const MessageFlowModeBody& body);
    void visit(const MessageFlowBody& body);
    void visit(const MessageStopBody& body);
    void visit(const MessageEmptyBody& body);
    void visit(const MessageOffsetBody& body);
};

class AMQP_ClientOperations::ExecutionHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::ExecutionHandler& target;
  public:
    Invoker(AMQP_ClientOperations::ExecutionHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const ExecutionFlushBody& body);
    void visit(const ExecutionCompleteBody& body);
    void visit(const ExecutionNoopBody& body);
    void visit(const ExecutionResultBody& body);
    void visit(const ExecutionSyncBody& body);
};

class AMQP_ClientOperations::Connection010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::Connection010Handler& target;
  public:
    Invoker(AMQP_ClientOperations::Connection010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Connection010StartBody& body);
    void visit(const Connection010SecureBody& body);
    void visit(const Connection010TuneBody& body);
    void visit(const Connection010OpenOkBody& body);
    void visit(const Connection010RedirectBody& body);
    void visit(const Connection010CloseBody& body);
    void visit(const Connection010CloseOkBody& body);
};

class AMQP_ClientOperations::Session010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::Session010Handler& target;
  public:
    Invoker(AMQP_ClientOperations::Session010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Session010AttachBody& body);
    void visit(const Session010AttachedBody& body);
    void visit(const Session010DetachBody& body);
    void visit(const Session010DetachedBody& body);
    void visit(const Session010RequestTimeoutBody& body);
    void visit(const Session010TimeoutBody& body);
    void visit(const Session010CommandPointBody& body);
    void visit(const Session010ExpectedBody& body);
    void visit(const Session010ConfirmedBody& body);
    void visit(const Session010CompletedBody& body);
    void visit(const Session010KnownCompletedBody& body);
    void visit(const Session010FlushBody& body);
    void visit(const Session010GapBody& body);
};

class AMQP_ClientOperations::Execution010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::Execution010Handler& target;
  public:
    Invoker(AMQP_ClientOperations::Execution010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Execution010SyncBody& body);
    void visit(const Execution010ResultBody& body);
    void visit(const Execution010ExceptionBody& body);
};

class AMQP_ClientOperations::Message010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ClientOperations::Message010Handler& target;
  public:
    Invoker(AMQP_ClientOperations::Message010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Message010TransferBody& body);
    void visit(const Message010AcceptBody& body);
    void visit(const Message010RejectBody& body);
};

}} // namespace qpid::framing

#endif  /*!QPID_FRAMING_CLIENTINVOKER_H*/
