#ifndef QPID_FRAMING_CONNECTION010CLOSEBODY_H
#define QPID_FRAMING_CONNECTION010CLOSEBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class Connection010CloseBody : public AMQMethodBody {
    uint16_t replyCode;
    string replyText;
    uint16_t classId;
    uint16_t methodId;
    uint16_t flags;
public:
    static const ClassId CLASS_ID = 1;
    static const MethodId METHOD_ID = 11;
    Connection010CloseBody(
        ProtocolVersion, uint16_t _replyCode,
        const string& _replyText,
        uint16_t _classId,
        uint16_t _methodId) : 
        replyCode(_replyCode),
        replyText(_replyText),
        classId(_classId),
        methodId(_methodId),
        flags(0){
        flags |= (1 << 8);
        flags |= (1 << 9);
        flags |= (1 << 10);
        flags |= (1 << 11);
    }
    Connection010CloseBody(ProtocolVersion=ProtocolVersion())  : replyCode(0), classId(0), methodId(0), flags(0) {}
    
    void setReplyCode(uint16_t _replyCode);
    uint16_t getReplyCode() const;
    bool hasReplyCode() const;
    void clearReplyCodeFlag();
    void setReplyText(const string& _replyText);
    const string& getReplyText() const;
    bool hasReplyText() const;
    void clearReplyTextFlag();
    void setClassId(uint16_t _classId);
    uint16_t getClassId() const;
    bool hasClassId() const;
    void clearClassIdFlag();
    void setMethodId(uint16_t _methodId);
    uint16_t getMethodId() const;
    bool hasMethodId() const;
    void clearMethodIdFlag();
virtual uint8_t type() const { return 0;/*control segment*/ }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.close(getReplyCode(), getReplyText(), getClassId(), getMethodId());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  true; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class Connection010CloseBody */

}}
#endif  /*!QPID_FRAMING_CONNECTION010CLOSEBODY_H*/
