#ifndef QPID_FRAMING_CONNECTIONCLOSEBODY_H
#define QPID_FRAMING_CONNECTIONCLOSEBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class ConnectionCloseBody : public AMQMethodBody {
    uint16_t replyCode;
    string replyText;
    uint16_t classId;
    uint16_t methodId;
public:
    static const ClassId CLASS_ID = 10;
    static const MethodId METHOD_ID = 50;
    ConnectionCloseBody(
        ProtocolVersion, uint16_t _replyCode,
        const string& _replyText,
        uint16_t _classId,
        uint16_t _methodId) : 
         replyCode(_replyCode),
         replyText(_replyText),
         classId(_classId),
         methodId(_methodId){}
    ConnectionCloseBody(ProtocolVersion=ProtocolVersion())  : replyCode(0), classId(0), methodId(0) {}
    
    void setReplyCode(uint16_t _replyCode) { replyCode = _replyCode; }
    uint16_t getReplyCode() const { return replyCode; }
    void setReplyText(const string& _replyText) { replyText = _replyText; }
    const string& getReplyText() const { return replyText; }
    void setClassId(uint16_t _classId) { classId = _classId; }
    uint16_t getClassId() const { return classId; }
    void setMethodId(uint16_t _methodId) { methodId = _methodId; }
    uint16_t getMethodId() const { return methodId; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.close(getReplyCode(), getReplyText(), getClassId(), getMethodId());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  true; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class ConnectionCloseBody */

}}
#endif  /*!QPID_FRAMING_CONNECTIONCLOSEBODY_H*/
