#ifndef QPID_FRAMING_CONNECTIONOPENBODY_H
#define QPID_FRAMING_CONNECTIONOPENBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class ConnectionOpenBody : public AMQMethodBody {
    string virtualHost;
    string capabilities;
    bool insist;
public:
    static const ClassId CLASS_ID = 10;
    static const MethodId METHOD_ID = 40;
    ConnectionOpenBody(
        ProtocolVersion, const string& _virtualHost,
        const string& _capabilities,
        bool _insist) : 
         virtualHost(_virtualHost),
         capabilities(_capabilities),
         insist(_insist){}
    ConnectionOpenBody(ProtocolVersion=ProtocolVersion())  : insist(0) {}
    
    void setVirtualHost(const string& _virtualHost) { virtualHost = _virtualHost; }
    const string& getVirtualHost() const { return virtualHost; }
    void setCapabilities(const string& _capabilities) { capabilities = _capabilities; }
    const string& getCapabilities() const { return capabilities; }
    void setInsist(bool _insist) { insist = _insist; }
    bool getInsist() const { return insist; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.open(getVirtualHost(), getCapabilities(), getInsist());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  true; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class ConnectionOpenBody */

}}
#endif  /*!QPID_FRAMING_CONNECTIONOPENBODY_H*/
