#ifndef QPID_FRAMING_CONNECTIONSTARTBODY_H
#define QPID_FRAMING_CONNECTIONSTARTBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class ConnectionStartBody : public AMQMethodBody {
    uint8_t versionMajor;
    uint8_t versionMinor;
    FieldTable serverProperties;
    string mechanisms;
    string locales;
public:
    static const ClassId CLASS_ID = 10;
    static const MethodId METHOD_ID = 10;
    ConnectionStartBody(
        ProtocolVersion, uint8_t _versionMajor,
        uint8_t _versionMinor,
        const FieldTable& _serverProperties,
        const string& _mechanisms,
        const string& _locales) : 
         versionMajor(_versionMajor),
         versionMinor(_versionMinor),
         serverProperties(_serverProperties),
         mechanisms(_mechanisms),
         locales(_locales){}
    ConnectionStartBody(ProtocolVersion=ProtocolVersion())  : versionMajor(0), versionMinor(0) {}
    
    void setVersionMajor(uint8_t _versionMajor) { versionMajor = _versionMajor; }
    uint8_t getVersionMajor() const { return versionMajor; }
    void setVersionMinor(uint8_t _versionMinor) { versionMinor = _versionMinor; }
    uint8_t getVersionMinor() const { return versionMinor; }
    void setServerProperties(const FieldTable& _serverProperties) { serverProperties = _serverProperties; }
    const FieldTable& getServerProperties() const { return serverProperties; }
    FieldTable& getServerProperties() { return serverProperties; }
    void setMechanisms(const string& _mechanisms) { mechanisms = _mechanisms; }
    const string& getMechanisms() const { return mechanisms; }
    void setLocales(const string& _locales) { locales = _locales; }
    const string& getLocales() const { return locales; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.start(getVersionMajor(), getVersionMinor(), getServerProperties(), getMechanisms(), getLocales());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  true; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class ConnectionStartBody */

}}
#endif  /*!QPID_FRAMING_CONNECTIONSTARTBODY_H*/
