#ifndef QPID_FRAMING_EXCHANGEDECLAREBODY_H
#define QPID_FRAMING_EXCHANGEDECLAREBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class ExchangeDeclareBody : public AMQMethodBody {
    uint16_t ticket;
    string exchange;
    string type;
    string alternateExchange;
    bool passive;
    bool durable;
    bool autoDelete;
    FieldTable arguments;
public:
    static const ClassId CLASS_ID = 40;
    static const MethodId METHOD_ID = 10;
    ExchangeDeclareBody(
        ProtocolVersion, uint16_t _ticket,
        const string& _exchange,
        const string& _type,
        const string& _alternateExchange,
        bool _passive,
        bool _durable,
        bool _autoDelete,
        const FieldTable& _arguments) : 
         ticket(_ticket),
         exchange(_exchange),
         type(_type),
         alternateExchange(_alternateExchange),
         passive(_passive),
         durable(_durable),
         autoDelete(_autoDelete),
         arguments(_arguments){}
    ExchangeDeclareBody(ProtocolVersion=ProtocolVersion())  : ticket(0), passive(0), durable(0), autoDelete(0) {}
    
    void setTicket(uint16_t _ticket) { ticket = _ticket; }
    uint16_t getTicket() const { return ticket; }
    void setExchange(const string& _exchange) { exchange = _exchange; }
    const string& getExchange() const { return exchange; }
    void setType(const string& _type) { type = _type; }
    const string& getType() const { return type; }
    void setAlternateExchange(const string& _alternateExchange) { alternateExchange = _alternateExchange; }
    const string& getAlternateExchange() const { return alternateExchange; }
    void setPassive(bool _passive) { passive = _passive; }
    bool getPassive() const { return passive; }
    void setDurable(bool _durable) { durable = _durable; }
    bool getDurable() const { return durable; }
    void setAutoDelete(bool _autoDelete) { autoDelete = _autoDelete; }
    bool getAutoDelete() const { return autoDelete; }
    void setArguments(const FieldTable& _arguments) { arguments = _arguments; }
    const FieldTable& getArguments() const { return arguments; }
    FieldTable& getArguments() { return arguments; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.declare(getTicket(), getExchange(), getType(), getAlternateExchange(), getPassive(), getDurable(), getAutoDelete(), getArguments());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class ExchangeDeclareBody */

}}
#endif  /*!QPID_FRAMING_EXCHANGEDECLAREBODY_H*/
