#ifndef QPID_FRAMING_FILECONSUMEBODY_H
#define QPID_FRAMING_FILECONSUMEBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class FileConsumeBody : public AMQMethodBody {
    uint16_t ticket;
    string queue;
    string consumerTag;
    bool noLocal;
    bool noAck;
    bool exclusive;
    bool nowait;
    FieldTable filter;
public:
    static const ClassId CLASS_ID = 70;
    static const MethodId METHOD_ID = 20;
    FileConsumeBody(
        ProtocolVersion, uint16_t _ticket,
        const string& _queue,
        const string& _consumerTag,
        bool _noLocal,
        bool _noAck,
        bool _exclusive,
        bool _nowait,
        const FieldTable& _filter) : 
         ticket(_ticket),
         queue(_queue),
         consumerTag(_consumerTag),
         noLocal(_noLocal),
         noAck(_noAck),
         exclusive(_exclusive),
         nowait(_nowait),
         filter(_filter){}
    FileConsumeBody(ProtocolVersion=ProtocolVersion())  : ticket(0), noLocal(0), noAck(0), exclusive(0), nowait(0) {}
    
    void setTicket(uint16_t _ticket) { ticket = _ticket; }
    uint16_t getTicket() const { return ticket; }
    void setQueue(const string& _queue) { queue = _queue; }
    const string& getQueue() const { return queue; }
    void setConsumerTag(const string& _consumerTag) { consumerTag = _consumerTag; }
    const string& getConsumerTag() const { return consumerTag; }
    void setNoLocal(bool _noLocal) { noLocal = _noLocal; }
    bool getNoLocal() const { return noLocal; }
    void setNoAck(bool _noAck) { noAck = _noAck; }
    bool getNoAck() const { return noAck; }
    void setExclusive(bool _exclusive) { exclusive = _exclusive; }
    bool getExclusive() const { return exclusive; }
    void setNowait(bool _nowait) { nowait = _nowait; }
    bool getNowait() const { return nowait; }
    void setFilter(const FieldTable& _filter) { filter = _filter; }
    const FieldTable& getFilter() const { return filter; }
    FieldTable& getFilter() { return filter; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.consume(getTicket(), getQueue(), getConsumerTag(), getNoLocal(), getNoAck(), getExclusive(), getNowait(), getFilter());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  true; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class FileConsumeBody */

}}
#endif  /*!QPID_FRAMING_FILECONSUMEBODY_H*/
