#ifndef QPID_FRAMING_MESSAGEQOSBODY_H
#define QPID_FRAMING_MESSAGEQOSBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class MessageQosBody : public AMQMethodBody {
    uint32_t prefetchSize;
    uint16_t prefetchCount;
    bool global;
public:
    static const ClassId CLASS_ID = 120;
    static const MethodId METHOD_ID = 110;
    MessageQosBody(
        ProtocolVersion, uint32_t _prefetchSize,
        uint16_t _prefetchCount,
        bool _global) : 
         prefetchSize(_prefetchSize),
         prefetchCount(_prefetchCount),
         global(_global){}
    MessageQosBody(ProtocolVersion=ProtocolVersion())  : prefetchSize(0), prefetchCount(0), global(0) {}
    
    void setPrefetchSize(uint32_t _prefetchSize) { prefetchSize = _prefetchSize; }
    uint32_t getPrefetchSize() const { return prefetchSize; }
    void setPrefetchCount(uint16_t _prefetchCount) { prefetchCount = _prefetchCount; }
    uint16_t getPrefetchCount() const { return prefetchCount; }
    void setGlobal(bool _global) { global = _global; }
    bool getGlobal() const { return global; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.qos(getPrefetchSize(), getPrefetchCount(), getGlobal());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class MessageQosBody */

}}
#endif  /*!QPID_FRAMING_MESSAGEQOSBODY_H*/
