#ifndef QPID_FRAMING_MESSAGEREJECTBODY_H
#define QPID_FRAMING_MESSAGEREJECTBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class MessageRejectBody : public AMQMethodBody {
    SequenceNumberSet transfers;
    uint16_t code;
    string text;
public:
    static const ClassId CLASS_ID = 120;
    static const MethodId METHOD_ID = 160;
    MessageRejectBody(
        ProtocolVersion, const SequenceNumberSet& _transfers,
        uint16_t _code,
        const string& _text) : 
         transfers(_transfers),
         code(_code),
         text(_text){}
    MessageRejectBody(ProtocolVersion=ProtocolVersion())  : code(0) {}
    
    void setTransfers(const SequenceNumberSet& _transfers) { transfers = _transfers; }
    const SequenceNumberSet& getTransfers() const { return transfers; }
    void setCode(uint16_t _code) { code = _code; }
    uint16_t getCode() const { return code; }
    void setText(const string& _text) { text = _text; }
    const string& getText() const { return text; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.reject(getTransfers(), getCode(), getText());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class MessageRejectBody */

}}
#endif  /*!QPID_FRAMING_MESSAGEREJECTBODY_H*/
