#ifndef QPID_FRAMING_MESSAGESUBSCRIBEBODY_H
#define QPID_FRAMING_MESSAGESUBSCRIBEBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class MessageSubscribeBody : public AMQMethodBody {
    uint16_t ticket;
    string queue;
    string destination;
    bool noLocal;
    uint8_t confirmMode;
    uint8_t acquireMode;
    bool exclusive;
    FieldTable filter;
public:
    static const ClassId CLASS_ID = 120;
    static const MethodId METHOD_ID = 20;
    MessageSubscribeBody(
        ProtocolVersion, uint16_t _ticket,
        const string& _queue,
        const string& _destination,
        bool _noLocal,
        uint8_t _confirmMode,
        uint8_t _acquireMode,
        bool _exclusive,
        const FieldTable& _filter) : 
         ticket(_ticket),
         queue(_queue),
         destination(_destination),
         noLocal(_noLocal),
         confirmMode(_confirmMode),
         acquireMode(_acquireMode),
         exclusive(_exclusive),
         filter(_filter){}
    MessageSubscribeBody(ProtocolVersion=ProtocolVersion())  : ticket(0), noLocal(0), confirmMode(0), acquireMode(0), exclusive(0) {}
    
    void setTicket(uint16_t _ticket) { ticket = _ticket; }
    uint16_t getTicket() const { return ticket; }
    void setQueue(const string& _queue) { queue = _queue; }
    const string& getQueue() const { return queue; }
    void setDestination(const string& _destination) { destination = _destination; }
    const string& getDestination() const { return destination; }
    void setNoLocal(bool _noLocal) { noLocal = _noLocal; }
    bool getNoLocal() const { return noLocal; }
    void setConfirmMode(uint8_t _confirmMode) { confirmMode = _confirmMode; }
    uint8_t getConfirmMode() const { return confirmMode; }
    void setAcquireMode(uint8_t _acquireMode) { acquireMode = _acquireMode; }
    uint8_t getAcquireMode() const { return acquireMode; }
    void setExclusive(bool _exclusive) { exclusive = _exclusive; }
    bool getExclusive() const { return exclusive; }
    void setFilter(const FieldTable& _filter) { filter = _filter; }
    const FieldTable& getFilter() const { return filter; }
    FieldTable& getFilter() { return filter; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.subscribe(getTicket(), getQueue(), getDestination(), getNoLocal(), getConfirmMode(), getAcquireMode(), getExclusive(), getFilter());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class MessageSubscribeBody */

}}
#endif  /*!QPID_FRAMING_MESSAGESUBSCRIBEBODY_H*/
