#ifndef QPID_FRAMING_MESSAGETRANSFERBODY_H
#define QPID_FRAMING_MESSAGETRANSFERBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class MessageTransferBody : public AMQMethodBody {
    uint16_t ticket;
    string destination;
    uint8_t confirmMode;
    uint8_t acquireMode;
public:
    static const ClassId CLASS_ID = 120;
    static const MethodId METHOD_ID = 10;
    MessageTransferBody(
        ProtocolVersion, uint16_t _ticket,
        const string& _destination,
        uint8_t _confirmMode,
        uint8_t _acquireMode) : 
         ticket(_ticket),
         destination(_destination),
         confirmMode(_confirmMode),
         acquireMode(_acquireMode){}
    MessageTransferBody(ProtocolVersion=ProtocolVersion())  : ticket(0), confirmMode(0), acquireMode(0) {}
    
    void setTicket(uint16_t _ticket) { ticket = _ticket; }
    uint16_t getTicket() const { return ticket; }
    void setDestination(const string& _destination) { destination = _destination; }
    const string& getDestination() const { return destination; }
    void setConfirmMode(uint8_t _confirmMode) { confirmMode = _confirmMode; }
    uint8_t getConfirmMode() const { return confirmMode; }
    void setAcquireMode(uint8_t _acquireMode) { acquireMode = _acquireMode; }
    uint8_t getAcquireMode() const { return acquireMode; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.transfer(getTicket(), getDestination(), getConfirmMode(), getAcquireMode());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  true; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class MessageTransferBody */

}}
#endif  /*!QPID_FRAMING_MESSAGETRANSFERBODY_H*/
