#ifndef QPID_FRAMING_METHODBODYCONSTVISITOR_H
#define QPID_FRAMING_METHODBODYCONSTVISITOR_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///



namespace qpid {
namespace framing {

class ConnectionStartBody;
class ConnectionStartOkBody;
class ConnectionSecureBody;
class ConnectionSecureOkBody;
class ConnectionTuneBody;
class ConnectionTuneOkBody;
class ConnectionOpenBody;
class ConnectionOpenOkBody;
class ConnectionRedirectBody;
class ConnectionCloseBody;
class ConnectionCloseOkBody;
class SessionOpenBody;
class SessionAttachedBody;
class SessionFlowBody;
class SessionFlowOkBody;
class SessionCloseBody;
class SessionClosedBody;
class SessionResumeBody;
class SessionSuspendBody;
class SessionDetachedBody;
class SessionAckBody;
class SessionHighWaterMarkBody;
class SessionSolicitAckBody;
class AccessRequestBody;
class AccessRequestOkBody;
class ExchangeDeclareBody;
class ExchangeDeleteBody;
class ExchangeQueryBody;
class QueueDeclareBody;
class QueueBindBody;
class QueueUnbindBody;
class QueuePurgeBody;
class QueueDeleteBody;
class QueueQueryBody;
class BasicQosBody;
class BasicConsumeBody;
class BasicConsumeOkBody;
class BasicCancelBody;
class BasicPublishBody;
class BasicDeliverBody;
class BasicGetBody;
class BasicGetOkBody;
class BasicGetEmptyBody;
class BasicAckBody;
class BasicRejectBody;
class BasicRecoverBody;
class FileQosBody;
class FileQosOkBody;
class FileConsumeBody;
class FileConsumeOkBody;
class FileCancelBody;
class FileOpenBody;
class FileOpenOkBody;
class FileStageBody;
class FilePublishBody;
class FileReturnBody;
class FileDeliverBody;
class FileAckBody;
class FileRejectBody;
class StreamQosBody;
class StreamQosOkBody;
class StreamConsumeBody;
class StreamConsumeOkBody;
class StreamCancelBody;
class StreamPublishBody;
class StreamReturnBody;
class StreamDeliverBody;
class TxSelectBody;
class TxCommitBody;
class TxRollbackBody;
class DtxDemarcationSelectBody;
class DtxDemarcationStartBody;
class DtxDemarcationEndBody;
class DtxCoordinationCommitBody;
class DtxCoordinationForgetBody;
class DtxCoordinationGetTimeoutBody;
class DtxCoordinationPrepareBody;
class DtxCoordinationRecoverBody;
class DtxCoordinationRollbackBody;
class DtxCoordinationSetTimeoutBody;
class TunnelRequestBody;
class MessageTransferBody;
class MessageRejectBody;
class MessageAcquireBody;
class MessageAcquiredBody;
class MessageReleaseBody;
class MessageSubscribeBody;
class MessageCancelBody;
class MessageGetBody;
class MessageRecoverBody;
class MessageOpenBody;
class MessageCloseBody;
class MessageAppendBody;
class MessageCheckpointBody;
class MessageResumeBody;
class MessageQosBody;
class MessageFlowModeBody;
class MessageFlowBody;
class MessageFlushBody;
class MessageStopBody;
class MessageEmptyBody;
class MessageOffsetBody;
class BindingQueryBody;
class ExecutionFlushBody;
class ExecutionCompleteBody;
class ExecutionNoopBody;
class ExecutionResultBody;
class ExecutionSyncBody;
class Connection010StartBody;
class Connection010StartOkBody;
class Connection010SecureBody;
class Connection010SecureOkBody;
class Connection010TuneBody;
class Connection010TuneOkBody;
class Connection010OpenBody;
class Connection010OpenOkBody;
class Connection010RedirectBody;
class Connection010HeartbeatBody;
class Connection010CloseBody;
class Connection010CloseOkBody;
class Session010AttachBody;
class Session010AttachedBody;
class Session010DetachBody;
class Session010DetachedBody;
class Session010RequestTimeoutBody;
class Session010TimeoutBody;
class Session010CommandPointBody;
class Session010ExpectedBody;
class Session010ConfirmedBody;
class Session010CompletedBody;
class Session010KnownCompletedBody;
class Session010FlushBody;
class Session010GapBody;
class Execution010SyncBody;
class Execution010ResultBody;
class Execution010ExceptionBody;
class Message010TransferBody;
class Message010AcceptBody;
class Message010RejectBody;
class Message010ReleaseBody;
class Message010AcquireBody;
class Message010SubscribeBody;
class Message010CancelBody;
class Message010SetFlowModeBody;
class Message010FlowBody;
class Message010FlushBody;
class Message010StopBody;
class Tx010SelectBody;
class Tx010CommitBody;
class Tx010RollbackBody;
class Dtx010SelectBody;
class Dtx010StartBody;
class Dtx010EndBody;
class Dtx010CommitBody;
class Dtx010ForgetBody;
class Dtx010GetTimeoutBody;
class Dtx010PrepareBody;
class Dtx010RecoverBody;
class Dtx010RollbackBody;
class Dtx010SetTimeoutBody;
class Exchange010DeclareBody;
class Exchange010DeleteBody;
class Exchange010QueryBody;
class Exchange010BindBody;
class Exchange010UnbindBody;
class Exchange010BoundBody;
class Queue010DeclareBody;
class Queue010DeleteBody;
class Queue010PurgeBody;
class Queue010QueryBody;
class ClusterNotifyBody;
class MethodBodyConstVisitor
{
    public:
    virtual ~MethodBodyConstVisitor() {}
    virtual void visit(const ConnectionStartBody&) = 0;
    virtual void visit(const ConnectionStartOkBody&) = 0;
    virtual void visit(const ConnectionSecureBody&) = 0;
    virtual void visit(const ConnectionSecureOkBody&) = 0;
    virtual void visit(const ConnectionTuneBody&) = 0;
    virtual void visit(const ConnectionTuneOkBody&) = 0;
    virtual void visit(const ConnectionOpenBody&) = 0;
    virtual void visit(const ConnectionOpenOkBody&) = 0;
    virtual void visit(const ConnectionRedirectBody&) = 0;
    virtual void visit(const ConnectionCloseBody&) = 0;
    virtual void visit(const ConnectionCloseOkBody&) = 0;
    virtual void visit(const SessionOpenBody&) = 0;
    virtual void visit(const SessionAttachedBody&) = 0;
    virtual void visit(const SessionFlowBody&) = 0;
    virtual void visit(const SessionFlowOkBody&) = 0;
    virtual void visit(const SessionCloseBody&) = 0;
    virtual void visit(const SessionClosedBody&) = 0;
    virtual void visit(const SessionResumeBody&) = 0;
    virtual void visit(const SessionSuspendBody&) = 0;
    virtual void visit(const SessionDetachedBody&) = 0;
    virtual void visit(const SessionAckBody&) = 0;
    virtual void visit(const SessionHighWaterMarkBody&) = 0;
    virtual void visit(const SessionSolicitAckBody&) = 0;
    virtual void visit(const AccessRequestBody&) = 0;
    virtual void visit(const AccessRequestOkBody&) = 0;
    virtual void visit(const ExchangeDeclareBody&) = 0;
    virtual void visit(const ExchangeDeleteBody&) = 0;
    virtual void visit(const ExchangeQueryBody&) = 0;
    virtual void visit(const QueueDeclareBody&) = 0;
    virtual void visit(const QueueBindBody&) = 0;
    virtual void visit(const QueueUnbindBody&) = 0;
    virtual void visit(const QueuePurgeBody&) = 0;
    virtual void visit(const QueueDeleteBody&) = 0;
    virtual void visit(const QueueQueryBody&) = 0;
    virtual void visit(const BasicQosBody&) = 0;
    virtual void visit(const BasicConsumeBody&) = 0;
    virtual void visit(const BasicConsumeOkBody&) = 0;
    virtual void visit(const BasicCancelBody&) = 0;
    virtual void visit(const BasicPublishBody&) = 0;
    virtual void visit(const BasicDeliverBody&) = 0;
    virtual void visit(const BasicGetBody&) = 0;
    virtual void visit(const BasicGetOkBody&) = 0;
    virtual void visit(const BasicGetEmptyBody&) = 0;
    virtual void visit(const BasicAckBody&) = 0;
    virtual void visit(const BasicRejectBody&) = 0;
    virtual void visit(const BasicRecoverBody&) = 0;
    virtual void visit(const FileQosBody&) = 0;
    virtual void visit(const FileQosOkBody&) = 0;
    virtual void visit(const FileConsumeBody&) = 0;
    virtual void visit(const FileConsumeOkBody&) = 0;
    virtual void visit(const FileCancelBody&) = 0;
    virtual void visit(const FileOpenBody&) = 0;
    virtual void visit(const FileOpenOkBody&) = 0;
    virtual void visit(const FileStageBody&) = 0;
    virtual void visit(const FilePublishBody&) = 0;
    virtual void visit(const FileReturnBody&) = 0;
    virtual void visit(const FileDeliverBody&) = 0;
    virtual void visit(const FileAckBody&) = 0;
    virtual void visit(const FileRejectBody&) = 0;
    virtual void visit(const StreamQosBody&) = 0;
    virtual void visit(const StreamQosOkBody&) = 0;
    virtual void visit(const StreamConsumeBody&) = 0;
    virtual void visit(const StreamConsumeOkBody&) = 0;
    virtual void visit(const StreamCancelBody&) = 0;
    virtual void visit(const StreamPublishBody&) = 0;
    virtual void visit(const StreamReturnBody&) = 0;
    virtual void visit(const StreamDeliverBody&) = 0;
    virtual void visit(const TxSelectBody&) = 0;
    virtual void visit(const TxCommitBody&) = 0;
    virtual void visit(const TxRollbackBody&) = 0;
    virtual void visit(const DtxDemarcationSelectBody&) = 0;
    virtual void visit(const DtxDemarcationStartBody&) = 0;
    virtual void visit(const DtxDemarcationEndBody&) = 0;
    virtual void visit(const DtxCoordinationCommitBody&) = 0;
    virtual void visit(const DtxCoordinationForgetBody&) = 0;
    virtual void visit(const DtxCoordinationGetTimeoutBody&) = 0;
    virtual void visit(const DtxCoordinationPrepareBody&) = 0;
    virtual void visit(const DtxCoordinationRecoverBody&) = 0;
    virtual void visit(const DtxCoordinationRollbackBody&) = 0;
    virtual void visit(const DtxCoordinationSetTimeoutBody&) = 0;
    virtual void visit(const TunnelRequestBody&) = 0;
    virtual void visit(const MessageTransferBody&) = 0;
    virtual void visit(const MessageRejectBody&) = 0;
    virtual void visit(const MessageAcquireBody&) = 0;
    virtual void visit(const MessageAcquiredBody&) = 0;
    virtual void visit(const MessageReleaseBody&) = 0;
    virtual void visit(const MessageSubscribeBody&) = 0;
    virtual void visit(const MessageCancelBody&) = 0;
    virtual void visit(const MessageGetBody&) = 0;
    virtual void visit(const MessageRecoverBody&) = 0;
    virtual void visit(const MessageOpenBody&) = 0;
    virtual void visit(const MessageCloseBody&) = 0;
    virtual void visit(const MessageAppendBody&) = 0;
    virtual void visit(const MessageCheckpointBody&) = 0;
    virtual void visit(const MessageResumeBody&) = 0;
    virtual void visit(const MessageQosBody&) = 0;
    virtual void visit(const MessageFlowModeBody&) = 0;
    virtual void visit(const MessageFlowBody&) = 0;
    virtual void visit(const MessageFlushBody&) = 0;
    virtual void visit(const MessageStopBody&) = 0;
    virtual void visit(const MessageEmptyBody&) = 0;
    virtual void visit(const MessageOffsetBody&) = 0;
    virtual void visit(const BindingQueryBody&) = 0;
    virtual void visit(const ExecutionFlushBody&) = 0;
    virtual void visit(const ExecutionCompleteBody&) = 0;
    virtual void visit(const ExecutionNoopBody&) = 0;
    virtual void visit(const ExecutionResultBody&) = 0;
    virtual void visit(const ExecutionSyncBody&) = 0;
    virtual void visit(const Connection010StartBody&) = 0;
    virtual void visit(const Connection010StartOkBody&) = 0;
    virtual void visit(const Connection010SecureBody&) = 0;
    virtual void visit(const Connection010SecureOkBody&) = 0;
    virtual void visit(const Connection010TuneBody&) = 0;
    virtual void visit(const Connection010TuneOkBody&) = 0;
    virtual void visit(const Connection010OpenBody&) = 0;
    virtual void visit(const Connection010OpenOkBody&) = 0;
    virtual void visit(const Connection010RedirectBody&) = 0;
    virtual void visit(const Connection010HeartbeatBody&) = 0;
    virtual void visit(const Connection010CloseBody&) = 0;
    virtual void visit(const Connection010CloseOkBody&) = 0;
    virtual void visit(const Session010AttachBody&) = 0;
    virtual void visit(const Session010AttachedBody&) = 0;
    virtual void visit(const Session010DetachBody&) = 0;
    virtual void visit(const Session010DetachedBody&) = 0;
    virtual void visit(const Session010RequestTimeoutBody&) = 0;
    virtual void visit(const Session010TimeoutBody&) = 0;
    virtual void visit(const Session010CommandPointBody&) = 0;
    virtual void visit(const Session010ExpectedBody&) = 0;
    virtual void visit(const Session010ConfirmedBody&) = 0;
    virtual void visit(const Session010CompletedBody&) = 0;
    virtual void visit(const Session010KnownCompletedBody&) = 0;
    virtual void visit(const Session010FlushBody&) = 0;
    virtual void visit(const Session010GapBody&) = 0;
    virtual void visit(const Execution010SyncBody&) = 0;
    virtual void visit(const Execution010ResultBody&) = 0;
    virtual void visit(const Execution010ExceptionBody&) = 0;
    virtual void visit(const Message010TransferBody&) = 0;
    virtual void visit(const Message010AcceptBody&) = 0;
    virtual void visit(const Message010RejectBody&) = 0;
    virtual void visit(const Message010ReleaseBody&) = 0;
    virtual void visit(const Message010AcquireBody&) = 0;
    virtual void visit(const Message010SubscribeBody&) = 0;
    virtual void visit(const Message010CancelBody&) = 0;
    virtual void visit(const Message010SetFlowModeBody&) = 0;
    virtual void visit(const Message010FlowBody&) = 0;
    virtual void visit(const Message010FlushBody&) = 0;
    virtual void visit(const Message010StopBody&) = 0;
    virtual void visit(const Tx010SelectBody&) = 0;
    virtual void visit(const Tx010CommitBody&) = 0;
    virtual void visit(const Tx010RollbackBody&) = 0;
    virtual void visit(const Dtx010SelectBody&) = 0;
    virtual void visit(const Dtx010StartBody&) = 0;
    virtual void visit(const Dtx010EndBody&) = 0;
    virtual void visit(const Dtx010CommitBody&) = 0;
    virtual void visit(const Dtx010ForgetBody&) = 0;
    virtual void visit(const Dtx010GetTimeoutBody&) = 0;
    virtual void visit(const Dtx010PrepareBody&) = 0;
    virtual void visit(const Dtx010RecoverBody&) = 0;
    virtual void visit(const Dtx010RollbackBody&) = 0;
    virtual void visit(const Dtx010SetTimeoutBody&) = 0;
    virtual void visit(const Exchange010DeclareBody&) = 0;
    virtual void visit(const Exchange010DeleteBody&) = 0;
    virtual void visit(const Exchange010QueryBody&) = 0;
    virtual void visit(const Exchange010BindBody&) = 0;
    virtual void visit(const Exchange010UnbindBody&) = 0;
    virtual void visit(const Exchange010BoundBody&) = 0;
    virtual void visit(const Queue010DeclareBody&) = 0;
    virtual void visit(const Queue010DeleteBody&) = 0;
    virtual void visit(const Queue010PurgeBody&) = 0;
    virtual void visit(const Queue010QueryBody&) = 0;
    virtual void visit(const ClusterNotifyBody&) = 0;
};

}} // namespace qpid::framing

#endif  /*!QPID_FRAMING_METHODBODYCONSTVISITOR_H*/
