#ifndef QPID_FRAMING_METHODBODYDEFAULTVISITOR_H
#define QPID_FRAMING_METHODBODYDEFAULTVISITOR_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/MethodBodyConstVisitor.h"

namespace qpid {
namespace framing {

class AMQMethodBody;
class MethodBodyDefaultVisitor:
    public MethodBodyConstVisitor
{
    public:
    virtual void defaultVisit(const AMQMethodBody&) = 0;
    virtual void visit(const ConnectionStartBody&);
    virtual void visit(const ConnectionStartOkBody&);
    virtual void visit(const ConnectionSecureBody&);
    virtual void visit(const ConnectionSecureOkBody&);
    virtual void visit(const ConnectionTuneBody&);
    virtual void visit(const ConnectionTuneOkBody&);
    virtual void visit(const ConnectionOpenBody&);
    virtual void visit(const ConnectionOpenOkBody&);
    virtual void visit(const ConnectionRedirectBody&);
    virtual void visit(const ConnectionCloseBody&);
    virtual void visit(const ConnectionCloseOkBody&);
    virtual void visit(const SessionOpenBody&);
    virtual void visit(const SessionAttachedBody&);
    virtual void visit(const SessionFlowBody&);
    virtual void visit(const SessionFlowOkBody&);
    virtual void visit(const SessionCloseBody&);
    virtual void visit(const SessionClosedBody&);
    virtual void visit(const SessionResumeBody&);
    virtual void visit(const SessionSuspendBody&);
    virtual void visit(const SessionDetachedBody&);
    virtual void visit(const SessionAckBody&);
    virtual void visit(const SessionHighWaterMarkBody&);
    virtual void visit(const SessionSolicitAckBody&);
    virtual void visit(const AccessRequestBody&);
    virtual void visit(const AccessRequestOkBody&);
    virtual void visit(const ExchangeDeclareBody&);
    virtual void visit(const ExchangeDeleteBody&);
    virtual void visit(const ExchangeQueryBody&);
    virtual void visit(const QueueDeclareBody&);
    virtual void visit(const QueueBindBody&);
    virtual void visit(const QueueUnbindBody&);
    virtual void visit(const QueuePurgeBody&);
    virtual void visit(const QueueDeleteBody&);
    virtual void visit(const QueueQueryBody&);
    virtual void visit(const BasicQosBody&);
    virtual void visit(const BasicConsumeBody&);
    virtual void visit(const BasicConsumeOkBody&);
    virtual void visit(const BasicCancelBody&);
    virtual void visit(const BasicPublishBody&);
    virtual void visit(const BasicDeliverBody&);
    virtual void visit(const BasicGetBody&);
    virtual void visit(const BasicGetOkBody&);
    virtual void visit(const BasicGetEmptyBody&);
    virtual void visit(const BasicAckBody&);
    virtual void visit(const BasicRejectBody&);
    virtual void visit(const BasicRecoverBody&);
    virtual void visit(const FileQosBody&);
    virtual void visit(const FileQosOkBody&);
    virtual void visit(const FileConsumeBody&);
    virtual void visit(const FileConsumeOkBody&);
    virtual void visit(const FileCancelBody&);
    virtual void visit(const FileOpenBody&);
    virtual void visit(const FileOpenOkBody&);
    virtual void visit(const FileStageBody&);
    virtual void visit(const FilePublishBody&);
    virtual void visit(const FileReturnBody&);
    virtual void visit(const FileDeliverBody&);
    virtual void visit(const FileAckBody&);
    virtual void visit(const FileRejectBody&);
    virtual void visit(const StreamQosBody&);
    virtual void visit(const StreamQosOkBody&);
    virtual void visit(const StreamConsumeBody&);
    virtual void visit(const StreamConsumeOkBody&);
    virtual void visit(const StreamCancelBody&);
    virtual void visit(const StreamPublishBody&);
    virtual void visit(const StreamReturnBody&);
    virtual void visit(const StreamDeliverBody&);
    virtual void visit(const TxSelectBody&);
    virtual void visit(const TxCommitBody&);
    virtual void visit(const TxRollbackBody&);
    virtual void visit(const DtxDemarcationSelectBody&);
    virtual void visit(const DtxDemarcationStartBody&);
    virtual void visit(const DtxDemarcationEndBody&);
    virtual void visit(const DtxCoordinationCommitBody&);
    virtual void visit(const DtxCoordinationForgetBody&);
    virtual void visit(const DtxCoordinationGetTimeoutBody&);
    virtual void visit(const DtxCoordinationPrepareBody&);
    virtual void visit(const DtxCoordinationRecoverBody&);
    virtual void visit(const DtxCoordinationRollbackBody&);
    virtual void visit(const DtxCoordinationSetTimeoutBody&);
    virtual void visit(const TunnelRequestBody&);
    virtual void visit(const MessageTransferBody&);
    virtual void visit(const MessageRejectBody&);
    virtual void visit(const MessageAcquireBody&);
    virtual void visit(const MessageAcquiredBody&);
    virtual void visit(const MessageReleaseBody&);
    virtual void visit(const MessageSubscribeBody&);
    virtual void visit(const MessageCancelBody&);
    virtual void visit(const MessageGetBody&);
    virtual void visit(const MessageRecoverBody&);
    virtual void visit(const MessageOpenBody&);
    virtual void visit(const MessageCloseBody&);
    virtual void visit(const MessageAppendBody&);
    virtual void visit(const MessageCheckpointBody&);
    virtual void visit(const MessageResumeBody&);
    virtual void visit(const MessageQosBody&);
    virtual void visit(const MessageFlowModeBody&);
    virtual void visit(const MessageFlowBody&);
    virtual void visit(const MessageFlushBody&);
    virtual void visit(const MessageStopBody&);
    virtual void visit(const MessageEmptyBody&);
    virtual void visit(const MessageOffsetBody&);
    virtual void visit(const BindingQueryBody&);
    virtual void visit(const ExecutionFlushBody&);
    virtual void visit(const ExecutionCompleteBody&);
    virtual void visit(const ExecutionNoopBody&);
    virtual void visit(const ExecutionResultBody&);
    virtual void visit(const ExecutionSyncBody&);
    virtual void visit(const Connection010StartBody&);
    virtual void visit(const Connection010StartOkBody&);
    virtual void visit(const Connection010SecureBody&);
    virtual void visit(const Connection010SecureOkBody&);
    virtual void visit(const Connection010TuneBody&);
    virtual void visit(const Connection010TuneOkBody&);
    virtual void visit(const Connection010OpenBody&);
    virtual void visit(const Connection010OpenOkBody&);
    virtual void visit(const Connection010RedirectBody&);
    virtual void visit(const Connection010HeartbeatBody&);
    virtual void visit(const Connection010CloseBody&);
    virtual void visit(const Connection010CloseOkBody&);
    virtual void visit(const Session010AttachBody&);
    virtual void visit(const Session010AttachedBody&);
    virtual void visit(const Session010DetachBody&);
    virtual void visit(const Session010DetachedBody&);
    virtual void visit(const Session010RequestTimeoutBody&);
    virtual void visit(const Session010TimeoutBody&);
    virtual void visit(const Session010CommandPointBody&);
    virtual void visit(const Session010ExpectedBody&);
    virtual void visit(const Session010ConfirmedBody&);
    virtual void visit(const Session010CompletedBody&);
    virtual void visit(const Session010KnownCompletedBody&);
    virtual void visit(const Session010FlushBody&);
    virtual void visit(const Session010GapBody&);
    virtual void visit(const Execution010SyncBody&);
    virtual void visit(const Execution010ResultBody&);
    virtual void visit(const Execution010ExceptionBody&);
    virtual void visit(const Message010TransferBody&);
    virtual void visit(const Message010AcceptBody&);
    virtual void visit(const Message010RejectBody&);
    virtual void visit(const Message010ReleaseBody&);
    virtual void visit(const Message010AcquireBody&);
    virtual void visit(const Message010SubscribeBody&);
    virtual void visit(const Message010CancelBody&);
    virtual void visit(const Message010SetFlowModeBody&);
    virtual void visit(const Message010FlowBody&);
    virtual void visit(const Message010FlushBody&);
    virtual void visit(const Message010StopBody&);
    virtual void visit(const Tx010SelectBody&);
    virtual void visit(const Tx010CommitBody&);
    virtual void visit(const Tx010RollbackBody&);
    virtual void visit(const Dtx010SelectBody&);
    virtual void visit(const Dtx010StartBody&);
    virtual void visit(const Dtx010EndBody&);
    virtual void visit(const Dtx010CommitBody&);
    virtual void visit(const Dtx010ForgetBody&);
    virtual void visit(const Dtx010GetTimeoutBody&);
    virtual void visit(const Dtx010PrepareBody&);
    virtual void visit(const Dtx010RecoverBody&);
    virtual void visit(const Dtx010RollbackBody&);
    virtual void visit(const Dtx010SetTimeoutBody&);
    virtual void visit(const Exchange010DeclareBody&);
    virtual void visit(const Exchange010DeleteBody&);
    virtual void visit(const Exchange010QueryBody&);
    virtual void visit(const Exchange010BindBody&);
    virtual void visit(const Exchange010UnbindBody&);
    virtual void visit(const Exchange010BoundBody&);
    virtual void visit(const Queue010DeclareBody&);
    virtual void visit(const Queue010DeleteBody&);
    virtual void visit(const Queue010PurgeBody&);
    virtual void visit(const Queue010QueryBody&);
    virtual void visit(const ClusterNotifyBody&);
};

}} // namespace qpid::framing

#endif  /*!QPID_FRAMING_METHODBODYDEFAULTVISITOR_H*/
