#ifndef QPID_FRAMING_QUEUEBINDBODY_H
#define QPID_FRAMING_QUEUEBINDBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class QueueBindBody : public AMQMethodBody {
    uint16_t ticket;
    string queue;
    string exchange;
    string routingKey;
    FieldTable arguments;
public:
    static const ClassId CLASS_ID = 50;
    static const MethodId METHOD_ID = 20;
    QueueBindBody(
        ProtocolVersion, uint16_t _ticket,
        const string& _queue,
        const string& _exchange,
        const string& _routingKey,
        const FieldTable& _arguments) : 
         ticket(_ticket),
         queue(_queue),
         exchange(_exchange),
         routingKey(_routingKey),
         arguments(_arguments){}
    QueueBindBody(ProtocolVersion=ProtocolVersion())  : ticket(0) {}
    
    void setTicket(uint16_t _ticket) { ticket = _ticket; }
    uint16_t getTicket() const { return ticket; }
    void setQueue(const string& _queue) { queue = _queue; }
    const string& getQueue() const { return queue; }
    void setExchange(const string& _exchange) { exchange = _exchange; }
    const string& getExchange() const { return exchange; }
    void setRoutingKey(const string& _routingKey) { routingKey = _routingKey; }
    const string& getRoutingKey() const { return routingKey; }
    void setArguments(const FieldTable& _arguments) { arguments = _arguments; }
    const FieldTable& getArguments() const { return arguments; }
    FieldTable& getArguments() { return arguments; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.bind(getTicket(), getQueue(), getExchange(), getRoutingKey(), getArguments());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class QueueBindBody */

}}
#endif  /*!QPID_FRAMING_QUEUEBINDBODY_H*/
