#ifndef QPID_FRAMING_QUEUEDELETEBODY_H
#define QPID_FRAMING_QUEUEDELETEBODY_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQMethodBody.h"
#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/MethodBodyConstVisitor.h"

#include <ostream>
#include "qpid/framing/amqp_types_full.h"

namespace qpid {
namespace framing {

class QueueDeleteBody : public AMQMethodBody {
    uint16_t ticket;
    string queue;
    bool ifUnused;
    bool ifEmpty;
public:
    static const ClassId CLASS_ID = 50;
    static const MethodId METHOD_ID = 40;
    QueueDeleteBody(
        ProtocolVersion, uint16_t _ticket,
        const string& _queue,
        bool _ifUnused,
        bool _ifEmpty) : 
         ticket(_ticket),
         queue(_queue),
         ifUnused(_ifUnused),
         ifEmpty(_ifEmpty){}
    QueueDeleteBody(ProtocolVersion=ProtocolVersion())  : ticket(0), ifUnused(0), ifEmpty(0) {}
    
    void setTicket(uint16_t _ticket) { ticket = _ticket; }
    uint16_t getTicket() const { return ticket; }
    void setQueue(const string& _queue) { queue = _queue; }
    const string& getQueue() const { return queue; }
    void setIfUnused(bool _ifUnused) { ifUnused = _ifUnused; }
    bool getIfUnused() const { return ifUnused; }
    void setIfEmpty(bool _ifEmpty) { ifEmpty = _ifEmpty; }
    bool getIfEmpty() const { return ifEmpty; }
    typedef void ResultType;

    template <class T> ResultType invoke(T& invocable) const {
        return invocable.delete_(getTicket(), getQueue(), getIfUnused(), getIfEmpty());
    }

    using  AMQMethodBody::accept;
    void accept(MethodBodyConstVisitor& v) const { v.visit(*this); }

    ClassId amqpClassId() const { return CLASS_ID; }
    MethodId amqpMethodId() const { return METHOD_ID; }
    bool isContentBearing() const { return  false; }
    bool resultExpected() const { return  false; }
    bool responseExpected() const { return  false; }
    void encode(Buffer&) const;
    void decode(Buffer&, uint32_t=0);
    void encodeStructBody(Buffer&) const;
    void decodeStructBody(Buffer&, uint32_t=0);
    uint32_t size() const;
    uint32_t bodySize() const;
    void print(std::ostream& out) const;
}; /* class QueueDeleteBody */

}}
#endif  /*!QPID_FRAMING_QUEUEDELETEBODY_H*/
