#ifndef QPID_FRAMING_SERVERINVOKER_H
#define QPID_FRAMING_SERVERINVOKER_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQP_ServerOperations.h"
#include "qpid/framing/Invoker.h"

namespace qpid {
namespace framing {


class AMQP_ServerOperations::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations& target;
  public:
    Invoker(AMQP_ServerOperations& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const ConnectionStartOkBody& body);
    void visit(const ConnectionSecureOkBody& body);
    void visit(const ConnectionTuneOkBody& body);
    void visit(const ConnectionOpenBody& body);
    void visit(const ConnectionCloseBody& body);
    void visit(const ConnectionCloseOkBody& body);
    void visit(const SessionOpenBody& body);
    void visit(const SessionFlowBody& body);
    void visit(const SessionFlowOkBody& body);
    void visit(const SessionCloseBody& body);
    void visit(const SessionClosedBody& body);
    void visit(const SessionResumeBody& body);
    void visit(const SessionSuspendBody& body);
    void visit(const SessionAckBody& body);
    void visit(const SessionHighWaterMarkBody& body);
    void visit(const SessionSolicitAckBody& body);
    void visit(const AccessRequestBody& body);
    void visit(const ExchangeDeclareBody& body);
    void visit(const ExchangeDeleteBody& body);
    void visit(const ExchangeQueryBody& body);
    void visit(const QueueDeclareBody& body);
    void visit(const QueueBindBody& body);
    void visit(const QueueUnbindBody& body);
    void visit(const QueuePurgeBody& body);
    void visit(const QueueDeleteBody& body);
    void visit(const QueueQueryBody& body);
    void visit(const BasicQosBody& body);
    void visit(const BasicConsumeBody& body);
    void visit(const BasicCancelBody& body);
    void visit(const BasicGetBody& body);
    void visit(const BasicAckBody& body);
    void visit(const BasicRejectBody& body);
    void visit(const BasicRecoverBody& body);
    void visit(const FileQosBody& body);
    void visit(const FileConsumeBody& body);
    void visit(const FileCancelBody& body);
    void visit(const FileOpenBody& body);
    void visit(const FileOpenOkBody& body);
    void visit(const FilePublishBody& body);
    void visit(const FileAckBody& body);
    void visit(const FileRejectBody& body);
    void visit(const StreamQosBody& body);
    void visit(const StreamConsumeBody& body);
    void visit(const StreamCancelBody& body);
    void visit(const TxSelectBody& body);
    void visit(const TxCommitBody& body);
    void visit(const TxRollbackBody& body);
    void visit(const DtxDemarcationSelectBody& body);
    void visit(const DtxDemarcationStartBody& body);
    void visit(const DtxDemarcationEndBody& body);
    void visit(const DtxCoordinationCommitBody& body);
    void visit(const DtxCoordinationForgetBody& body);
    void visit(const DtxCoordinationGetTimeoutBody& body);
    void visit(const DtxCoordinationPrepareBody& body);
    void visit(const DtxCoordinationRecoverBody& body);
    void visit(const DtxCoordinationRollbackBody& body);
    void visit(const DtxCoordinationSetTimeoutBody& body);
    void visit(const MessageRejectBody& body);
    void visit(const MessageAcquireBody& body);
    void visit(const MessageReleaseBody& body);
    void visit(const MessageSubscribeBody& body);
    void visit(const MessageCancelBody& body);
    void visit(const MessageGetBody& body);
    void visit(const MessageRecoverBody& body);
    void visit(const MessageOpenBody& body);
    void visit(const MessageCloseBody& body);
    void visit(const MessageAppendBody& body);
    void visit(const MessageCheckpointBody& body);
    void visit(const MessageResumeBody& body);
    void visit(const MessageQosBody& body);
    void visit(const MessageFlowModeBody& body);
    void visit(const MessageFlowBody& body);
    void visit(const MessageFlushBody& body);
    void visit(const MessageStopBody& body);
    void visit(const MessageEmptyBody& body);
    void visit(const MessageOffsetBody& body);
    void visit(const BindingQueryBody& body);
    void visit(const ExecutionFlushBody& body);
    void visit(const ExecutionCompleteBody& body);
    void visit(const ExecutionNoopBody& body);
    void visit(const ExecutionResultBody& body);
    void visit(const ExecutionSyncBody& body);
    void visit(const Connection010StartOkBody& body);
    void visit(const Connection010SecureOkBody& body);
    void visit(const Connection010TuneOkBody& body);
    void visit(const Connection010OpenBody& body);
    void visit(const Connection010HeartbeatBody& body);
    void visit(const Connection010CloseBody& body);
    void visit(const Connection010CloseOkBody& body);
    void visit(const Session010AttachBody& body);
    void visit(const Session010AttachedBody& body);
    void visit(const Session010DetachBody& body);
    void visit(const Session010DetachedBody& body);
    void visit(const Session010RequestTimeoutBody& body);
    void visit(const Session010TimeoutBody& body);
    void visit(const Session010CommandPointBody& body);
    void visit(const Session010ExpectedBody& body);
    void visit(const Session010ConfirmedBody& body);
    void visit(const Session010CompletedBody& body);
    void visit(const Session010KnownCompletedBody& body);
    void visit(const Session010FlushBody& body);
    void visit(const Session010GapBody& body);
    void visit(const Execution010SyncBody& body);
    void visit(const Execution010ResultBody& body);
    void visit(const Execution010ExceptionBody& body);
    void visit(const Message010TransferBody& body);
    void visit(const Message010AcceptBody& body);
    void visit(const Message010RejectBody& body);
    void visit(const Message010ReleaseBody& body);
    void visit(const Message010AcquireBody& body);
    void visit(const Message010SubscribeBody& body);
    void visit(const Message010CancelBody& body);
    void visit(const Message010SetFlowModeBody& body);
    void visit(const Message010FlowBody& body);
    void visit(const Message010FlushBody& body);
    void visit(const Message010StopBody& body);
    void visit(const Tx010SelectBody& body);
    void visit(const Tx010CommitBody& body);
    void visit(const Tx010RollbackBody& body);
    void visit(const Dtx010SelectBody& body);
    void visit(const Dtx010StartBody& body);
    void visit(const Dtx010EndBody& body);
    void visit(const Dtx010CommitBody& body);
    void visit(const Dtx010ForgetBody& body);
    void visit(const Dtx010GetTimeoutBody& body);
    void visit(const Dtx010PrepareBody& body);
    void visit(const Dtx010RecoverBody& body);
    void visit(const Dtx010RollbackBody& body);
    void visit(const Dtx010SetTimeoutBody& body);
    void visit(const Exchange010DeclareBody& body);
    void visit(const Exchange010DeleteBody& body);
    void visit(const Exchange010QueryBody& body);
    void visit(const Exchange010BindBody& body);
    void visit(const Exchange010UnbindBody& body);
    void visit(const Exchange010BoundBody& body);
    void visit(const Queue010DeclareBody& body);
    void visit(const Queue010DeleteBody& body);
    void visit(const Queue010PurgeBody& body);
    void visit(const Queue010QueryBody& body);
};

class AMQP_ServerOperations::ConnectionHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::ConnectionHandler& target;
  public:
    Invoker(AMQP_ServerOperations::ConnectionHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const ConnectionStartOkBody& body);
    void visit(const ConnectionSecureOkBody& body);
    void visit(const ConnectionTuneOkBody& body);
    void visit(const ConnectionOpenBody& body);
    void visit(const ConnectionCloseBody& body);
    void visit(const ConnectionCloseOkBody& body);
};

class AMQP_ServerOperations::SessionHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::SessionHandler& target;
  public:
    Invoker(AMQP_ServerOperations::SessionHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const SessionOpenBody& body);
    void visit(const SessionFlowBody& body);
    void visit(const SessionFlowOkBody& body);
    void visit(const SessionCloseBody& body);
    void visit(const SessionClosedBody& body);
    void visit(const SessionResumeBody& body);
    void visit(const SessionSuspendBody& body);
    void visit(const SessionAckBody& body);
    void visit(const SessionHighWaterMarkBody& body);
    void visit(const SessionSolicitAckBody& body);
};

class AMQP_ServerOperations::AccessHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::AccessHandler& target;
  public:
    Invoker(AMQP_ServerOperations::AccessHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const AccessRequestBody& body);
};

class AMQP_ServerOperations::ExchangeHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::ExchangeHandler& target;
  public:
    Invoker(AMQP_ServerOperations::ExchangeHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const ExchangeDeclareBody& body);
    void visit(const ExchangeDeleteBody& body);
    void visit(const ExchangeQueryBody& body);
};

class AMQP_ServerOperations::QueueHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::QueueHandler& target;
  public:
    Invoker(AMQP_ServerOperations::QueueHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const QueueDeclareBody& body);
    void visit(const QueueBindBody& body);
    void visit(const QueueUnbindBody& body);
    void visit(const QueuePurgeBody& body);
    void visit(const QueueDeleteBody& body);
    void visit(const QueueQueryBody& body);
};

class AMQP_ServerOperations::BasicHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::BasicHandler& target;
  public:
    Invoker(AMQP_ServerOperations::BasicHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const BasicQosBody& body);
    void visit(const BasicConsumeBody& body);
    void visit(const BasicCancelBody& body);
    void visit(const BasicGetBody& body);
    void visit(const BasicAckBody& body);
    void visit(const BasicRejectBody& body);
    void visit(const BasicRecoverBody& body);
};

class AMQP_ServerOperations::FileHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::FileHandler& target;
  public:
    Invoker(AMQP_ServerOperations::FileHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const FileQosBody& body);
    void visit(const FileConsumeBody& body);
    void visit(const FileCancelBody& body);
    void visit(const FileOpenBody& body);
    void visit(const FileOpenOkBody& body);
    void visit(const FilePublishBody& body);
    void visit(const FileAckBody& body);
    void visit(const FileRejectBody& body);
};

class AMQP_ServerOperations::StreamHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::StreamHandler& target;
  public:
    Invoker(AMQP_ServerOperations::StreamHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const StreamQosBody& body);
    void visit(const StreamConsumeBody& body);
    void visit(const StreamCancelBody& body);
};

class AMQP_ServerOperations::TxHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::TxHandler& target;
  public:
    Invoker(AMQP_ServerOperations::TxHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const TxSelectBody& body);
    void visit(const TxCommitBody& body);
    void visit(const TxRollbackBody& body);
};

class AMQP_ServerOperations::DtxDemarcationHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::DtxDemarcationHandler& target;
  public:
    Invoker(AMQP_ServerOperations::DtxDemarcationHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const DtxDemarcationSelectBody& body);
    void visit(const DtxDemarcationStartBody& body);
    void visit(const DtxDemarcationEndBody& body);
};

class AMQP_ServerOperations::DtxCoordinationHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::DtxCoordinationHandler& target;
  public:
    Invoker(AMQP_ServerOperations::DtxCoordinationHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const DtxCoordinationCommitBody& body);
    void visit(const DtxCoordinationForgetBody& body);
    void visit(const DtxCoordinationGetTimeoutBody& body);
    void visit(const DtxCoordinationPrepareBody& body);
    void visit(const DtxCoordinationRecoverBody& body);
    void visit(const DtxCoordinationRollbackBody& body);
    void visit(const DtxCoordinationSetTimeoutBody& body);
};

class AMQP_ServerOperations::MessageHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::MessageHandler& target;
  public:
    Invoker(AMQP_ServerOperations::MessageHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const MessageRejectBody& body);
    void visit(const MessageAcquireBody& body);
    void visit(const MessageReleaseBody& body);
    void visit(const MessageSubscribeBody& body);
    void visit(const MessageCancelBody& body);
    void visit(const MessageGetBody& body);
    void visit(const MessageRecoverBody& body);
    void visit(const MessageOpenBody& body);
    void visit(const MessageCloseBody& body);
    void visit(const MessageAppendBody& body);
    void visit(const MessageCheckpointBody& body);
    void visit(const MessageResumeBody& body);
    void visit(const MessageQosBody& body);
    void visit(const MessageFlowModeBody& body);
    void visit(const MessageFlowBody& body);
    void visit(const MessageFlushBody& body);
    void visit(const MessageStopBody& body);
    void visit(const MessageEmptyBody& body);
    void visit(const MessageOffsetBody& body);
};

class AMQP_ServerOperations::BindingHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::BindingHandler& target;
  public:
    Invoker(AMQP_ServerOperations::BindingHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const BindingQueryBody& body);
};

class AMQP_ServerOperations::ExecutionHandler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::ExecutionHandler& target;
  public:
    Invoker(AMQP_ServerOperations::ExecutionHandler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const ExecutionFlushBody& body);
    void visit(const ExecutionCompleteBody& body);
    void visit(const ExecutionNoopBody& body);
    void visit(const ExecutionResultBody& body);
    void visit(const ExecutionSyncBody& body);
};

class AMQP_ServerOperations::Connection010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Connection010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Connection010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Connection010StartOkBody& body);
    void visit(const Connection010SecureOkBody& body);
    void visit(const Connection010TuneOkBody& body);
    void visit(const Connection010OpenBody& body);
    void visit(const Connection010HeartbeatBody& body);
    void visit(const Connection010CloseBody& body);
    void visit(const Connection010CloseOkBody& body);
};

class AMQP_ServerOperations::Session010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Session010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Session010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Session010AttachBody& body);
    void visit(const Session010AttachedBody& body);
    void visit(const Session010DetachBody& body);
    void visit(const Session010DetachedBody& body);
    void visit(const Session010RequestTimeoutBody& body);
    void visit(const Session010TimeoutBody& body);
    void visit(const Session010CommandPointBody& body);
    void visit(const Session010ExpectedBody& body);
    void visit(const Session010ConfirmedBody& body);
    void visit(const Session010CompletedBody& body);
    void visit(const Session010KnownCompletedBody& body);
    void visit(const Session010FlushBody& body);
    void visit(const Session010GapBody& body);
};

class AMQP_ServerOperations::Execution010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Execution010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Execution010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Execution010SyncBody& body);
    void visit(const Execution010ResultBody& body);
    void visit(const Execution010ExceptionBody& body);
};

class AMQP_ServerOperations::Message010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Message010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Message010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Message010TransferBody& body);
    void visit(const Message010AcceptBody& body);
    void visit(const Message010RejectBody& body);
    void visit(const Message010ReleaseBody& body);
    void visit(const Message010AcquireBody& body);
    void visit(const Message010SubscribeBody& body);
    void visit(const Message010CancelBody& body);
    void visit(const Message010SetFlowModeBody& body);
    void visit(const Message010FlowBody& body);
    void visit(const Message010FlushBody& body);
    void visit(const Message010StopBody& body);
};

class AMQP_ServerOperations::Tx010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Tx010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Tx010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Tx010SelectBody& body);
    void visit(const Tx010CommitBody& body);
    void visit(const Tx010RollbackBody& body);
};

class AMQP_ServerOperations::Dtx010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Dtx010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Dtx010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Dtx010SelectBody& body);
    void visit(const Dtx010StartBody& body);
    void visit(const Dtx010EndBody& body);
    void visit(const Dtx010CommitBody& body);
    void visit(const Dtx010ForgetBody& body);
    void visit(const Dtx010GetTimeoutBody& body);
    void visit(const Dtx010PrepareBody& body);
    void visit(const Dtx010RecoverBody& body);
    void visit(const Dtx010RollbackBody& body);
    void visit(const Dtx010SetTimeoutBody& body);
};

class AMQP_ServerOperations::Exchange010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Exchange010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Exchange010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Exchange010DeclareBody& body);
    void visit(const Exchange010DeleteBody& body);
    void visit(const Exchange010QueryBody& body);
    void visit(const Exchange010BindBody& body);
    void visit(const Exchange010UnbindBody& body);
    void visit(const Exchange010BoundBody& body);
};

class AMQP_ServerOperations::Queue010Handler::Invoker:
    public qpid::framing::Invoker
{
    AMQP_ServerOperations::Queue010Handler& target;
  public:
    Invoker(AMQP_ServerOperations::Queue010Handler& target_) : target(target_) {}
    using MethodBodyDefaultVisitor::visit;
    void visit(const Queue010DeclareBody& body);
    void visit(const Queue010DeleteBody& body);
    void visit(const Queue010PurgeBody& body);
    void visit(const Queue010QueryBody& body);
};

}} // namespace qpid::framing

#endif  /*!QPID_FRAMING_SERVERINVOKER_H*/
