#ifndef QPID_FRAMING_FRAME_BODY_LISTS_H
#define QPID_FRAMING_FRAME_BODY_LISTS_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


/**@file
 * Macro lists of frame body classes, used to generate Visitors
 */
#define METHOD_BODIES() \
    (ConnectionStartBody) \
    (ConnectionStartOkBody) \
    (ConnectionSecureBody) \
    (ConnectionSecureOkBody) \
    (ConnectionTuneBody) \
    (ConnectionTuneOkBody) \
    (ConnectionOpenBody) \
    (ConnectionOpenOkBody) \
    (ConnectionRedirectBody) \
    (ConnectionCloseBody) \
    (ConnectionCloseOkBody) \
    (SessionOpenBody) \
    (SessionAttachedBody) \
    (SessionFlowBody) \
    (SessionFlowOkBody) \
    (SessionCloseBody) \
    (SessionClosedBody) \
    (SessionResumeBody) \
    (SessionSuspendBody) \
    (SessionDetachedBody) \
    (SessionAckBody) \
    (SessionHighWaterMarkBody) \
    (SessionSolicitAckBody) \
    (AccessRequestBody) \
    (AccessRequestOkBody) \
    (ExchangeDeclareBody) \
    (ExchangeDeleteBody) \
    (ExchangeQueryBody) \
    (QueueDeclareBody) \
    (QueueBindBody) \
    (QueueUnbindBody) \
    (QueuePurgeBody) \
    (QueueDeleteBody) \
    (QueueQueryBody) \
    (BasicQosBody) \
    (BasicConsumeBody) \
    (BasicConsumeOkBody) \
    (BasicCancelBody) \
    (BasicPublishBody) \
    (BasicDeliverBody) \
    (BasicGetBody) \
    (BasicGetOkBody) \
    (BasicGetEmptyBody) \
    (BasicAckBody) \
    (BasicRejectBody) \
    (BasicRecoverBody) \
    (FileQosBody) \
    (FileQosOkBody) \
    (FileConsumeBody) \
    (FileConsumeOkBody) \
    (FileCancelBody) \
    (FileOpenBody) \
    (FileOpenOkBody) \
    (FileStageBody) \
    (FilePublishBody) \
    (FileReturnBody) \
    (FileDeliverBody) \
    (FileAckBody) \
    (FileRejectBody) \
    (StreamQosBody) \
    (StreamQosOkBody) \
    (StreamConsumeBody) \
    (StreamConsumeOkBody) \
    (StreamCancelBody) \
    (StreamPublishBody) \
    (StreamReturnBody) \
    (StreamDeliverBody) \
    (TxSelectBody) \
    (TxCommitBody) \
    (TxRollbackBody) \
    (DtxDemarcationSelectBody) \
    (DtxDemarcationStartBody) \
    (DtxDemarcationEndBody) \
    (DtxCoordinationCommitBody) \
    (DtxCoordinationForgetBody) \
    (DtxCoordinationGetTimeoutBody) \
    (DtxCoordinationPrepareBody) \
    (DtxCoordinationRecoverBody) \
    (DtxCoordinationRollbackBody) \
    (DtxCoordinationSetTimeoutBody) \
    (TunnelRequestBody) \
    (MessageTransferBody) \
    (MessageRejectBody) \
    (MessageAcquireBody) \
    (MessageAcquiredBody) \
    (MessageReleaseBody) \
    (MessageSubscribeBody) \
    (MessageCancelBody) \
    (MessageGetBody) \
    (MessageRecoverBody) \
    (MessageOpenBody) \
    (MessageCloseBody) \
    (MessageAppendBody) \
    (MessageCheckpointBody) \
    (MessageResumeBody) \
    (MessageQosBody) \
    (MessageFlowModeBody) \
    (MessageFlowBody) \
    (MessageFlushBody) \
    (MessageStopBody) \
    (MessageEmptyBody) \
    (MessageOffsetBody) \
    (BindingQueryBody) \
    (ExecutionFlushBody) \
    (ExecutionCompleteBody) \
    (ExecutionNoopBody) \
    (ExecutionResultBody) \
    (ExecutionSyncBody) \
    (Connection010StartBody) \
    (Connection010StartOkBody) \
    (Connection010SecureBody) \
    (Connection010SecureOkBody) \
    (Connection010TuneBody) \
    (Connection010TuneOkBody) \
    (Connection010OpenBody) \
    (Connection010OpenOkBody) \
    (Connection010RedirectBody) \
    (Connection010HeartbeatBody) \
    (Connection010CloseBody) \
    (Connection010CloseOkBody) \
    (Session010AttachBody) \
    (Session010AttachedBody) \
    (Session010DetachBody) \
    (Session010DetachedBody) \
    (Session010RequestTimeoutBody) \
    (Session010TimeoutBody) \
    (Session010CommandPointBody) \
    (Session010ExpectedBody) \
    (Session010ConfirmedBody) \
    (Session010CompletedBody) \
    (Session010KnownCompletedBody) \
    (Session010FlushBody) \
    (Session010GapBody) \
    (Execution010SyncBody) \
    (Execution010ResultBody) \
    (Execution010ExceptionBody) \
    (Message010TransferBody) \
    (Message010AcceptBody) \
    (Message010RejectBody) \
    (Message010ReleaseBody) \
    (Message010AcquireBody) \
    (Message010SubscribeBody) \
    (Message010CancelBody) \
    (Message010SetFlowModeBody) \
    (Message010FlowBody) \
    (Message010FlushBody) \
    (Message010StopBody) \
    (Tx010SelectBody) \
    (Tx010CommitBody) \
    (Tx010RollbackBody) \
    (Dtx010SelectBody) \
    (Dtx010StartBody) \
    (Dtx010EndBody) \
    (Dtx010CommitBody) \
    (Dtx010ForgetBody) \
    (Dtx010GetTimeoutBody) \
    (Dtx010PrepareBody) \
    (Dtx010RecoverBody) \
    (Dtx010RollbackBody) \
    (Dtx010SetTimeoutBody) \
    (Exchange010DeclareBody) \
    (Exchange010DeleteBody) \
    (Exchange010QueryBody) \
    (Exchange010BindBody) \
    (Exchange010UnbindBody) \
    (Exchange010BoundBody) \
    (Queue010DeclareBody) \
    (Queue010DeleteBody) \
    (Queue010PurgeBody) \
    (Queue010QueryBody) \
    (ClusterNotifyBody) 

#define OTHER_BODIES() (AMQContentBody)(AMQHeaderBody)(AMQHeartbeatBody))

#endif  /*!QPID_FRAMING_FRAME_BODY_LISTS_H*/
