#ifndef QPID_FRAMING_REPLY_EXCEPTIONS_H
#define QPID_FRAMING_REPLY_EXCEPTIONS_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/Exception.h"

namespace qpid {
namespace framing {


struct NotDeliveredException:
    ChannelException
{
    NotDeliveredException(const std::string& msg=std::string()) : ChannelException(310, "not-delivered: "+msg) {}
};

struct ContentTooLargeException:
    ChannelException
{
    ContentTooLargeException(const std::string& msg=std::string()) : ChannelException(311, "content-too-large: "+msg) {}
};

struct NoRouteException:
    ChannelException
{
    NoRouteException(const std::string& msg=std::string()) : ChannelException(312, "no-route: "+msg) {}
};

struct NoConsumersException:
    ChannelException
{
    NoConsumersException(const std::string& msg=std::string()) : ChannelException(313, "no-consumers: "+msg) {}
};

struct ConnectionForcedException:
    ConnectionException
{
    ConnectionForcedException(const std::string& msg=std::string()) : ConnectionException(320, "connection-forced: "+msg) {}
};

struct InvalidPathException:
    ConnectionException
{
    InvalidPathException(const std::string& msg=std::string()) : ConnectionException(402, "invalid-path: "+msg) {}
};

struct AccessRefusedException:
    ChannelException
{
    AccessRefusedException(const std::string& msg=std::string()) : ChannelException(403, "access-refused: "+msg) {}
};

struct NotFoundException:
    ChannelException
{
    NotFoundException(const std::string& msg=std::string()) : ChannelException(404, "not-found: "+msg) {}
};

struct ResourceLockedException:
    ChannelException
{
    ResourceLockedException(const std::string& msg=std::string()) : ChannelException(405, "resource-locked: "+msg) {}
};

struct PreconditionFailedException:
    ChannelException
{
    PreconditionFailedException(const std::string& msg=std::string()) : ChannelException(406, "precondition-failed: "+msg) {}
};

struct SessionBusyException:
    ChannelException
{
    SessionBusyException(const std::string& msg=std::string()) : ChannelException(407, "session-busy: "+msg) {}
};

struct FrameErrorException:
    ConnectionException
{
    FrameErrorException(const std::string& msg=std::string()) : ConnectionException(501, "frame-error: "+msg) {}
};

struct SyntaxErrorException:
    ConnectionException
{
    SyntaxErrorException(const std::string& msg=std::string()) : ConnectionException(502, "syntax-error: "+msg) {}
};

struct CommandInvalidException:
    ConnectionException
{
    CommandInvalidException(const std::string& msg=std::string()) : ConnectionException(503, "command-invalid: "+msg) {}
};

struct ChannelErrorException:
    ConnectionException
{
    ChannelErrorException(const std::string& msg=std::string()) : ConnectionException(504, "channel-error: "+msg) {}
};

struct ResourceErrorException:
    ConnectionException
{
    ResourceErrorException(const std::string& msg=std::string()) : ConnectionException(506, "resource-error: "+msg) {}
};

struct NotAllowedException:
    ConnectionException
{
    NotAllowedException(const std::string& msg=std::string()) : ConnectionException(530, "not-allowed: "+msg) {}
};

struct NotImplementedException:
    ConnectionException
{
    NotImplementedException(const std::string& msg=std::string()) : ConnectionException(540, "not-implemented: "+msg) {}
};

struct InternalErrorException:
    ConnectionException
{
    InternalErrorException(const std::string& msg=std::string()) : ConnectionException(541, "internal-error: "+msg) {}
};

struct InvalidArgumentException:
    ConnectionException
{
    InvalidArgumentException(const std::string& msg=std::string()) : ConnectionException(542, "invalid-argument: "+msg) {}
};

struct ChannelBusyException:
    ConnectionException
{
    ChannelBusyException(const std::string& msg=std::string()) : ConnectionException(543, "channel-busy: "+msg) {}
};

void throwReplyException(int code, const std::string& text);

}} // namespace qpid::framing

#endif  /*!QPID_FRAMING_REPLY_EXCEPTIONS_H*/
