
#ifndef _MANAGEMENT_LINK_
#define _MANAGEMENT_LINK_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
namespace management {

class Link : public ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];

    // Configuration Elements
    uint64_t vhostRef;
    std::string address;
    std::string authIdentity;

    // Instrumentation Elements
    uint8_t  closing;
    uint64_t  framesFromPeer;
    uint64_t  framesToPeer;
    uint64_t  bytesFromPeer;
    uint64_t  bytesToPeer;

    // Private Methods
    static void writeSchema   (qpid::framing::Buffer& buf);
    void writeConfig          (qpid::framing::Buffer& buf);
    void writeInstrumentation (qpid::framing::Buffer& buf,
                               bool skipHeaders = false);
    void doMethod             (std::string            methodName,
                               qpid::framing::Buffer& inBuf,
                               qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall (void) { return writeSchema; }


  public:

    friend class PackageQpid;
    typedef boost::shared_ptr<Link> shared_ptr;

    Link (Manageable* coreObject, Manageable* _parent, std::string _address);
    ~Link (void);

    std::string getPackageName (void) { return packageName; }
    std::string getClassName   (void) { return className; }
    uint8_t*    getMd5Sum      (void) { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_CLOSE = 1;
    static const uint32_t METHOD_BRIDGE = 2;

    // Accessor Methods
    inline void set_authIdentity (std::string val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        authIdentity = val;
        configChanged = true;
    }
    inline void set_closing (uint8_t val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        closing = val;
        instChanged = true;
    }
    inline void inc_framesFromPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        framesFromPeer += by;
        instChanged = true;
    }
    inline void dec_framesFromPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        framesFromPeer -= by;
        instChanged = true;
    }
    inline void inc_framesToPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        framesToPeer += by;
        instChanged = true;
    }
    inline void dec_framesToPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        framesToPeer -= by;
        instChanged = true;
    }
    inline void inc_bytesFromPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        bytesFromPeer += by;
        instChanged = true;
    }
    inline void dec_bytesFromPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        bytesFromPeer -= by;
        instChanged = true;
    }
    inline void inc_bytesToPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        bytesToPeer += by;
        instChanged = true;
    }
    inline void dec_bytesToPeer (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        bytesToPeer -= by;
        instChanged = true;
    }

};

}}
            

#endif  /*!_MANAGEMENT_LINK_*/
